Option Explicit
DefInt A-Z

' accusoft vbx specific : in fact, an index we'll use for control function call in doEffect()

Global Const EFFECTNONE% = 0
Global Const EFFECTGRAY% = 1
Global Const EFFECTBAYERMONO% = 2
Global Const EFFECTBAYERCOLOR% = 3
Global Const EFFECTDIFFUSIONMONO% = 4
Global Const EFFECTDIFFUSIONCOLOR% = 5
Global Const EFFECTHALFTONEMONO% = 6
Global Const EFFECTPOPULARITY% = 7
Global Const EFFECTMEDIAN% = 8
Global Const EFFECTLAPLACIAN% = 9
Global Const EFFECTDIALATION% = 10 ' not very useful
Global Const EFFECTBPP8% = 11
Global Const EFFECTBPP4% = 12
Global Const EFFECTBPP1% = 13
Global Const EFFECTINVERSE% = 14

' vindoze 3.1 related constants

Global Const sSectionDesktop$ = "Desktop"
Global Const eWallPaper$ = "Wallpaper"

' app ini settings

Global Const eDirectory$ = "Directory"
Global Const eIncludeHidden$ = "IncludeHidden"
Global Const eIncludeGIF$ = "IncludeGIF"
Global Const eIncludeJPG$ = "IncludeJPG"
Global Const eIncludeBMP$ = "IncludeBMP"
Global Const eIncludePCX$ = "IncludePCX"
Global Const eIncludeTGA$ = "IncludeTGA"

Global Const eSortedFileNames$ = "SortedFileNames"
Global Const ePickAtRandom$ = "PickAtRandom"

' we'll resize any picture outsize target-substracted..target+added
Global Const eTargetSize$ = "TargetSize" ' units = percentage of screen
Global Const eAddedMargin$ = "AddedMargin" ' for pictures bigger than target
Global Const eSubstractedMargin$ = "SubstractedMargin" ' for pictures smaller than target
Global Const eSkipOutOfRange$ = "SkipOutOfRange"

Global Const eColorReduction$ = "ColorReduction" ' index in combo list
Global Const eColorReductionCode$ = "ColorReductionCode"
Global Const eDither$ = "Dither"
Global Const eDitherCode$ = "DitherCode"

Global Const eChangeGammaGIF$ = "ChangeGammaGIF"
Global Const eChangeGammaJPG$ = "ChangeGammaJPG"
Global Const eChangeGammaTGA$ = "ChangeGammaTGA"
Global Const eChangeGammaBMP$ = "ChangeGammaBMP"
Global Const eChangeGammaPCX$ = "ChangeGammaPCX"

Global Const eGammaGIF$ = "GammaGIF"
Global Const eGammaJPG$ = "GammaJPG"
Global Const eGammaBMP$ = "GammaBMP"
Global Const eGammaPCX$ = "GammaPCX"
Global Const eGammaTGA$ = "GammaTGA"

Global Const eAutoPreview$ = "AutoPreview"

Global Const eKillTmpBMP$ = "KillTmpBMP"
Global Const eWriteBMPpath$ = "WriteBMPpath"
Global Const ePersistence$ = "Persistence" ' in minutes
Global Const eUseDDB$ = "UseDDB"
Global Const ePollInterval$ = "PollInterval"' in seconds
Global Const eXtsr$ = "Xtsr"
Global Const eYtsr$ = "Ytsr"
'Global Const eX2tsr$ = "X2tsr" ' for rectangle restoration with setwindowplacement
'Global Const eY2tsr$ = "Y2tsr"
Global Const eXtsrIcon$ = "XtsrIcon"
Global Const eYtsrIcon$ = "YtsrIcon"

Global Const eLastIndex$ = "LastIndex"
Global Const eLastFileName$ = "LastFileName"
Global Const eLastUnsupported$ = "LastUnsupported"
Global Const eLastPicInfos$ = "LastPicInfos"
Global Const eLastErrorCode$ = "LastErrorCode"

Global Const eListBoxLimitKB$ = "ListBoxLimitKB"
Global Const eListBoxFix$ = "ListBoxFix"

' list and indexes

Global Const lY$ = "Y"
Global Const lN$ = "N"

' defaults (strings)

'Global Const dDirectory$="" ' will be exedir$
Global Const dIncludeHidden% = True
Global Const dIncludeGIF% = True
Global Const dIncludeJPG% = True
Global Const dIncludeBMP% = False
Global Const dIncludePCX% = False
Global Const dIncludeTGA% = False

Global Const dSortedFileNames% = False
Global Const dPickAtRandom% = False

Global Const dTargetSize% = 100
Global Const dAddedMargin% = 0
Global Const dSubstractedMargin% = 10
Global Const dSkipOutOfRange% = False

Global Const dColorReduction% = 0 ' is Original colors index in combo box
Global Const dColorReductionCode% = EFFECTNONE%
Global Const dDither% = 0 ' is No dithering index in combo box
Global Const dDitherCode% = AC_DITHERNONE

Global Const dChangeGammaGIF% = False
Global Const dChangeGammaJPG% = False
Global Const dChangeGammaTGA% = False
Global Const dChangeGammaBMP% = False
Global Const dChangeGammaPCX% = False

' 150 is default gamma value for Accusoft VBX, i.e. 1,5
' unfortunately, this crap uses it for display only and won't save it
' so gamma will be in fact brightness

Global Const dGammaGIF% = 0
Global Const dGammaJPG% = 0
Global Const dGammaBMP% = 0
Global Const dGammaPCX% = 0
Global Const dGammaTGA% = 0

Global Const dAutoPreview% = False

Global Const dKillTmpBMP% = True
Global Const dWriteBMPpath% = False
Global Const dPersistence% = 10 ' minutes
Global Const dUseDDB% = True
Global Const dPollInterval% = 1 ' seconds, original 15 was a no-no !
Global Const dXtsr% = 0
Global Const dYtsr% = 0
'Global Const dX2tsr% = 0 ' hem...
'Global Const dY2tsr% = 0
Global Const dXtsrIcon% = 0
Global Const dYtsrIcon% = 0

Global Const ndxFIRSTPIC% = 0 'must be defined here
Global Const dLastIndex% = ndxFIRSTPIC%
'Global Const dLastFileName$=""

Global Const dListBoxLimitKB% = 64 ' in Kb
Global Const dListBoxFix% = True

' global settings

Global gDirectory$
Global gIncludeHidden%
Global gIncludeGIF%
Global gIncludeJPG%
Global gIncludeBMP%
Global gIncludePCX%
Global gIncludeTGA%

Global gSortedFileNames%
Global gPickAtRandom%

Global gTargetSize%
Global gAddedMargin%
Global gSubstractedMargin%
Global gSkipOutOfRange%

Global gColorReduction%
Global gColorReductionCode%
Global gDither%
Global gDitherCode%

Global gChangeGammaGIF%
Global gChangeGammaJPG%
Global gChangeGammaTGA%
Global gChangeGammaBMP%
Global gChangeGammaPCX%

Global gGammaGIF%
Global gGammaJPG%
Global gGammaBMP%
Global gGammaPCX%
Global gGammaTGA%

Global gAutoPreview%

Global gKillTmpBMP%
Global gWriteBMPpath%
Global gPersistence%
Global gUseDDB%

Global gPollInterval% ' seconds
Global gRealPollInterval& ' milliseconds
Global MULTIPLICATOR%
Global TIMEINTERVAL%

Global gXtsr%
Global gYtsr%
'Global gX2tsr%
'Global gY2tsr%
Global gXtsrIcon%
Global gYtsrIcon%

Global gLastIndex%
Global gLastFileName$ ' remember it was stored with " (WIxHExBPP)" suffix !
Global gLastUnsupported$
Global gLastPicInfos$
Global gLastErrorCode$

Global gLastLoadErrorCode% ' last picdir preview for pickdir setwallpaper

Global gListBoxLimitKB%
Global gListBoxFix%

' app constants

Global Const Title$ = "AutoWall v0.9"
Global Const splashTitle$ = "Q&&D AutoWall v0.9" ' silly VB !

Global Const picprocessing$ = "Picture processing" ' for setup.framepictureprocessing caption
Global Const thisVBX$ = "Accusoft 5.0.1" ' the same

Global Const culprit$ = "by PhG"
Global Const sSection$ = "AutoWall"

Global Const splashInfo$ = "This program DOES require Micro$oft Vindoze... :-("

Global Const TSRcaption$ = "TSR"

Global Const tmpBMP$ = "~del_me~.bmp" ' or autoview.bmp ? RLE useless !

Global Const envTMP$ = "TMP"
Global Const envTEMP$ = "TEMP"

Global Const NOLASTWALL$ = "Last picture is undefined"
Global Const LASTWALL$ = "Last : "
Global Const NOLASTINDEX$ = "Last index is undefined"
Global Const LASTINDEX$ = ", index was " ' "(w*h*bpp, index was #)"
Global Const NOLASTUNSUPPORTED$ = "Last unsupported picture is undefined"
Global Const LASTUNSUPPORTED$ = "Last error : "
' we removed useless LAST ERROR code : lasting terror, eh eh ;-)

' global vars (easier with vb piece of crap, and saves typing too !)

Global f As form ' setup
Global ff As form
Global fff As form ' pickdir

Global windir$
Global sysdir$

Global exedir$ ' avoid repeated getexepath$()
Global ini$

' misc

'Global Const ndxFIRSTPIC% = 0 'must be defined earlier
Global Const STARdotSTAR$ = "*.*"
Global Const MatchAllFilesWithoutHidden% = ATTR_NORMAL Or ATTR_READONLY Or ATTR_ARCHIVE
Global Const MatchAllFilesWithHidden% = ATTR_NORMAL Or ATTR_READONLY Or ATTR_HIDDEN Or ATTR_ARCHIVE

' extensions MUST be in upper case

Global Const RPText$ = ".RPT"
Global Const LSText$ = ".LST"
Global Const INIext$ = ".INI"

Global Const GIFext$ = ".GIF"
Global Const JPGext$ = ".JPG"
Global Const BMPext$ = ".BMP"
Global Const PCXext$ = ".PCX"
Global Const TGAext$ = ".TGA"

Global Const MINPERSISTENCE% = 1 ' in minutes
Global Const MAXPERSISTENCE% = 60 ' one hour is enough !
Global Const SMALLCHANGEPERSISTENCE% = 1
Global Const LARGECHANGEPERSISTENCE% = 10

Global Const MINPOLLINTERVAL% = 1 ' in seconds
Global Const MAXPOLLINTERVAL% = 60 ' one minute is enough !
Global Const SMALLCHANGEPOLLINTERVAL% = 1
Global Const LARGECHANGEPOLLINTERVAL% = 5

Global Const MINTARGETSIZE% = 20 ' is also absolute lower limit
Global Const MAXTARGETSIZE% = 120
Global Const SMALLCHANGETARGETSIZE% = 1
Global Const LARGECHANGETARGETSIZE% = 10
Global Const MINMARGIN% = 0
Global Const MAXMARGIN% = 100
Global Const SMALLCHANGEMARGIN% = 1
Global Const LARGECHANGEMARGIN% = 10

' for warnings
Global Const QB_LIGHTRED = 12
Global Const QB_WHITE = 15

' imageman was 1.0 to 3.0 (*100), now it's 0,1 to 10,0
' darn, we have to use brightness instead of gamma !
'Global Const MINGAMMA% = 10 ' start at 0,1
'Global Const MAXGAMMA% = 1000 ' 20000 is possible but is just washed out
' imageman was 1, 10
'Global Const SMALLCHANGEGAMMA% = 10
'Global Const LARGECHANGEGAMMA% = 100

Global Const MINGAMMA% = -127
Global Const MAXGAMMA% = 127
Global Const SMALLCHANGEGAMMA% = 1
Global Const LARGECHANGEGAMMA% = 10

' all times in milliseconds
Global Const ONESECOND& = 1000&
Global Const ONEMINUTE& = 60& * ONESECOND ' long required because > 32767
'is now useless
'Global Const FIFTEENSECONDS = 15& * ONESECOND
'both are now globerks
'Global Const MULTIPLICATOR = 60 \ 15 ' well : 60 seconds, 15 seconds interval
'Global Const TIMEINTERVAL = 15 ' update display every 15 seconds

' screen dimensions

Global XscreenInPixels%
Global YscreenInPixels%

' for frmPickDIR

Global gNewdir$

' for autowall

Global gUseTimer% ' "automagic change" mode while in TSR mode
Global gCountdown%

' for debug

Global DEBUGLOG% ' for logging of some events while creating code
Global hndLog% ' yes, virginia, could be in vb_log... but it's vb after all ! :-)

Global Const frozen% = True ' true=final production ! for experimental code

Global Const secondsPerMinute& = 60&
Global Const secondsPerHour& = 60& * secondsPerMinute&
Global Const secondsPerDay& = 24& * secondsPerHour&
' for initial delay 1..120 seconds
Global Const minDELAY& = 1&
Global Const maxDELAY& = 2& * secondsPerMinute& ' more than enough !

Sub retrieveParameters ()
Dim s$
Dim flag%
Dim i%

' directory and masks

s$ = readIni$(ini$, sSection$, eDirectory$)
If s$ = "" Then
    s$ = exedir$ ' default directory always exists
Else
    If Right$(s$, 1) <> "\" Then s$ = s$ + "\"
    If direxists%(s$) = False Then s$ = exedir$
End If
If Right$(s$, 1) <> "\" Then s$ = s$ + "\"
gDirectory$ = LCase$(s$)

s$ = readIni$(ini$, sSection$, eIncludeHidden$)
gIncludeHidden% = getBool(s$, dIncludeHidden%)
s$ = readIni$(ini$, sSection$, eIncludeGIF$)
gIncludeGIF% = getBool(s$, dIncludeGIF%)
s$ = readIni$(ini$, sSection$, eIncludeJPG$)
gIncludeJPG% = getBool(s$, dIncludeJPG%)
s$ = readIni$(ini$, sSection$, eIncludeBMP$)
gIncludeBMP% = getBool(s$, dIncludeBMP%)
s$ = readIni$(ini$, sSection$, eIncludePCX$)
gIncludePCX% = getBool(s$, dIncludePCX%)
s$ = readIni$(ini$, sSection$, eIncludeTGA$)
gIncludeTGA% = getBool(s$, dIncludeTGA%)

' misc

s$ = readIni$(ini$, sSection$, eSortedFileNames$)
gSortedFileNames% = getBool(s$, dSortedFileNames%)
s$ = readIni$(ini$, sSection$, ePickAtRandom$)
gPickAtRandom% = getBool(s$, dPickAtRandom%)

s$ = readIni$(ini$, sSection$, eTargetSize$)
gTargetSize% = getInt(s$, dTargetSize%)
s$ = readIni$(ini$, sSection$, eAddedMargin$)
gAddedMargin% = getInt(s$, dAddedMargin%)
s$ = readIni$(ini$, sSection$, eSubstractedMargin$)
gSubstractedMargin% = getInt(s$, dSubstractedMargin%)
s$ = readIni$(ini$, sSection$, eSkipOutOfRange$)
gSkipOutOfRange% = getBool(s$, dSkipOutOfRange%)

s$ = readIni$(ini$, sSection$, eColorReduction$)
gColorReduction% = getInt(s$, dColorReduction%)
s$ = readIni$(ini$, sSection$, eColorReductionCode$)
gColorReductionCode% = getInt(s$, dColorReductionCode%)
s$ = readIni$(ini$, sSection$, eDither$)
gDither% = getInt(s$, dDither%)
s$ = readIni$(ini$, sSection$, eDitherCode$)
gDitherCode% = getInt(s$, dDitherCode%)

s$ = readIni$(ini$, sSection$, eChangeGammaGIF$)
gChangeGammaGIF% = getBool(s$, dChangeGammaGIF%)
s$ = readIni$(ini$, sSection$, eChangeGammaJPG$)
gChangeGammaJPG% = getBool(s$, dChangeGammaJPG%)
s$ = readIni$(ini$, sSection$, eChangeGammaTGA$)
gChangeGammaTGA% = getBool(s$, dChangeGammaTGA%)
s$ = readIni$(ini$, sSection$, eChangeGammaBMP$)
gChangeGammaBMP% = getBool(s$, dChangeGammaBMP%)
s$ = readIni$(ini$, sSection$, eChangeGammaPCX$)
gChangeGammaPCX% = getBool(s$, dChangeGammaPCX%)

s$ = readIni$(ini$, sSection$, eGammaGIF$)
gGammaGIF% = getInt(s$, dGammaGIF%)
s$ = readIni$(ini$, sSection$, eGammaJPG$)
gGammaJPG% = getInt(s$, dGammaJPG%)
s$ = readIni$(ini$, sSection$, eGammaBMP$)
gGammaBMP% = getInt(s$, dGammaBMP%)
s$ = readIni$(ini$, sSection$, eGammaPCX$)
gGammaPCX% = getInt(s$, dGammaPCX%)
s$ = readIni$(ini$, sSection$, eGammaTGA$)
gGammaTGA% = getInt(s$, dGammaTGA%)

s$ = readIni$(ini$, sSection$, eAutoPreview$)
gAutoPreview% = getBool(s$, dAutoPreview%)

s$ = readIni$(ini$, sSection$, eKillTmpBMP$)
gKillTmpBMP% = getBool(s$, dKillTmpBMP%)
s$ = readIni$(ini$, sSection$, eWriteBMPpath$)
gWriteBMPpath% = getBool(s$, dWriteBMPpath%)

s$ = readIni$(ini$, sSection$, ePersistence$)
gPersistence% = getInt(s$, dPersistence%)

s$ = readIni$(ini$, sSection$, eUseDDB$)
gUseDDB% = getBool(s$, dUseDDB%)

s$ = readIni$(ini$, sSection$, ePollInterval$)
gPollInterval% = getInt(s$, dPollInterval%)

's$ = readIni$(ini$, sSection$, eXtsr$)
'gXtsr% = getInt(s$, dXtsr%)
's$ = readIni$(ini$, sSection$, eYtsr$)
'gYtsr% = getInt(s$, dYtsr%)

s$ = readIni$(ini$, sSection$, eLastIndex$)
gLastIndex% = getInt(s$, dLastIndex%)

s$ = readIni$(ini$, sSection$, eLastFileName$)
'If s$ = "" Then s$ = "<none>"
gLastFileName$ = LCase$(s$)

s$ = readIni$(ini$, sSection$, eLastUnsupported$)
gLastUnsupported$ = LCase$(s$)

s$ = readIni$(ini$, sSection$, eLastPicInfos$)
gLastPicInfos$ = LCase$(s$)
s$ = readIni$(ini$, sSection$, eLastErrorCode$)
gLastErrorCode$ = LCase$(s$)

s$ = readIni$(ini$, sSection$, eListBoxLimitKB$)
gListBoxLimitKB% = getInt(s$, dListBoxLimitKB%)
s$ = readIni$(ini$, sSection$, eListBoxFix$)
gListBoxFix% = getBool(s$, dListBoxFix%)
End Sub
