' a real program to test accusoft vbx !

Option Explicit
DefInt A-Z

Sub doDelay (ByVal v As Long, ByVal nunc As String)
Dim h, m, S As Long' 24*60*60
Dim oldhms&, currhms&, delta&' if we define it as long, we get an overflow !!!
' yes, yes, there are more clever ways to force waiting
h = Hour(nunc$)
m = Minute(nunc$)
S = Second(nunc$)
oldhms& = (h * secondsPerHour&)
oldhms& = oldhms + (m * secondsPerMinute&)
oldhms& = oldhms + S
'MsgBox "// oldhms : " + Str$(oldhms)
Do
    nunc$ = Time$
    h = Hour(nunc$)
    m = Minute(nunc$)
    S = Second(nunc$)
    currhms& = (h * secondsPerHour&)
    currhms& = currhms + (m * secondsPerMinute&)
    currhms& = currhms + S
    If oldhms <= currhms Then ' 86350 86357 note <= is required for 0 second delta to be processed
        delta = currhms - oldhms
    Else  ' 86395 7
        delta = currhms + (secondsPerDay& - oldhms)
    End If
    delta = Abs(delta)' better safe than sorry
    'MsgBox "// old curr delta v = " + Str$(oldhms) + Str$(currhms) + Str$(delta) + Str$(v)
    If delta >= v Then Exit Do
    DoEvents
    'MsgBox "// " + nunc$ + " = " + Str$(currhms) + " => " + Str$(delta)
Loop
End Sub

Sub Main ()
Dim cli$, newcli$, value$
Dim rc%, flag%
Dim i%
Dim S$
Dim Splash%
Dim v&

If isRunning%() Then End
' If is3X%() = False Then End

' maybe later check for correct installation of IMVB5 libraries (extensioncount, etc.)

getDirectories windir$, sysdir$
exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$

XscreenInPixels% = screen.Width \ screen.TwipsPerPixelX
YscreenInPixels% = screen.Height \ screen.TwipsPerPixelY

cli$ = Trim$(Command$)
cli$ = UCase$(cli$)

Splash% = True
DEBUGLOG% = False
value$ = ""

If argc%(cli$) <> 0 Then
    newcli$ = ""
    For i% = 1 To argc%(cli$)
        S$ = argv$(cli$, i%)
        Select Case S$
        Case "/DEBUG", "-DEBUG"
            DEBUGLOG% = True
        Case "/QUIET", "-QUIET"
            Splash% = False
        Case "/Q", "-Q"
            Splash% = False
        Case "/DELAY", "-DELAY", "/PAUSE", "-PAUSE", "/WAIT", "-WAIT"
            value$ = argv$(cli$, i% + 1)
        Case "/D", "-D", "/P", "-P", "/W", "-W"
            value$ = argv$(cli$, i% + 1)
        Case Else
            If S$ = value$ Then ' what if /W is followed by a command ?
                Select Case Left$(S$, 1)
                Case "/", "-"
                    newcli$ = " " + S$
                    value$ = ""
                Case Else
                    ' ignore value following /W
                End Select
            Else
                newcli$ = " " + S$
            End If
        End Select
    Next
    cli$ = Trim$(newcli$)' just in case
End If


: : : logInit' now we have DEBUGLOG% set according to command line

If value$ <> "" Then
    v& = Val(value$)
    Select Case v&
    Case minDELAY& To maxDELAY&
        doDelay v&, Time$
    Case Else
        ' ignore
    End Select
End If

'MsgBox "// cli : " + cli$
Select Case cli$
Case "/C", "-C", "/CFG", "-CFG", "/CONFIG", "-CONFIG", "/SETUP", "-SETUP", ""
    doSetupMain
Case "/N", "-N", "/NEW", "-NEW"
    doNewWallMain Splash%
Case "/R", "-R", "/TSR", "-TSR"
    doTSRnewWallMain Splash%, False
Case "/A", "-A", "/AUTO", "-AUTO"
    doTSRnewWallMain Splash%, True
Case "/?", "-?", "/H", "-H", "/HELP", "-HELP"
    doHelpMain
Case Else
    doHelpMain 'End
End Select
End Sub

Sub quit ()
Dim rc%, flag%
While forms.Count > 0
    Unload forms(0)
Wend
: : : logClose
End
End Sub