(* --------------------------------------------------------------
Title         Spirolatres
Overview      tsk tsk...
Usage         see help
Notes         Le dictionnaire Penguin des curiosits gomtriques, page 234
              si le programme correspond  la description, les figures
              avec des angles autres que 90 sont impossibles  obtenir !
              avec quelques amnagements irrationnels, en revanche,
              les rsultats sont conformes aux dessins ! incomprhensible...
              using LONGREAL instead of INTEGER for coordinates accounts
              for a much better display, avoiding rounding errors
              (+0.5 in fGrLine caller is required for rounding : f2i() function)
              ah, floor() and ceil()...

              glad Borland BGI uses a small 8x8 font in graphic modes !

              for the sake of modernity, QD_HIRES was patched :
              ONLYBGI256 flag forces use of SVGA256F driver only (forcing many problems, too)

              check project and end of this source
              for now, USEBGI=true and ONLYBGI256=false

              qd_dump and qd_hires are to be found in astropg.arj

Bugs          are too many globerks a conceptual bug ? ;-)
Wish List     tsk tsk...

--------------------------------------------------------------- *)

MODULE Spiro;

IMPORT Str;
IMPORT Lib;
IMPORT MATHLIB;
IMPORT FIO;
IMPORT BiosIO;

FROM IO IMPORT WrStr,WrLn,WrCard;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim, str16,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
cleantabs;

FROM QD_rand IMPORT InitRnd, GetRnd,
GetRndCardRange, GetRndLngCardRange,
GetRndLngRealRange, GetRndRealRange;

FROM QD_Dump IMPORT extPIC, buildpicname, savescreen;

FROM QD_Hires IMPORT WaitVGAretrace, palval,
pset, HiresOn, TextOn, GrLine, GrCircle,
GrClearScreen, GrSetLinestyle, GrWrapon, GrPoint,
GrSetBkColor, GrOutText, GrSetTextColor, GrSetTextPosition, textcoords,
VGAhere, getmaxhtab, getmaxvtab,
xmax,ymax,xmin,ymin,cx,cy,
cPALEWHITE, cPALEBLUE, cPALEGREEN, cPALECYAN, cPALERED, cPALEMAGENTA,
cBROWN, cGRAY, cBLACK, cBLUE, cGREEN, cCYAN, cRED, cMAGENTA,
cYELLOW, cWHITE, cMYBLACK,
firstInk, lastInk, inkToRGB, FixPalette, palette16, pal16,
restype, initHGR, charheight;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    PAPEROK = TRUE;
CONST
    ProgEXEname   = "SPIRO";
    exeblank      = "     ";
    ProgTitle     = "Q&D Spirolatres";
    ProgVersion   = "v1.1e";
    ProgCopyright = "par PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    extLOG        = ".LOG";
    datafile      = ProgEXEname+extLOG;
    sMaxcount     = "500"; (* see infra : maxcount *)
CONST
    cr         = CHR(13);
    lf         = CHR(10);
    nl         = cr+lf;
    ctrlN      = CHR(14);
    ESC        = CHR(27);
    dquote     = '"';
CONST
    errNone      = 0;
    errHelp      = 1;
    errOpt       = 2;
    errOverflow  = 3;
    errVGA       = 4;
    errCannotSet = 5;
    errRange     = 6;
    errMissing   = 7;
    errFullHelp  = 8;

PROCEDURE mak2 (VAR R : ARRAY OF CHAR;S1,S2:ARRAY OF CHAR);
BEGIN
    Str.Concat(R,S1,S2);
END mak2;

PROCEDURE mak3 (VAR R : ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
BEGIN
    Str.Concat(R,S1,S2); Str.Append(R,S3);
END mak3;

CONST
    helpF1intro = nl+
"Voici les fonctions disponibles pendant l'affichage d'un motif :"+nl+
nl;

    helpF1=
"Touche(s)       Fonction"+nl+
nl+
"[F1|?|,|F12]    afficher l'aide (vous y tes !) ou quelques exemples"+nl+
"[F2|!]          afficher les valeurs actuelles (bascule)"+nl+
"[Ctrl-Q|Echap]  sortir du programme (Maj obligatoire, par scurit)"+nl+
nl+
"[+|$]           augmenter de 1 le nombre de rptitions (de 10 avec Maj)"+nl+
"[-|*]           diminuer de 1 le nombre de rptitions (de 10 avec Maj)"+nl+
"[Ctrl-+|Alt-I]  mettre au minimum le nombre de rptitions"+nl+
"[Ctrl--|Alt-A]  mettre au maximum le nombre de rptitions"+nl+
nl+
"[Page Haut]     augmenter de 1 l'angle de rotation (de 10 avec Maj)"+nl+
"[Page Bas]      diminuer de 1 l'angle de rotation (de 10 avec Maj)"+nl+
nl+
"[Entre]        entrer de nouveaux paramtres"+nl+
"                [Droite|Gauche|Fin|Dbut]-dplacer, [Entre]-valider,"+nl+
"                [Echap]-annuler, [Ctrl-X]-mettre  zro, [Del|Suppr]-effacer"+nl+
"                Les paramtres hors de l'intervalle autoris seront ignors."+nl+
nl+
"[Dbut]         augmenter de 1 l'chelle (de 10 avec Maj)"+nl+
"[Fin]           diminuer de 1 l'chelle (de 10 avec Maj)"+nl+
nl+
"[a|A]           choisir l'algorithme original ou corrig (bascule)"+nl+
nl+
"[Haut]          diminuer de 10 la coordonne de dpart en Y (de 1 avec Maj)"+nl+
"[Bas]           augmenter de 10 la coordonne de dpart en Y (de 1 avec Maj)"+nl+
"[Gauche]        diminuer de 10 la coordonne de dpart en X (de 1 avec Maj)"+nl+
"[Droite]        augmenter de 10 la coordonne de dpart en X (de 1 avec Maj)"+nl+
nl+
"[c|C]           centrer le motif"+nl+
"[o|O]           centrer automatiquement le motif (bascule)"+nl+
"[Ctrl-N]        crer alatoirement un nouveau motif"+nl+
"[Ctrl-D]        mode dmonstration automatique"+nl+
"                (pour arrter, appuyer sur [Echap])"+nl+
"[t|T]           afficher toutes les rotations possibles de +0  +360"+nl+
"                (pour arrter, appuyer sur [Echap])"+nl+
"[F3|F4]         changer le dlai d'affichage (de 10 avec Maj)"+nl+
"[r|R|Espace]    redessiner le motif tape par tape"+nl+
"                (pour finir le motif, appuyer sur [Echap])"+nl+
nl+
"[F5|F6]         changer la couleur du texte"+nl+
"[F7|F8]         changer la couleur de l'encre"+nl+
(*%T PAPEROK  *)
"[F9|F10]        changer la couleur du papier"+nl+
(*%E  *)
nl+
"[Ctrl-S]        sauvegarder l'cran en noir et blanc"+nl+
"                (attendre la fin des signaux sonores)"+nl+
"[Ctrl-V]        sauvegarder l'cran en couleurs"+nl+
"                (attendre la fin des signaux sonores)"+nl;
(*
nl+
"[Ctrl-R]        rtablir les valeurs de dmarrage"+nl;
*)

    helpF12 = (* same as text help screen *)
"Voici quelques exemples  visualiser :"+nl+
nl+
"Rptitions  Rotation  Paramtres"+nl+
nl+
"4            90        1 3 2 -1 -2"+nl+
"4            60        1 3 2 -1 -2"+nl+
"4            90        1 2 3"+nl+
"4            90        1 2 3 4 5 6 7 8 9"+nl+
"5            72        2 3 4 5"+nl+
"5            108       1 2 3 4"+nl+
"5            36        2 -2 1"+nl;

     helpwait = nl+
"Appuyez sur (presque) n'importe quelle touche pour revenir au programme . . ."+nl;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    repdefault          = "*";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntaxe : "+ProgEXEname+" [<rptitions|"+repdefault+"> <rotation> <dplacement>...] [option]..."+nl+
nl+
"  -v[v[v]]  mode vido (v=640x480, vv=800x600, vvv=1024x768)"+nl+
"  -e:#      chelle [1..500] (par dfaut : 15)"+nl+
"  -a        algorithme original (par dfaut : algorithme corrig)"+nl+
"  -o        centrage automatique du motif dsactiv (par dfaut : activ)"+nl+
"  -n        nouveau motif alatoire"+nl+
"  -t:#      couleur du texte [0..15] (par dfaut : 14)"+nl+
"  -c:#      couleur de l'encre [0..15] (par dfaut : 15)"+nl+
(*%T PAPEROK  *)
"  -p:#      couleur du papier [0..15] (par dfaut : 0)"+nl+
(*%E  *)
"  -d:#      dlai d'affichage de chaque rotation [0..100] (par dfaut : 10)"+nl+
"  -d        mode dmonstration automatique"+nl+
"  -??       aide complte"+nl+
nl+
"a) Le nombre de rptitions est fix  "+sMaxcount+" s'il est spcifi avec "+dquote+repdefault+dquote+"."+nl+
"b) Les fichiers "+ProgEXEname+"*"+extPIC+" contiennent les crans sauvegards,"+nl+
"   dont les valeurs sont enregistres dans le fichier journal "+datafile+"."+nl+
(*%T PAPEROK  *)
"c) Seule la sauvegarde des crans sur fond noir est garantie !"+nl+
(*%E  *)    nl+
"Voici quelques exemples :"+nl+
nl+
"  "+ProgEXEname+" 4 90 1 3 2 -1 -2"+nl+
"  "+ProgEXEname+" 4 60 1 3 2 -1 -2"+nl+
"  "+ProgEXEname+" 4 90 1 2 3"+nl+
"  "+ProgEXEname+" 4 90 1 2 3 4 5 6 7 8 9"+nl+
"  "+ProgEXEname+" 5 72 2 3 4 5"+nl+
"  "+ProgEXEname+" 5 108 1 2 3 4"+nl+
"  "+ProgEXEname+" 5 36 2 -2 1"+nl;

VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOpt      : mak3(S,"L'option ",einfo," est illgale !");
    | errOverflow : mak3(S,"Le paramtre ",einfo," est illgal !");
    | errVGA      : S:="Ce systme ne semble pas disposer d'une carte VGA !";
    | errCannotSet: S:="Impossible d'initialiser l'affichage !";
    | errRange    : mak3(S,"La valeur de l'option ",einfo," est illgale !");
    | errMissing  : mak3(S,"Les paramtres ",einfo," manquent !");
    | errFullHelp:
        WrStr(helpmsg);
        WrStr(helpF1intro);
        WrStr(helpF1);
        e := errHelp;
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isLegalNegative (S:ARRAY OF CHAR):BOOLEAN;
VAR
    v:LONGINT;
    ok:BOOLEAN;
BEGIN
    v:=Str.StrToInt(S,10,ok);
    RETURN ok;
END isLegalNegative;

PROCEDURE valueint (S:ARRAY OF CHAR;min,max:INTEGER;VAR r:INTEGER):BOOLEAN;
VAR
    v : LONGINT;
BEGIN
    IF GetLongInt(S,v)=FALSE THEN RETURN FALSE; END;
    IF v < LONGINT(min) THEN RETURN FALSE; END;
    IF v > LONGINT(max) THEN RETURN FALSE; END;
    r := INTEGER(v);
    RETURN TRUE;
END valueint;

PROCEDURE valuecard (S:ARRAY OF CHAR;min,max:CARDINAL;VAR r:CARDINAL):BOOLEAN;
VAR
    v : LONGCARD;
BEGIN
    IF GetLongCard(S,v)=FALSE THEN RETURN FALSE; END;
    IF v < LONGCARD(min) THEN RETURN FALSE; END;
    IF v > LONGCARD(max) THEN RETURN FALSE; END;
    r := CARDINAL(v);
    RETURN TRUE;
END valuecard;

PROCEDURE sound (freq,duration:CARDINAL);
BEGIN
    Lib.Sound(freq);
    Lib.Delay(duration);
    Lib.NoSound();
END sound;

PROCEDURE rangebuzz ();
BEGIN
    sound(222,50);
END rangebuzz;

PROCEDURE buzz (  );
BEGIN
    sound(55,50);
END buzz;

PROCEDURE buzzy (  );
BEGIN
    sound(444,100);
END buzzy;

PROCEDURE toggle (VAR flag:BOOLEAN   );
BEGIN
    flag:=NOT(flag);
END toggle;

(* fix=0 not to format *)

PROCEDURE fmtint (v:INTEGER;fix:CARDINAL;pad:CHAR;signed:BOOLEAN):str16;
VAR
    ok:BOOLEAN;
    i:CARDINAL;
    c:CHAR;
    R:str16;
BEGIN
    Str.IntToStr( LONGINT( ABS(v) ),R,10,ok);
    FOR i:=Str.Length(R) TO fix DO
        Str.Prepend(R,pad);
    END;
    IF v < 0 THEN
        c:="-";
    ELSE
        IF signed THEN
            c:=" ";
        ELSE
            c:="";
        END;
    END;
    Str.Prepend(R,c);
    RETURN R;
END fmtint;

PROCEDURE fmtcard (v:CARDINAL;fix:CARDINAL;pad:CHAR;signed:BOOLEAN):str16;
BEGIN
    RETURN fmtint(INTEGER(v),fix,pad,signed);
END fmtcard;

PROCEDURE fmtbool (flag:BOOLEAN;v,f:ARRAY OF CHAR):str16;
BEGIN
    IF flag THEN
        RETURN str16(v);
    ELSE
        RETURN str16(f);
    END;
END fmtbool;

PROCEDURE newint (VAR v:INTEGER;shifted:BOOLEAN;
                  small,big:INTEGER;lower,upper:INTEGER;roll:BOOLEAN );
VAR
    tmp:INTEGER;
BEGIN
    tmp:=v;
    IF shifted THEN
        INC(tmp,big);
    ELSE
        INC(tmp,small);
    END;
    IF tmp < lower THEN
        IF roll THEN
            v:=upper-ABS(lower-tmp);
        ELSE
            rangebuzz;
        END;
    ELSIF tmp > upper THEN
        IF roll THEN
            v:=lower+ABS(tmp-upper);
        ELSE
            rangebuzz;
        END;
    ELSE
        v:=tmp;
    END;
END newint;

PROCEDURE newcard (VAR v:CARDINAL;shifted:BOOLEAN;
                   small,big:INTEGER;lower,upper:CARDINAL;roll:BOOLEAN);
VAR
    vv:INTEGER;
BEGIN
    vv:=INTEGER(v);
    newint( vv, shifted, small,big, INTEGER(lower), INTEGER(upper), roll );
    v:=CARDINAL(vv);
END newcard;

(* force limits to MIN(int) and MAX(int) with rollover *)

PROCEDURE newcoor (VAR v:INTEGER;shifted:BOOLEAN;
                  small,big:INTEGER;lower,upper:INTEGER;roll:BOOLEAN );
BEGIN
    newint( v, shifted, small,big, MIN(INTEGER), MAX(INTEGER), TRUE );
END newcoor;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    PI      : LONGREAL;
    deg2rad : LONGREAL;

PROCEDURE inittrigo (  );
BEGIN
    PI      := 4.0 * MATHLIB.ATan(1.0);
    deg2rad := PI / 180.0;
END inittrigo;

PROCEDURE DegreesToRadians ( alphadeg : LONGREAL ) : LONGREAL ;
BEGIN
    RETURN (alphadeg * deg2rad);
END DegreesToRadians;

PROCEDURE RadiansToDegrees( alpha : LONGREAL ) : LONGREAL ;
BEGIN
    RETURN (alpha / deg2rad);
END RadiansToDegrees;

(*
(* with these coeffs/signs, up=0 and right=90 *)

PROCEDURE PolarToRectangular (alphadeg:LONGREAL;radius,cx,cy:INTEGER;
                             VAR x,y : INTEGER);
VAR
    alpha,dx,dy,co,si : LONGREAL;
BEGIN
    alpha := DegreesToRadians(alphadeg);
    co    := MATHLIB.Cos(alpha);
    si    := MATHLIB.Sin(alpha);
    dx    := LONGREAL(radius) * si;
    dy    := LONGREAL(radius) * co;
    x     := cx+VAL(INTEGER,dx);
    y     := cy-VAL(INTEGER,dy);
END PolarToRectangular;
*)

(* with these coeffs/signs, up=0 and right=270 *)

PROCEDURE PolarToRectangular (alphadeg:LONGREAL;radius:INTEGER;
                             cx,cy:LONGREAL;
                             VAR x,y : LONGREAL);
VAR
    alpha,dx,dy,co,si : LONGREAL;
BEGIN
    alpha := DegreesToRadians(alphadeg);
    co    := MATHLIB.Cos(alpha);
    si    := MATHLIB.Sin(alpha);
    dx    := LONGREAL(radius) * si;
    dy    := LONGREAL(radius) * co;
    x     := cx-dx;
    y     := cy-dy;
END PolarToRectangular;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    mincount     =    1;   maxcount     =  500; maxcount2     = 50;
    minangle     = -180;   maxangle     =  180; (* was 360 *)
    minmotion    =    1;   maxmotion    =  100; maxmotion2    = 20;
    minmotionval = -100;   maxmotionval = +100; maxmotionval2 = 10;
    minscale     =    1;   maxscale     =  500; maxscale2     = 10;
    minrefresh   =    0;   maxrefresh   =  100;
    midAngle     =    0;
    midMotionval =    0;
VAR
    rotation,rotationAnchor,savrotation         : INTEGER;
    motion,savmotion           : ARRAY [minmotion..maxmotion] OF INTEGER;
    count,lastmotion,savcount,savlastmotion : CARDINAL;
    resolution       : restype;
CONST
    defaultInk       = cGREEN;
    defaultPaper     = cBLACK;
    defaultInkText   = cYELLOW;
    defaultPaperText = defaultPaper;
    defaultRotation  = 90;
    defaultScale     = 15;
    defaultresolution= res640x480;
    defaultrefresh   = 10;
VAR
    xx,yy,scale,savscale    : INTEGER;
    ink,paper,inktext,papertext,refresh: CARDINAL;
    orgbadalgo,autocenter : BOOLEAN;
    saveBW,singlestep,DEBUG,show,demomode : BOOLEAN;

PROCEDURE defaults (xyonly:BOOLEAN);
VAR
    i:CARDINAL;
    S,R:str128;
    ok:BOOLEAN;
    v:LONGINT;
BEGIN
IF xyonly THEN
    xx:=INTEGER(cx);
    yy:=INTEGER(cy);
ELSE
    ink              := defaultInk;
    paper            := defaultPaper;
    inktext          := defaultInkText;
    papertext        := defaultPaperText;
    scale            := defaultScale;
    singlestep       := FALSE;
    DEBUG            := FALSE;
    orgbadalgo       := FALSE; (* TRUE matches description but not figures ! *)
    autocenter       := TRUE;
    refresh          := defaultrefresh;
    (*
    xx               := cx;
    yy               := cy;
    *)
    count            := mincount-1;
    rotation         := defaultRotation;
    lastmotion       := minmotion-1;

    resolution       := defaultresolution;
    show             := TRUE;
    demomode         := FALSE;

    (* assume here we won't goof ! *)

    S:="4 90 1 2 3 4 5 6 7 8 9";
    i:=0;
    LOOP
        isoleItemS(R, S, " ", i);
        IF same(R,"") THEN EXIT; END;
        v:=Str.StrToInt(R,10,ok);
        CASE i OF
        | 0 : count:=CARDINAL(v);
        | 1 : rotation:=INTEGER(v);
        ELSE
            INC(lastmotion);
            motion[lastmotion]:=INTEGER(v);
        END;
        INC(i);
    END;
END;
END defaults;

PROCEDURE parmsToStr (VAR S : ARRAY OF CHAR);
VAR
    i : CARDINAL;
BEGIN
    Str.Copy(S,"");
    FOR i:=minmotion TO lastmotion DO
        Str.Append(S," ");
        Str.Append(S, fmtint(motion[i],0,"0",FALSE) );
    END;
    LtrimBlanks(S);
    IF same(S,"") THEN Str.Copy(S,"0");END;
END parmsToStr;

PROCEDURE genparms (  );
VAR
    i,nulls,points:CARDINAL;
BEGIN
    (* keep current just in case *)
    savcount      := count;
    savrotation   := rotation;
    savlastmotion := lastmotion;
    savmotion     := motion;
    savscale      := scale;

    count      := GetRndCardRange(mincount,maxcount2);
    rotation   := INTEGER ( GetRndCardRange(midAngle,maxangle) );
    IF GetRndCardRange(0,1)=1 THEN rotation:=-rotation;END;
    lastmotion := GetRndCardRange (minmotion,maxmotion2);
    LOOP
        points:=lastmotion-minmotion+1;
        nulls:=0;
        FOR i:=minmotion TO lastmotion DO
            motion[i]:=INTEGER( GetRndCardRange(midMotionval,maxmotionval2) );
            IF GetRndCardRange(0,1)=1 THEN motion[i]:=-motion[i];END;
            IF motion[i]=midMotionval THEN INC(nulls);END;
        END;
        IF nulls # points THEN EXIT; END;
        (* try again ! *)
        (* buzzy; *)
    END;
    scale      := INTEGER ( GetRndCardRange(minscale,maxscale2) );
END genparms;

PROCEDURE restoresavedparms (  );
BEGIN
    count      := savcount;
    rotation   := savrotation;
    lastmotion := savlastmotion;
    motion     := savmotion;
    scale      := savscale;
END restoresavedparms;

(* ------------------------------------------------------------ *)

(*
CONST
    dosave=1;
    dorestore=2;
VAR
    savinktext,savink,savpaper : CARDINAL;
    savxx,savyy,savscale    : INTEGER;
    savorgbadalgo,savautocenter : BOOLEAN;

PROCEDURE procparms (op:CARDINAL);
VAR
    i:CARDINAL;
BEGIN
CASE op OF
| dosave:
    savxx:=xx;
    savyy:=yy;
    savinktext:=inktext;
    savink:=ink;
    savpaper:=paper;
    savscale:=scale;
    savorgbadalgo:=orgbadalgo;
    savautocenter:=autocenter;
    savcount:=count;
    savrotation:=rotation;
    savlastmotion:=lastmotion;
    FOR i:=minmotion TO lastmotion DO
        savmotion[i]:=motion[i];
    END;
| dorestore:
    xx:=savxx;
    yy:=savyy;
    inktext:=savinktext;
    ink:=savink;
    paper:=savpaper;
    scale:=savscale;
    orgbadalgo:=savorgbadalgo;
    autocenter:=savautocenter;
    count:=savcount;
    rotation:=savrotation;
    lastmotion:=savlastmotion;
    FOR i:=minmotion TO lastmotion DO
        motion[i]:=savmotion[i];
    END;
END;
END procparms;
*)

(* ------------------------------------------------------------ *)

(* adapted from buildpicname() in QD_DUMP.MOD *)

PROCEDURE rebuildpicname (S:ARRAY OF CHAR;num:CARDINAL; VAR pic:ARRAY OF CHAR);
VAR
    N:str128;
    v:LONGCARD;
    ok:BOOLEAN;
    p,len:CARDINAL;
    unit,dir,f8,e3,newf8:str128;
BEGIN
    qdSplitAllPath(S,unit,dir,f8,e3);
    Str.CardToStr(LONGCARD(num),N,10,ok);
    len:=Str.Length(N);
    p:=Str.Length(f8);
    IF (p+len) > 8 THEN
        Str.Delete(f8,8-len,p+len-8);
    END;
    Str.Concat(newf8,f8,N);
    Lib.MakeAllPath(pic,unit,dir,newf8,e3);
END rebuildpicname;

PROCEDURE dmpit (hnd:FIO.File;S1,S2:ARRAY OF CHAR);
BEGIN
    FIO.WrStr(hnd,S1);FIO.WrStr(hnd," : ");FIO.WrStr(hnd,S2);FIO.WrLn(hnd);
END dmpit;

PROCEDURE savedata (S1,S2:ARRAY OF CHAR;num:CARDINAL);
VAR
    hnd:FIO.File;
    S:str128;
    i:CARDINAL;
BEGIN
    IF FIO.Exists(S1) THEN
        hnd:=FIO.Append(S1);
    ELSE
        hnd:=FIO.Create(S1);
    END;

    rebuildpicname(S2,num,S);
    Str.Prepend(S,"::: Fichier ");
    FIO.WrStr(hnd,S);FIO.WrLn(hnd);
    FIO.WrLn(hnd);

    dmpit(hnd,"  Rptitions",fmtcard(count   ,0,"0",FALSE));
    dmpit(hnd,"  Rotation   ",fmtint (rotation,0,"0",FALSE));
    S:="";
    FOR i:=minmotion TO lastmotion DO
        Str.Append(S," ");
        Str.Append(S, fmtint(motion[i],0,"0",FALSE) );
    END;
    LtrimBlanks(S);
    IF same(S,"") THEN S:="0";END;
    dmpit(hnd,"  Paramtres ",S);
    dmpit(hnd,"  Echelle    ",fmtint (scale   ,0,"0",FALSE));
    dmpit(hnd,"  Algorithme ",fmtbool(orgbadalgo,"original","corrig"));
    dmpit(hnd,"  X          ",fmtint (xx      ,0,"0",FALSE));
    dmpit(hnd,"  Y          ",fmtint (yy      ,0,"0",FALSE));
    FIO.WrLn(hnd);

    Str.Prepend(S," ");
    Str.Prepend(S,fmtint(rotation,0,"0",FALSE));
    Str.Prepend(S," ");
    Str.Prepend(S,fmtcard(count,0,"0",FALSE));
    Str.Prepend(S,"  "+ProgEXEname+" ");
    Str.Append(S," -e:");Str.Append(S,fmtint(scale,0,"0",FALSE));
    IF orgbadalgo THEN Str.Append(S," -o");END;

    FIO.WrStr(hnd,S);FIO.WrLn(hnd);
    FIO.WrLn(hnd);

    FIO.Close(hnd);
END savedata;

(* ------------------------------------------------------------ *)

PROCEDURE vpause (n:CARDINAL   );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=1 TO n DO WaitVGAretrace; END;
END vpause;

CONST
    Solid         = 0FFFFH; (* 1111111111111111 *)
    Light         = 0AAAAH; (* 1010101010101010 *)
    VeryLight     = 08888H; (* 1000100010001000 *)
    VeryVeryLight = 08080H; (* 1000000010000000 *)
CONST
    minhtab=1;
    minvtab=1;

PROCEDURE f2i ( v:LONGREAL  ):INTEGER ;
CONST
    fk = LONGREAL(0.5);
    minint = LONGREAL (MIN(INTEGER));
    maxint = LONGREAL (MAX(INTEGER));
VAR
    vv:LONGREAL;
BEGIN
    (* // try and handle v bigger than an INTEGER, the brutal way  *)
    vv:=v+fk;
    IF vv > maxint THEN
        RETURN MAX(INTEGER);
    ELSIF vv < minint THEN
        RETURN MIN(INTEGER);
    ELSE
        RETURN VAL( INTEGER, vv);
    END;
END f2i;

PROCEDURE fGrLine (x1,y1,x2,y2:LONGREAL;ink,pattern:CARDINAL);
VAR
    a,b,c,d:INTEGER;
BEGIN
    a:=f2i(x1);
    b:=f2i(y1);
    c:=f2i(x2);
    d:=f2i(y2);
    GrLine(a,b,c,d, ink,pattern);
END fGrLine;

PROCEDURE cls ( ndx:CARDINAL  );
VAR
    bgr:LONGCARD;
BEGIN
    bgr:=GrSetBkColor ( inkToRGB(ndx) );
    WaitVGAretrace;
    GrClearScreen;
END cls;

PROCEDURE pr (vtab,htab:CARDINAL;S:ARRAY OF CHAR);
VAR
    rowcol:textcoords;
BEGIN
    rowcol:=GrSetTextPosition(vtab,htab);
    GrOutText(S);
END pr;

PROCEDURE WrS (VAR vtab:CARDINAL;htab:CARDINAL;S:ARRAY OF CHAR);
BEGIN
    pr(vtab,htab,S);
    INC(vtab);
END WrS;

PROCEDURE prink (inkval,vtab,htab:CARDINAL;S:ARRAY OF CHAR);
VAR
    oldink:CARDINAL;
BEGIN
    oldink:=GrSetTextColor( inkval );
    pr(vtab,htab,S);
END prink;

CONST
    sep    = " : ";

PROCEDURE stat (VAR vtab,htab:CARDINAL;S1,S2:ARRAY OF CHAR);
VAR
    R:str128;
BEGIN
    Str.Concat(R,S1,sep);Str.Append(R,S2);
    WrS(vtab,htab,R);
END stat;


PROCEDURE editparms (vt,ht:CARDINAL;prompt,parms:ARRAY OF CHAR  );
CONST
    admitted = "0123456789 -+";
    foo = 4;
VAR
    ok:BOOLEAN;
    i:CARDINAL;
    maxhtab,maxvtab,htab,vtab:CARDINAL;
    c1,c2:CHAR;
    shifted,insmode:BOOLEAN;
    S,oldS,R:str128;
    len,cpos,oldcpos:CARDINAL;
    c,phase1,phase2:str2;
    v:LONGINT;
BEGIN
    ok:=GrWrapon(FALSE);
    maxhtab:=getmaxhtab();
    maxvtab:=getmaxvtab();

    htab:=ht;
    vtab:=vt;

    (* alays rewrite prompt, in case we would not show infos *)

    Str.Concat(S,prompt,sep);
    prink(inktext,vtab,htab,S);

    INC(htab,Str.Length(prompt));
    INC(htab,Str.Length(sep));

    Str.Copy(S,parms);
    Str.Copy(oldS,S);

    len :=Str.Length(S); (* space was added FOR safety TO avoid a  *)
    cpos:=len;
    oldcpos:=cpos;

    insmode:=TRUE;
    phase1:="_";
    phase2:=CHR(219);
    LOOP
        prink(paper    ,vtab,htab,oldS);
        prink(inktext  ,vtab,htab,S);
        Str.Copy(oldS,S);

        IF cpos < len THEN
            Str.Concat(c,S[cpos],CHR(0));
        ELSE
            Str.Concat(c," ",CHR(0));
        END;
        WHILE BiosIO.KeyPressed()=FALSE DO
            prink(paper   ,vtab,htab+cpos,c);

            IF insmode THEN
                phase1:=CHR(219);
            ELSE
                phase1:="_";
            END;
            prink(inktext ,vtab,htab+cpos,phase1); vpause(foo);
            prink(paper   ,vtab,htab+cpos,phase1);

            prink(inktext ,vtab,htab+cpos,c);      vpause(foo);
        END;

        c1:=BiosIO.RdKey();
        shifted:=(BiosIO.RShift IN BiosIO.KBFlags()) OR (BiosIO.LShift IN BiosIO.KBFlags());
        IF c1 = CHR(0) THEN c2:=BiosIO.RdKey(); END;
        CASE c1 OF
        | CHR(13): (* cr *)   EXIT;
        | CHR(8) : (* bs *)   IF cpos > 0 THEN DEC(cpos);Str.Delete(S,cpos,1);DEC(len);END;
        | ESC    : (* esc *)  Str.Copy(S,parms); cpos:=oldcpos;
        | CHR(24): (* ^X *)   S:=""; cpos:=0;
        | CHR(0):
            CASE c2 OF
            | CHR(77) : (* right *)  IF cpos < len THEN INC(cpos); END;
            | CHR(75) : (* left *)   IF cpos > 0 THEN DEC(cpos); END;
            | CHR(71) : (* home *)   cpos:=0;
            | CHR(79) : (* end *)    cpos:=len;
            | CHR(83) : (* suppr *)  IF cpos < len THEN Str.Delete(S,cpos,1);DEC(len);END;
            | CHR(82) : (* ins *)    toggle(insmode);
            END;
        END;
        IF Str.CharPos(admitted,c1) # MAX(CARDINAL) THEN
            IF insmode THEN
               Str.Insert (S,c1,cpos); INC(len);
            ELSIF cpos = len THEN
               Str.Append (S,c1); INC(len);
            ELSE
               S[cpos] := c1;
            END;
            INC (cpos);
        END;
    END;

    lastmotion:=minmotion-1;
    i:=0;
    LOOP
        isoleItemS(R, S, " ", i);
        IF same(R,"") THEN EXIT; END;
        v:=Str.StrToInt(R,10,ok);
        IF ok THEN
            IF ( (v >= LONGINT(minmotionval)) AND (v <= LONGINT(maxmotionval)) ) THEN
               INC(lastmotion);
               motion[lastmotion]:=INTEGER(v);
            ELSE
               rangebuzz;
            END;
        ELSE
            rangebuzz;
        END;
        INC(i);
    END;
END editparms;

(* ------------------------------------------------------------ *)

CONST
    hlpStandard = 0;
    hlpExamples = 1;

PROCEDURE showhelp ( what:CARDINAL );
VAR
    c1,c2:CHAR;
    ok,shifted:BOOLEAN;
    oldink:CARDINAL;
    maxhtab,maxvtab,htab,vtab:CARDINAL;
    R:str128;
    i,n:CARDINAL;
BEGIN
    papertext:=paper; (* well... *)

    cls ( papertext );

    ok:=GrWrapon(FALSE);
    oldink:=GrSetTextColor( inktext );
    maxhtab:=getmaxhtab();
    maxvtab:=getmaxvtab();
    htab:=minhtab;
    vtab:=minvtab;

    (* helpF1 and helpF1wait *)
    FOR i:=1 TO 2 DO
        n:=0;
        LOOP
            CASE i OF
            | 1 :
                CASE what OF
                | hlpStandard: isoleItemS(R, helpF1  , lf, n);
                | hlpExamples: isoleItemS(R, helpF12 , lf, n);
                END;
            | 2 : isoleItemS(R, helpwait  , lf, n);
            END;
            IF same(R,"") THEN EXIT; END;
            Str.Subst(R,cr,"");
            Str.Subst(R,lf,"");
            WrS(vtab,htab,R);
            INC(n);
        END;
    END;

    BiosWaitkeyShifted(c1,c2,shifted);
END showhelp;

PROCEDURE showinfos (flagshow:BOOLEAN;
                     VAR vt,ht:CARDINAL;VAR prompt,parms:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
    i,oldink:CARDINAL;
    maxhtab,maxvtab,htab,vtab:CARDINAL;
    S:str128;
BEGIN
    parmsToStr(parms); (* always, whatever show status *)
    IF NOT(flagshow) THEN RETURN; END;

    ok:=GrWrapon(FALSE);
    oldink:=GrSetTextColor( inktext );
    maxhtab:=getmaxhtab();
    maxvtab:=getmaxvtab();
    htab:=minhtab;
    vtab:=minvtab;

    stat(vtab,htab,"Rptitions",fmtcard(count   ,0,"0",FALSE));
    stat(vtab,htab,"Rotation   ",fmtint (rotation,0,"0",FALSE));

    vt:=vtab; ht:=htab; (* keep'em *)
    stat(vtab,htab,"Paramtres ",parms);

    Str.Copy(prompt,"Paramtres ");
    (* parms already done *)

    stat(vtab,htab,"Echelle    ",fmtint (scale   ,0,"0",FALSE));
    stat(vtab,htab,"Algorithme ",fmtbool(orgbadalgo,"original","corrig"));
    (*
    stat(vtab,htab,"Centrage   ",fmtbool(autocenter,"oui","non"));
    *)
    (*
    stat(vtab,htab,"X          ",fmtint (xx      ,0,"0",FALSE));
    stat(vtab,htab,"Y          ",fmtint (yy      ,0,"0",FALSE));
    *)
    Str.Concat(S,fmtint (xx,0,"0",FALSE), ",");
    Str.Append(S,fmtint (yy,0,"0",FALSE) );
  IF autocenter THEN
    stat(vtab,htab,"X,Y (auto) ",S);
  ELSE
    stat(vtab,htab,"X,Y        ",S);
  END;

    IF refresh=0 THEN
        S:="aucun";
    ELSE
        Str.Copy(S,fmtcard(refresh ,0,"0",FALSE));
    END;
    stat(vtab,htab,"Delai      ",S);


    (*
    stat(vtab,htab,"Encre      ",fmtcard(ink     ,0,"0",FALSE));
    stat(vtab,htab,"Papier     ",fmtcard(paper   ,0,"0",FALSE));
    *)
    INC(vtab);
    WrS(vtab,htab,'(F1 = aide)');
END showinfos;

VAR
    orgX,orgY,loX,hiX,loY,hiY:LONGREAL;

PROCEDURE redraw ( chklimits:BOOLEAN  );
VAR
    i,j:CARDINAL;
    x,y,rotdeg,thetadeg,lastx,lasty,dx,dy:LONGREAL;
    radius:INTEGER;
    c1,c2:CHAR;
    shifted,forcekbwait:BOOLEAN;
BEGIN
    IF chklimits THEN
        orgX:=LONGREAL(xx);
        orgY:=LONGREAL(yy);
        loX:=orgX;
        hiX:=orgX;
        loY:=orgY;
        hiY:=orgY;
    ELSE
        cls (paper);
    END;

    x := LONGREAL(xx);
    y := LONGREAL(yy);

    rotdeg   := LONGREAL(rotation);
    thetadeg := 0.0;

    i:=mincount;
    LOOP
        j:=minmotion;
        LOOP
            IF j > lastmotion THEN EXIT; END;
            lastx := x;
            lasty := y;
            radius:= scale * motion[j];

            IF orgbadalgo THEN
                thetadeg:=thetadeg+rotdeg;
                IF radius < 0 THEN
                    radius := ABS(radius);
                    thetadeg:=thetadeg+LONGREAL(180.0);
                END;
            ELSE
                IF radius < 0 THEN
                    radius   := ABS(radius);
                    thetadeg := thetadeg+LONGREAL(180.0)+rotdeg;
                ELSE
                    thetadeg := thetadeg-LONGREAL(180.0)-rotdeg;
                END;
            END;
            thetadeg:=MATHLIB.Mod(thetadeg, 360.0);
            PolarToRectangular (thetadeg+LONGREAL(90.0),radius,lastx,lasty, x,y);
            IF chklimits THEN
                IF x < loX THEN loX:=x;END;
                IF x > hiX THEN hiX:=x;END;
                IF y < loY THEN loY:=y;END;
                IF y > hiY THEN hiY:=y;END;
            ELSE
                fGrLine(lastx,lasty,x,y,ink,Solid);
            END;
            INC(j);
        END;
        INC(i);
        IF i > count THEN singlestep:=FALSE; EXIT; END; (* force it just to avoid side effect *)

        forcekbwait := ( (chklimits=FALSE) AND singlestep );
        IF forcekbwait THEN
            BiosWaitkeyShifted(c1,c2,shifted); (* globerk as too many things here... *)
            IF c1=ESC THEN (* any other key is step *)
                singlestep:=FALSE; (* don't exit now ! finish pattern first *)
            END;
        END;
    END;

    IF chklimits THEN
        dx:=(hiX-loX)/2.0;
        dy:=(hiY-loY)/2.0;

        xx:=f2i( orgX+dx-(hiX-orgX) ); xx:=INTEGER(cx)+ xx-f2i(orgX);
        yy:=f2i( orgY+dy-(hiY-orgY) ); yy:=INTEGER(cy)+ yy-f2i(orgY);
    END;
END redraw;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    small = 1;
    big   = 10;

VAR
    i,opt,parmcount  : CARDINAL;
    S,R              : str128;
    chk              : BOOLEAN;
    loopstate : (waitcmd,continue,quit);
    c1,c2 : CHAR;
    shifted,savflag:BOOLEAN;
    picturefile:str128;
    picnum:CARDINAL;
    vt,ht:CARDINAL;
    prompt,parms:str128;
    state : (waiting,gotcount,gotrotation,gotmotion);
BEGIN
    Lib.DisableBreakCheck();
    WrLn;                       (* must be here for pretty ulterior display ! *)

    InitRnd;
    defaults(FALSE);

    parmcount := Lib.ParamCount();
    (* IF parmcount=0 THEN abort(errHelp,"");END; *)

    state:=waiting;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF (isOption(R) AND (isLegalNegative(R)=FALSE)) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "DEBUG"+delim+
                                   "V"+delim+
                                   "VV"+delim+
                                   "VVV"+delim+
                                   "C:"+delim+"INK:"+delim+
                                   "P:"+delim+"PAPER:"+delim+
                                   "E:"+delim+"SCALE:"+delim+
                                   "A"+delim+"EXACT"+delim+
                                   "T:"+delim+"TEXT:"+delim+
                                   "O"+delim+"AUTOCENTER"+delim+
                                   "??"+delim+"HH"+delim+"FULLHELP"+delim+
                                   "N"+delim+"RANDOM"+delim+
                                   "D:"+delim+"REFRESH:"+delim+
                                   "D"+delim+"DEMO"
                                   );
            CASE opt OF
            | 1,2,3: abort(errHelp,"");
            | 4:     DEBUG:=TRUE;
            | 5:     resolution:=res640x480;
            | 6:     resolution:=res800x600;
            | 7:     resolution:=res1024x768;
            | 8,9  : IF valuecard(R,firstInk,lastInk,ink)=FALSE THEN abort(errRange,R);END;
(*%T PAPEROK  *)
            | 10,11: IF valuecard(R,firstInk,lastInk,paper)=FALSE THEN abort(errRange,R);END;
(*%E  *)
            | 12,13: IF valueint(R,minscale,maxscale,scale)=FALSE THEN abort(errRange,R);END;
            | 14,15: orgbadalgo := TRUE;
            | 16,17: IF valuecard(R,firstInk,lastInk,inktext)=FALSE THEN abort(errRange,R);END;
            | 18,19: autocenter := FALSE;
            | 20,21,22: abort(errFullHelp,"");
            | 23,24: genparms();
            | 25,26: IF valuecard(R,minrefresh,maxrefresh,refresh)=FALSE THEN abort(errRange,R);END;
            | 27,28: demomode:=TRUE;
            ELSE
                abort(errOpt,S);
            END;
        ELSE
            CASE state OF
            | waiting:
                IF same(R,"*") THEN
                    count := maxcount;
                ELSE
                    IF valuecard(R,mincount,maxcount,count)=FALSE THEN abort(errRange,R);END;
                END;
                INC(state);
            | gotcount:
                IF valueint(R,-maxangle,+maxangle,rotation)=FALSE THEN abort(errRange,R);END;
                INC(state);
            | gotrotation:
                lastmotion := minmotion;
                IF valueint(R,minmotionval,maxmotionval,motion[lastmotion])=FALSE THEN abort(errRange,R);END;
                INC(state);
            | gotmotion:
                IF lastmotion < maxmotion THEN
                    INC(lastmotion);
                    IF valueint(R,minmotionval,maxmotionval,motion[lastmotion])=FALSE THEN abort(errRange,R);END;
                ELSE
                    abort(errOverflow,R);
                END;
            END;
        END;
    END;
    CASE state OF
    (*
    | waiting:    abort(errMissing,"<count> <rotation> <motion>...");
    *)
    | gotcount:   abort(errMissing,"<rotation> <dplacement>...");
    | gotrotation:abort(errMissing,"<dplacement>...");
    END;

    IF demomode THEN show:=FALSE; END;

    initHGR( resolution );

    IF VGAhere()=FALSE THEN abort(errVGA,"");END;
    IF HiresOn()=FALSE THEN
        chk := TextOn();
        abort(errCannotSet,"");
    END;
    FixPalette;

    inittrigo;

    defaults(TRUE); (* now we have video mode, we can do it *)

    redraw(TRUE); (* always center first pattern *)
    (* procparms(dosave); *)

    Str.Concat(picturefile,ProgEXEname,extPIC);
    picnum:=1;

    BiosFlushkey();
    LOOP

        savflag:=singlestep; (* //FIX11E *)
        IF autocenter THEN redraw(TRUE); END;
        singlestep:=savflag; (* //FIX11E *)

        redraw(FALSE); (* use our globerks here *)
        showinfos(show,vt,ht,prompt,parms);
        LOOP
            loopstate:=continue;
            IF demomode THEN
                IF BiosIO.KeyPressed() THEN
                    BiosWaitkeyShifted(c1,c2,shifted); (* globerk as too many things here... *)
                    IF c1=ESC THEN
                        demomode:=FALSE;
                        (* eh eh, we had already displayed next pattern, so... *)
                        restoresavedparms; (* saved when genparms() was called *)
                        redraw(TRUE); (* required *)
                        redraw(FALSE); (* use our globerks here *)
                        showinfos(show,vt,ht,prompt,parms);
                    ELSE
                        c1:=ctrlN; (* fake ctrl-n *)
                    END;
                ELSE
                    (* was not a good idea
                    genparms(); (* fake ctrl-n *)
                    c1:="t";
                    *)
                    vpause(refresh); (* allow user to see the pattern ! *)
                    c1:=ctrlN; (* fake ctrl-n *)
                END;
            ELSE
                BiosWaitkeyShifted(c1,c2,shifted); (* globerk as too many things here... *)
            END;
            CASE c1 OF
            | CHR(17),ESC    : IF shifted THEN (* shift-ctrl-Q or shift-Esc *)
                                   loopstate:=quit;
                               (*
                               ELSE
                                   loopstate:=waitcmd;
                               *)
                               END;
            | "r","R"," "    : singlestep:=TRUE;
            | "?",","        : showhelp(hlpStandard);
            | "!"            : toggle(show);
            | "a","A"        : toggle(orgbadalgo);
            | CHR(19)        : (* ctrl-S *)
                               savescreen(picturefile,TRUE,TRUE,TRUE,picnum);
                               savedata(datafile,picturefile,picnum-1); (* yes, -1 ! *)
                               BiosFlushkey(); (* prevent too many saves in succession *)
            | CHR(22)        : (* ctrl-V *)
                               savescreen(picturefile,FALSE,FALSE,TRUE,picnum);
                               savedata(datafile,picturefile,picnum-1); (* yes, -1 ! *)
                               BiosFlushkey(); (* prevent too many saves in succession *)
            | "-","*","" : newcard(count,shifted,-small,-big,mincount,maxcount,FALSE );
            | "+","$","" : newcard(count,shifted, small, big,mincount,maxcount,FALSE );

            | CHR(13):  (* return *)
                        editparms(vt,ht,prompt,parms);
            (*
            | CHR(18) : (* ctrl-R *)
                        defaults(FALSE); defaults(TRUE); procparms(dorestore);
            *)
            | "c","C" : IF autocenter=FALSE THEN redraw(TRUE); END;
            | "o","O" : toggle(autocenter);
            | ctrlN   : (* ctrl-N *)
                        genparms(); redraw(TRUE); (* center pattern *)
            | "t","T" : (* ugly code but who's to see it ? the Code Police ? ;-) *)
                        rotationAnchor:=rotation;
                        LOOP
                            IF autocenter THEN redraw(TRUE); END;
                            redraw(FALSE); (* use our globerks here *)
                            showinfos(show,vt,ht,prompt,parms);
                            vpause(refresh);

                            IF BiosIO.KeyPressed() THEN
                                 BiosWaitkeyShifted(c1,c2,shifted); (* globerk as too many things here... *)
                                 IF c1=ESC THEN EXIT;END;
                            END;

                            newint(rotation,FALSE,small,small,minangle,maxangle,TRUE );
                            IF rotation=rotationAnchor THEN EXIT; END;
                        END;
            | CHR(4): (* ctrl-D *)
                      toggle(demomode);
            | CHR(0):
                CASE c2 OF
                (* right left up down *)
                | CHR(77) : newcoor (xx,shifted, big, small,xmin,xmax,FALSE );
                | CHR(75) : newcoor (xx,shifted,-big,-small,xmin,xmax,FALSE );
                | CHR(72) : newcoor (yy,shifted,-big,-small,ymin,ymax,FALSE );
                | CHR(80) : newcoor (yy,shifted, big, small,ymin,ymax,FALSE );
                (* home end *)
                | CHR(71) : newint(scale,shifted, small, big,minscale,maxscale,FALSE );
                | CHR(79) : newint(scale,shifted,-small,-big,minscale,maxscale,FALSE );
                (* pgup pgdn *)
                | CHR(73) : newint(rotation,shifted, small, big,minangle,maxangle,TRUE );
                | CHR(81) : newint(rotation,shifted,-small,-big,minangle,maxangle,TRUE );

                | CHR(142),CHR(23) : count:=mincount; (* ctrl - , alt I *)
                | CHR(144),CHR(30) : count:=maxcount; (* ctrl + , alt A *)
                (* F5 F6 *)
                | CHR(63) : newcard(inktext  ,shifted,-small,-small,firstInk, lastInk,TRUE );
                            IF inktext=paper THEN newcard(inktext  ,shifted,-small,-small,firstInk, lastInk,TRUE ); END;
                | CHR(64) : newcard(inktext  ,shifted, small, small,firstInk, lastInk,TRUE );
                            IF inktext=paper THEN newcard(inktext  ,shifted, small, small,firstInk, lastInk,TRUE ); END;
                (* F7 F8 *)
                | CHR(65) : newcard(ink  ,shifted,-small,-small,firstInk, lastInk,TRUE );
                            IF ink=paper THEN newcard(ink  ,shifted,-small,-small,firstInk, lastInk,TRUE ); END;
                | CHR(66) : newcard(ink  ,shifted, small, small,firstInk, lastInk,TRUE );
                            IF ink=paper THEN newcard(ink  ,shifted, small, small,firstInk, lastInk,TRUE ); END;
(*%T PAPEROK  *)
                (* F9 F10 *)
                | CHR(67) : newcard(paper,shifted,-small,-small,firstInk, lastInk,TRUE );
                            IF ((paper=ink) OR (paper=inktext)) THEN newcard(paper,shifted,-small,-small,firstInk, lastInk,TRUE ); END;
                | CHR(68) : newcard(paper,shifted, small, small,firstInk, lastInk,TRUE );
                            IF ((paper=ink) OR (paper=inktext)) THEN newcard(paper,shifted, small, small,firstInk, lastInk,TRUE ); END;
(*%E  *)
                (* F1 *)
                | CHR(59) : showhelp(hlpStandard);
                (* F2 *)
                | CHR(60) : toggle(show);
                (* F3 F4 *)
                | CHR(61): newcard(refresh,shifted,-small,-big,minrefresh,maxrefresh,FALSE);
                | CHR(62): newcard(refresh,shifted, small, big,minrefresh,maxrefresh,FALSE);
                (* shift F3 F4 *)
                | CHR(86): newcard(refresh,shifted,-small,-big,minrefresh,maxrefresh,FALSE);
                | CHR(87): newcard(refresh,shifted, small, big,minrefresh,maxrefresh,FALSE);

                (* F12 *)
                | CHR(134) : showhelp(hlpExamples);
                ELSE
                    loopstate:=waitcmd;
                END;
            ELSE
                loopstate:=waitcmd;
            END;
            IF loopstate # waitcmd THEN EXIT; END;
            buzz;
            BiosFlushkey();
        END;
        IF loopstate = quit THEN EXIT; END;
    END;

    BiosFlushkey();

    IF TextOn()=FALSE THEN
        chk := TextOn();
        abort(errCannotSet,"");
    END;

    abort(errNone,"");
END Spiro.



