(* ---------------------------------------------------------------
Title         Q&D BGI demo
Author        PhG
Overview      self-explanatory !
Notes         very, very, very quick & dirty... :-(
              minimal error messages AND checking, etc.

              these models will work : LARGE, XLARGE, MTHREAD (not recommended)
              this model will compile but won't work : MEDIUM
              these models won't compile cleanly : SMALL, COMPACT

              original topspeed .def was a no-no

              this seems to work with internally linked OBJ
              (need several xxxF.DEF files anyway ! and a FarADDRESS, not
              a PROC in registerfar : installuser not yet checked)
              argh ! VESA16 would never work, and other drivers are whimsical...

              this works with external files (.BGI, .CHR)

              results may vary according to video card :
              a Matrox G400 and a Radeon 9600 pro do not support everything !
              now, talk about standards... and this will get worse and worse :-(

              see //CHKME for various compilation flags

              can't remember where the svga drivers come from :
              possibly a SWAG library ? a Simtel CD ?

              darn... I've just checked my old floppies catalog
              and contrarily to what I thought,
              svga16 and svga256 are not freeware but shareware
              (dated Dec 7, 1991 by "JORDAN HARGRAPHIX SOFTWARE")
              user will have to search himself for them...
              sorry for the inconvenience !

              anyway, I strongly doubt anyone will be interested ! ;-)

              here are missing files :
              7.598  svga16.bgi
              7.451  svga256.bgi
              7.726  svga16f.obj
              7.581  svga256f.obj

Bugs          borland, topspeed, et alii ;-)
Wish List

--------------------------------------------------------------- *)

MODULE BGIdemo;

IMPORT Lib;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

IMPORT BiosIO;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM IO IMPORT WrStr, WrLn;

FROM graphics IMPORT grOk, grNoInitGraph, grNotDetected, grFileNotFound,
grInvalidDriver, grNoLoadMem, grNoScanMem, grNoFloodMem,
grFontNotFound, grNoFontMem, grInvalidMode, grError, grIOerror,
grInvalidFont, grInvalidFontNum, grInvalidVersion,
Detect, CGA, MCGA, EGA, EGA64, EGAMono, IBM8514, HercMono,
ATT400, VGA, PC3270,
Current_Driver, DETECTX, VGA256, ATTDEB, TOSHIBA, SVGA16,
SVGA256, SVGA32K, SVGA64K, VESA16, VESA256, VESA32K, VESA64K,
VESA16M, ATI16, ATI256, ATI32K, COMPAQ, TSENG316, TSENG3256,
TSENG416, TSENG4256, TSENG432K, GENOA5, GENOA6, OAK,
PARADIS16, PARADIS256, TECMAR, TRIDENT16, TRIDENT256, VIDEO7,
VIDEO7II, S3, ATIGUP,
RES640x350, RES640x480, RES800x600, RES1024x768, RES1280x1024,
CGAC0, CGAC1, CGAC2, CGAC3, CGAHi, MCGAC0, MCGAC1, MCGAC2,
MCGAC3, MCGAMed, MCGAHi, EGALo, EGAHi, EGA64Lo, EGA64Hi,
EGAMonoHi, HercMonoHi, ATT400C0, ATT400C1, ATT400C2,
ATT400C3, ATT400Med, ATT400Hi, VGALo, VGAMed, VGAHi,
PC3270Hi, IBM8514LO, IBM8514HI, CGA_LIGHTGREEN, CGA_LIGHTRED,
CGA_YELLOW, CGA_LIGHTCYAN, CGA_LIGHTMAGENTA, CGA_WHITE,
CGA_GREEN, CGA_RED, CGA_BROWN, CGA_CYAN, CGA_MAGENTA, CGA_LIGHTGRAY,
EGABlack, EGABlue, EGAGreen, EGACyan, EGARed, EGAMagenta,
EGABrown, EGALightgray, EGADarkgray, EGALightblue, EGALightgreen,
EGALightcyan, EGALightred, EGALightmagenta, EGAYellow,
EGAWhite, NormWidth, ThickWidth, HorizDir, VertDir,
UserCharSize, LeftText, CenterText, RightText, BottomText,
TopText, MaxColors, ClipOn, ClipOff, TopOn, TopOff, Black,
Blue, Green, Cyan, Red, Magenta, Brown, LightGray, DarkGray,
LightBlue, LightGreen, LightCyan, LightRed, LightMagenta, Yellow,
White, SolidLn, DottedLn, CenterLn, DashedLn, UserBitLn,
DefaultFont, TriplexFont, SmallFont, SansSerifFont, GothicFont,
ScriptFont, SimplexFont, TriplexScrFont, ComplexFont,
EuropeanFont, BoldFont, EmptyFill, SolidFill, LineFill, LtSlashFill,
SlashFill, BkSlashFill, LtBkSlashFill, HatchFill, XHatchFill,
InterleaveFill, WideDotFill, CloseDotFill, UserFill, NormalPut,
CopyPut, XORPut, OrPut, AndPut, NotPut, palettetype_p,
PaletteType, LineSettingsType, TextSettingsType, FillSettingsType,
PointType, ViewportType, ArcCoordsType, fill_patterns, driverproc,
arc, bar, bar3d, circle, cleardevice, clearviewport, closegraph,
detectgraph, drawpoly, ellipse, fillellipse,
fillpoly, floodfill, getarccoords, getaspectratio, getbkcolor,
getcolor, getdefaultpalette, getdrivername, getfillpattern,
getfillsettings, getgraphmode, getimage, getlinesettings, getmaxcolor,
getmaxmode, getmaxx, getmaxy, getmodename, getmoderange,
getpixel, getpalette, getpalettesize, gettextsettings, getviewsettings,
getx, gety, graphdefaults, grapherrormsg, _graphfreemem,
_graphgetmem, graphresult, imagesize, initgraph, installuserdriver,
installuserfont, line, linerel, lineto, moverel, moveto, outtext,
outtextxy, pieslice, putimage, putpixel, rectangle, restorecrtmode,
sector, setactivepage, setallpalette, setaspectratio, setbkcolor,
setcolor, setfillpattern, setfillstyle, setgraphbufsize,
setgraphmode, setlinestyle, setpalette, setrgbpalette,
settextjustify, settextstyle, setusercharsize, setviewport,
setvisualpage, setwritemode, textheight, textwidth, registerbgidriver,
registerfarbgidriver, registerbgifont, registerfarbgifont,
CGA_driver_far, EGAVGA_driver_far, IBM8514_driver_far,
Herc_driver_far, ATT_driver_far, PC3270_driver_far,
triplex_font_far, small_font_far, sansserif_font_far,
gothic_font_far, Svga16_driver_far, Svga256_driver_far, BGI256_driver_far,
euro_font_far, bold_font_far, complex_font_far, script_font_far,
simplex_font_far, triplex_src_font_far,
VESA16_driver_far,VGA256_driver_far,
XNOR_PUT, NOR_PUT, NAND_PUT, TRANS_COPY_PUT,
SVGA320x200x16, SVGA640x200x16, SVGA640x350x16, SVGA640x480x16,
SVGA800x600x16, SVGA1024x768x16, SVGA1280x1024x16,
SVGA320x200x256, SVGA640x400x256, SVGA640x480x256, SVGA800x600x256,
SVGA1024x768x256, SVGA640x350x256, SVGA1280x1024x256;

FROM BGIsvga IMPORT DacPalette16, DacPalette256,
SetVGAPalette16, GetVGAPalette16,
SetVGAPalette256, GetVGAPalette256;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //CHKME
   don't forget to link in project file !
   # pragma link(svga256f,gothf,littf,sansf,tripf)
*)

(*
         external    linked
svga16   Y           Y
svga256  Y           Y
egavga   Y           Y
*)

CONST
    standalone = TRUE;   (* //CHKME self-explanatory *)
CONST                    (* //CHKME "there can be only one !" and "insociabile regnum" *)
    svga16     = TRUE;
    svga256    = FALSE;
    egavga     = FALSE;

(* //CHKME *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ProgEXEname = "BGIDEMO";
CONST
    errNone = 0;
    errHelp = 1;
    errOr   = 255; (* kolossal finesse *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
VAR
    S:str128;
BEGIN
    CASE e OF
    | errNone :
        ;
    | errHelp :
        WrStr("Q&D BGI demo v1.0 by PhG");WrLn;
        WrLn;
(*%T standalone  *)
        S:="internal";
(*%E  *)
(*%F standalone  *)
        S:="external";
(*%E  *)
        WrStr("BGI libraries   : ");WrStr(S);WrLn;
(*%T egavga  *)
        S:="EGAVGA";
(*%E *)
(*%T svga16  *)
        S:="SVGA16";
(*%E  *)
(*%T svga256 *)
        S:="SVGA256";
(*%E  *)
        WrStr("Graphics module : ");WrStr(S);WrLn;
        e:=errNone;
    ELSE
        WrStr(ProgEXEname+" : "); WrStr(einfo); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

(* ------------------------------------------------------------ *)

TYPE
   string = str128;
   pchar  = POINTER TO CHAR;

(* ------------------------------------------------------------ *)

PROCEDURE dataToStr (VAR S : ARRAY OF CHAR; p : pchar );
VAR
    i:CARDINAL;
BEGIN
    i:=0;
    LOOP
        S[i]:= p^;
        IF p^=CHR(0) THEN EXIT; END;
        INC(i);
        Lib.IncAddr(p,1);
    END;
END dataToStr;

PROCEDURE Abort(Msg : string);
VAR
    S : str128;
BEGIN
    WrStr(Msg);  WrStr(" : ");
    dataToStr(S, grapherrormsg(graphresult() ));
    WrStr(S);    WrLn;
    abort(errOr,"BGI BIG problem !");
END Abort;

(* ------------------------------------------------------------ *)

PROCEDURE WhitePixel() : INTEGER; (* ugly *)
BEGIN
    IF getmaxcolor() > 256 THEN
        RETURN 32767;
    ELSE
        RETURN 15;
    END;
END WhitePixel;

PROCEDURE DetectVGA16 () : INTEGER;
BEGIN
    RETURN SVGA800x600x16;
END DetectVGA16;

PROCEDURE DetectVGA256 () : INTEGER;
BEGIN
    RETURN SVGA1024x768x256;
END DetectVGA256;

(* ------------------------------------------------------------ *)

VAR
    GraphDriver : INTEGER;
    GraphMode   : INTEGER;

    ch : CHAR;
    S  : str128;
    rc : INTEGER;
BEGIN
    WrLn;
    IF Lib.ParamCount() # 0 THEN abort(errHelp,"");END;

(*%T svga16 *)
    GraphDriver := installuserdriver("SVGA16", driverproc(DetectVGA16) );
(*%E  *)
(*%T svga256  *)
    GraphDriver := installuserdriver("SVGA256", driverproc(DetectVGA256) );
(*%E  *)




(* does NOT like forced FarADDRESS() : use ADR() instead *)

(*%T standalone  *)

(*%T svga16 *)
    rc:=registerfarbgidriver( ADR(Svga16_driver_far) );
(*%E  *)

(*%T svga256  *)
    rc:=registerfarbgidriver( ADR(Svga256_driver_far) );
(*%E  *)

(*%T egavga  *)
    rc:=registerfarbgidriver( ADR(EGAVGA_driver_far) );
(*%E  *)
    WrStr("rc          = ");IO.WrInt(rc,8);WrLn;
    WrStr("graphresult = ");IO.WrInt(graphresult(),8);WrLn;

    IF graphresult() # grOk THEN
        dataToStr(S, grapherrormsg(GraphDriver) );
        Str.Prepend (S,"Graphics register error : ");
        abort(errOr,S);
    END;

    rc:=registerfarbgifont( ADR(gothic_font_far) );
    rc:=registerfarbgifont( ADR(sansserif_font_far) );
    rc:=registerfarbgifont( ADR(small_font_far) );
    rc:=registerfarbgifont( ADR(triplex_font_far) );


(*%E  *)

(* ------------------------------------------------------------ *)

(*%T svga16 *)
    GraphMode   := SVGA800x600x16;
    initgraph(GraphDriver,GraphMode,"");
(*%E  *)

(*%T svga256  *)
    GraphMode   := SVGA1024x768x256;
    initgraph(GraphDriver,GraphMode,"SVGA256");
(*%E  *)

(*%T egavga  *)
    GraphDriver := VGA;
    GraphMode   := VGAHi;
    initgraph(GraphDriver,GraphMode,"");
(*%E  *)

    IF graphresult() # grOk THEN
        dataToStr(S, grapherrormsg(GraphDriver) );
        Str.Prepend (S,"Graphics init error : ");
        abort(errOr,S);
    END;

    dataToStr(S,getdrivername() );
    moveto(5,1);
    outtext(S);

    moveto(5, 25);
    outtext('Drivers and fonts were ');
    moveto(5, 40);
    settextstyle(GothicFont, HorizDir, 4);

(*%T standalone *)
    outtext('Built ');
(*%E  *)
(*%F standalone *)
    outtext('NOT Built ');
(*%E  *)

    settextstyle(SmallFont, HorizDir, 4);
    outtext('into ');
    settextstyle(TriplexFont, HorizDir, 4);
    outtext('EXE ');
    settextstyle(SansSerifFont, HorizDir, 4);
    outtext('file!');
    rectangle(0, 0, getx(), gety() + textheight('file!') + 1);

    setcolor( WhitePixel() );
    line(0,0,getmaxx(),getmaxy());
    line(0,getmaxy(),getmaxx(),0);

    ch:=IO.RdKey();IF ch=CHR(0) THEN ch:=IO.RdKey();END;
    closegraph;

    abort(errNone,"");
END BGIdemo.




(*

The BGI supplied with Borland's Turbo C compiler can be called
from TopSpeed languages. Header files are supplied (graphics.def)
for each language. If you use #link in your project file, the
relevent library will be included automatically if you include
one of these header files in any compilation in a project.

Note that the BGI can not be used in multi-thread model, as
Borland's drivers are not re-entrant. Large model is recommended.

The BGI library graphics.lib must be imported. GRAPHICS.PRJ must be present.

(((
model Large
import %O%M_clib graphics
include %N initexe
)))

SS should NOT be equal to DS in models with far data pointers.

Quels crtins !!! Ca semble ne marcher qu'avec les pilotes Borland !

# pragma link(attf,cgaf,egavgaf,hercf,ibm8514f,pc3270f)
# pragma link(svga16f,svga256f,vesa16f)
# pragma link(gothf,littf,sansf,tripf)
# pragma link(boldf,eurof,lcomf,scrif,simpf,tscrf)

*)