' ---------------------------------------------------------------
' Title         Q&D Factorize
' Overview
' Notes         M2, where are you ?
'               darn, after all those years of programming in Modula-2,
'               going back to Basic syntax is a huge step backwards :-(
'               note windows strongly forces us to use longints when mere integers were more than enough :-(
' Bugs          pbcc parser is crap : unable to catch overlapping cases, among other things...
'               this crap won't even catch a string without final "_" concatenator symbol !
'               it is not able to clearly detect missing or exessive parameters in functions
'               using colors may be corrupted by previous screen attributes : another PB "feature" !
'               constants cannot be defined in subs !

'               I've loved "missing declaration : j" error message at this line :
'                   FOR i = firstparm TO lastparm
'               because parser is not able to detect "firstparm" is undefined
'               (in fact, a typo for minparm) -- btw, where did "j" reference come from ???

'               doesn't support "incr(var)" but requires "incr var"
'               and among its useless functions, doesn't have useful "inc(var,value)" !

'               from 98SE, consout pretends output is not redirected... while in fact it IS !

'               due to poor and lose BASIC syntax, we no longer care about types : almost everything is LONG ! :-(

'               we wasted a few minutes wondering why errAborted was a no-no :
'               in fact, pb does not like us defining a dword constant,
'               reducing maxlongcard to maxlongint !
'               we have to use a global dword value to fake constant !!!

' Wish List     a JPI TS-like M2 compiler for Vindoze
'               could probably be ported to quad integers for larger factorizatons
' ---------------------------------------------------------------

#COMPILER   PBCC 5
#COMPILE    EXE
#DIM        ALL
#OPTION     VERSION3    ' 98SE for ever !

#INCLUDE    "WIN32API.INC"

'----------------------------------------------------------------------
'----------------------------------------------------------------------

' awful globerks, awful language, awful operating system...

'----------------------------------------------------------------------
'----------------------------------------------------------------------

MACRO CONST     = MACRO
MACRO boolean   = INTEGER
MACRO char      = STRING * 1
'MACRO longint   = LONG
MACRO longcard  = DWORD

'MACRO str256    = STRING * 256
'MACRO str128    = STRING * 128
'MACRO str32     = STRING * 32
'MACRO str16     = STRING * 16

CONST false     = 0
CONST true      = NOT(false)

CONST nl            = $CRLF
CONST digits        = "0123456789"
CONST hexdigitsCapsLows= "ABCDEFabcdef"
CONST dquote        = $DQ
CONST slash         = "/"
CONST dash          = "-"
CONST equal         = "="
CONST dot           = "."
CONST coma          = ","
CONST colon         = ":"
CONST delim         = ","
CONST tabul         = $TAB
CONST space         = $SPC
CONST backspace     = $BS
CONST escapekey     = $ESC
CONST blank         = space
CONST decdigits     = digits
CONST filteredChars = dot+coma

CONST mintrack      = 0
CONST minhead       = 0
CONST minsector     = 1
CONST FORCEBEST     = 0
'CONST FORCE255      = 255
'CONST FORCE240      = 240

'CONST MAXLONG       = 2147483647 ' max(longint)
'CONST maxlongcard   = 4294967295 ' pb changes it to maxlongint !
CONST winum         = 13 ' "#.###.###.###"

CONST msgWait = "Computing, please wait... "
'CONST kEsc    = 1 ' keep 9X happy at least from DOS, was 1024

' completely ridiculous : constants cannot be defined in procedures !

CONST maxsectorcount    = 63
CONST maxsectorcountalt = 255 ' desperate try to keep CARDINALs everywhere
CONST maxheadcount      = 255
CONST maxtrackcount     = MAXLONGCARD

CONST minfactentry = 0
CONST maxfactentry = 0
CONST minfactor    = 1 ' so we can flag using minfactor-1=0
CONST maxfactor    = 32+1 ' should do for at most 2^32 !
CONST ABORTED      = MAXlongCARD

TYPE factortype
       k    AS LONGcard
       flag AS boolean
END TYPE

GLOBAL factor() AS factortype

GLOBAL maxlongcard AS DWORD ' ugly trick required by compiler !

CONST minparm       = 1
CONST maxparm       = 10 ' why ? why not ?

'----------------------------------------------------------------------
'----------------------------------------------------------------------

CONST ProgEXEname       = "FACTORIZ32" ' yes, yes, exe.name$ gives it but we don't like possible renaming
CONST ProgTitle         = "Q&D32 Factorize"
CONST ProgVersion       = "v1.0"
CONST ProgCopyright     = "by PhG"
CONST Banner            = ProgTitle+" "+ProgVersion+" "+ProgCopyright

CONST errNone           = 0
CONST errHelp           = 1
CONST errOption         = 2
CONST errParameter      = 3
CONST errLongCard       = 4
CONST errTHSfailure     = 5
CONST errAborted        = 6

SUB abort (BYVAL e AS LONG, BYVAL einfo AS STRING)
    LOCAL S, errmsg AS STRING

    SELECT CASE e
    CASE errHelp
        '00000000011111111112222222222333333333344444444445555555555666666666677777777778
        '1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
        errmsg = Banner + nl +                                                              _
        nl+                                                                                 _
        "Syntax : "+progEXEname+" <number>... [option]..."+nl+                              _
        nl+                                                                                 _
        "   -p   (very slowly) check <number> found to be prime with alternate method"+nl+  _
        "   -l   show one factor per line"+nl+                                              _
        "   -r   do not beautify factors"+nl+                                               _
        "   -ths try and build TxHxS from <number>"+nl+                                     _
        "   -e   do not poll keyboard for Escape"+nl+                                       _
        nl+                                                                                 _
        "This program (slowly) factorizes specified <number>."+nl+                          _
        "<number> must belong to [0..~] range."+nl+                                         _
        "["+filteredChars+"] characters are filtered out from <number>."+nl+                _
        nl+                                                                                 _
        "Examples : "+progEXEname+" 16,481,808 20,016,864"+nl+                              _
        "           "+progEXEname+" -ths 160,086,528"+nl+                                   _
        "           "+progEXEname+" -p 01.02.1963"+nl

        subst(errmsg,"~",LTRIM$(STR$(maxlongcard)))

    CASE errOption          : S="Unknown ~ option !"
    CASE errParameter       : S="Unexpected ~ parameter !"
    CASE errLongCard        : S="Illegal ~ number !"
    CASE errTHSfailure      : S="~ would not translate to valid TxHxS !"
    CASE errAborted         : S="Aborted by user !"
    CASE ELSE
                              S="This is illogical, Captain !"
    END SELECT

    SELECT CASE e
    CASE errNone
        '
    CASE errHelp
        wrstr errmsg
    CASE ELSE
        subst (s , "~" , dquote+einfo+dquote )
        s=ProgEXEname+" : "+s+nl
        wrstr s
    END SELECT
    exitProcess e ' cdwd
END SUB

'----------------------------------------------------------------------
'----------------------------------------------------------------------

SUB wrstr (BYVAL s AS STRING)
STDOUT s; ' yes, a semicolon here just to remind us of M2 syntax -- ah ah, only serious...
END SUB

SUB wrln ()
STDOUT nl; ' see wrstr() supra
END SUB

' replace first because REPLACE replaces all -- case sensitive

SUB subst(BYREF s AS STRING, BYVAL oldstr AS STRING, BYVAL newstr AS STRING)
    LOCAL p AS LONG
    LOCAL r AS STRING

    p = INSTR(s,oldstr)
    IF p <> 0 THEN
        r = LEFT$(s,p-1)+newstr+MID$(s,p+LEN(oldstr))
        s = r
    END IF
END SUB

SUB replaceall (BYREF s AS STRING, BYVAL oldstr AS STRING, BYVAL newstr AS STRING)
REPLACE oldstr WITH newstr IN s
END SUB

FUNCTION getParamCount() AS LONG
    LOCAL n AS LONG
    LOCAL s AS STRING

    n=0
    DO
        s=COMMAND$(n+1)
        IF s="" THEN EXIT LOOP
        INCR n
    LOOP
    FUNCTION=n
END FUNCTION

SUB uppercase (BYREF s AS STRING)
    s = UCASE$(s)
END SUB

SUB lowercase (BYREF s AS STRING)
    s = LCASE$(s)
END SUB

FUNCTION isOption(BYVAL s AS STRING) AS boolean
    LOCAL c AS char
    LOCAL rc AS boolean

    c = LEFT$(s,1)
    SELECT CASE c
    CASE dash,slash
        rc=true
    CASE ELSE
        rc=false
    END SELECT
    FUNCTION=rc
END FUNCTION

' if what has leading "/" or "-", we assume it's an option

FUNCTION getOptIndex (BYVAL ignorecase AS boolean, BYVAL separateur AS char, BYVAL what AS STRING, BYVAL list AS STRING) AS LONG
IF isOption(what)=true THEN what=MID$(what,2) ' how elegant... :-(
FUNCTION = getListIndex(ignorecase,separateur,what,list)
END FUNCTION

FUNCTION getListIndex (BYVAL ignorecase AS boolean, BYVAL separateur AS char, BYVAL what AS STRING, BYVAL list AS STRING) AS LONG
    LOCAL i AS LONG
    LOCAL s AS STRING
    LOCAL p AS LONG

    IF ignorecase = true THEN
        uppercase (what)
        uppercase (list)
    END IF
    subst (what, equal,colon)       ' cli xxx= becomes xxx:
    replaceall (list, equal,colon)  ' all xxx= become xxx:

    what=TRIM$(what,ANY space+tabul)
    i=1
    DO
        s=PARSE$(list,separateur,i)
        s=TRIM$(s, ANY space+tabul)
        IF s = "" THEN
            i=0
            EXIT LOOP
        END IF
        IF INSTR(what,colon) = 0 THEN  ' normal option
            IF s = what THEN EXIT LOOP
        ELSE                        ' option with a number
            ' check what ("c:3") against s ("c:")
            p=INSTR(what,colon)
            IF LEFT$(what,p) = s THEN EXIT LOOP
        END IF
        INCR i
    LOOP
    FUNCTION = i ' cint
END FUNCTION

FUNCTION verifyString (BYVAL s AS STRING, BYVAL allowed AS STRING) AS boolean
    LOCAL rc AS boolean

    IF VERIFY (s, allowed) = 0 THEN
        rc= true
    ELSE
        rc= false
    END IF
    FUNCTION = rc
END FUNCTION

'----------------------------------------------------------------------
'----------------------------------------------------------------------

FUNCTION chkescape() AS boolean
    LOCAL kbd AS STRING
    LOCAL rc AS boolean
    rc = false
    kbd = INKEY$
    SELECT CASE LEN(kbd)
    CASE 0: ' empty buffer
    CASE 1: IF kbd = escapekey THEN rc=true
    CASE 2: ' function key
    CASE 4: ' mouse event
    END SELECT

    FUNCTION=rc
END FUNCTION

SUB video(BYVAL s AS STRING, BYREF tf AS boolean, BYVAL redirected AS boolean)
    LOCAL i AS LONG
    IF redirected = true THEN EXIT SUB
    IF tf = true THEN
        STDOUT s;
    ELSE
        FOR i = 1 TO LEN(s)
            STDOUT backspace;
        NEXT
    END IF
END SUB

FUNCTION fmtme (BYVAL v AS LONGcard, BYVAL wi AS INTEGER, BEAUTIFY AS BOOLEAN) AS STRING
    LOCAL s AS STRING
    IF BEAUTIFY = true THEN
        S=beautifiedlc (v,blank,dot,wi)
    ELSE
        S=fmtlc (v,10,wi,blank,"")
    END IF
    FUNCTION=s
END FUNCTION

FUNCTION beautifiedlc (BYVAL v AS LONGcard, BYVAL pad AS char, BYVAL sep AS char, zfield AS INTEGER) AS STRING
    LOCAL S,R  AS STRING
    LOCAL slen,i AS LONG
    LOCAL ok AS boolean
    LOCAL ch  AS CHAR

    s=STR$(v): s=LTRIM$(s)

    slen=LEN(s)
    R = ""
    FOR i = 1 TO slen
        r=MID$(s,slen-i+1,1)+r
        IF i < slen THEN
            IF (i MOD 3) = 0 THEN
                r=sep+r
            END IF
        END IF
    NEXT
    DO
        IF LEN(r) >= ABS(zfield) THEN EXIT DO
        IF zfield < 0 THEN
            r=r+pad ' right alignment
        ELSE
            r=pad+r
        END IF
    LOOP
    FUNCTION = r
END FUNCTION

'----------------------------------------------------------------------
'----------------------------------------------------------------------

FUNCTION chkPrime (BYVAL num AS LONGcard, BYVAL POLLESC AS boolean, BYVAL DEBUG AS BOOLEAN, _
                    BYVAL redirected AS boolean) AS LONG
    LOCAL n AS LONGcard
    LOCAL rc AS LONG

    rc= minfactor
    IF num=2 THEN FUNCTION=rc:EXIT FUNCTION ' 2 is prime
    'video(msgWait,TRUE,redirected)
    n=2 ' BFI : not the fastest way but it works
    DO
        IF ( num MOD n ) = 0 THEN rc=maxfactor: EXIT DO
        INCR n
        IF n >= num THEN EXIT DO
        IF POLLESC = true THEN
            IF ChkEscape()=true THEN FUNCTION =ABORTED: EXIT FUNCTION
        END IF
    LOOP
    'video(msgWait,FALSE,redirected)
    FUNCTION= rc
END FUNCTION

FUNCTION factorize (BYVAL where AS LONG, BYVAL v AS LONGcard, _
                    BYVAL POLLESC AS boolean, BYVAL DEBUG AS BOOLEAN) AS LONG
    LOCAL i,ndx AS LONG
    LOCAL quotient, divisor,added AS LONGcard

    ndx=minfactor-1
    ' handle trivial cases
    IF v = 0 THEN FUNCTION=ndx:EXIT FUNCTION
    IF v = 1 THEN
        INCR ndx
        factor(where,ndx).k=v
        factor(where,ndx).flag=TRUE
        FUNCTION=ndx
        EXIT FUNCTION
    END IF

    FOR i=1 TO 2
        SELECT CASE i
        CASE 1: divisor = 2
        CASE 2: divisor = 3
        END SELECT
        DO
            IF trydiv (quotient, v,divisor,DEBUG) = true THEN
                INCR ndx
                IF ndx > maxfactor THEN FUNCTION= minfactor-1:EXIT FUNCTION ' should never happen
                factor(where,ndx).k=divisor
                factor(where,ndx).flag=TRUE
                v=quotient
                IF quotient < divisor THEN FUNCTION=ndx:EXIT FUNCTION
            ELSE
                EXIT LOOP ' or exit do thanks to silly syntax alternatives
            END IF
            IF POLLESC=true  THEN
                IF ChkEscape()=true THEN FUNCTION = ABORTED:EXIT FUNCTION
            END IF
        LOOP
    NEXT

    'after 2 and 3, gen next prime (5, 7, 11, 13, 17, 19, 23, 25, 29, 31...)
    'by adding alternatively 2 then 4 to previous value

    added = 2
    divisor = divisor + added ' 3+2=5
    DO
        IF trydiv (quotient,v,divisor,DEBUG)=true THEN
            INCR ndx
            IF ndx  > maxfactor THEN FUNCTION =minfactor-1 : EXIT FUNCTION
            factor(where,ndx).k   =divisor
            factor(where,ndx).flag=TRUE
            v=quotient
            IF quotient < divisor THEN FUNCTION= ndx: EXIT FUNCTION
        ELSE
            divisor = divisor + added
            IF added=2 THEN
                added=4
            ELSE ' is 4
                added=2
            END IF
        END IF
        IF POLLESC=true THEN
            IF ChkEscape()=true THEN FUNCTION = ABORTED:EXIT FUNCTION
        END IF
    LOOP
    FUNCTION = ndx
END FUNCTION

FUNCTION trydiv (BYREF q AS LONGcard, BYVAL v AS LONGcard, BYVAL d AS LONGcard, _
                BYVAL DEBUG AS BOOLEAN) AS BOOLEAN
    LOCAL rc AS boolean
    q = v \ d
IF DEBUG=true THEN
WrStr("value = "):      WrStr(fmtlc(v,10,winum,blank,""))
WrStr("  divisor = "):  WrStr(fmtlc(d,10,winum,blank,""))
WrStr("  quotient = "): WrStr(fmtlc(q,10,winum,blank,""))
WrLn
END IF
    IF v = (q * d) THEN
        rc=true
    ELSE
        rc=false
    END IF
    FUNCTION=rc
END FUNCTION

'----------------------------------------------------------------------
'----------------------------------------------------------------------

FUNCTION fmtlc (BYVAL v AS LONGcard, BYVAL nbase AS LONG, BYVAL wi AS INTEGER, _
                BYVAL ch AS char, BYVAL prefix AS CHAR) AS STRING
    LOCAL r AS STRING
    LOCAL i AS LONG
    IF nbase = 16 THEN
        r=HEX$(v)
    ELSE
        r=STR$(v) : r=LTRIM$(r)
    END IF

    FOR i= LEN(R)+1 TO ABS(wi)
        IF wi < 0 THEN
            r=r+ch
        ELSE
            r=ch+r
        END IF
    NEXT
    IF nbase=16 THEN lowercase(r)
    r=prefix+r
    FUNCTION = r
END FUNCTION

SUB filter (BYREF r AS STRING, BYVAL filtered AS STRING)
    LOCAL i AS LONG
    LOCAL s AS STRING
    LOCAL ch AS char

    s=""
    FOR i=1 TO LEN(r)
        ch = MID$(r,i,1)
        IF verifystring(ch,filtered)=false THEN s=s+ch ' //
    NEXT
    r=s
END SUB

FUNCTION getvallc (BYVAL s AS STRING, BYREF v AS LONGcard) AS boolean
    LOCAL legalchars,schk AS STRING
    LOCAL rc AS boolean

    legalchars = digits
    IF LEFT$(s,1)="$" THEN
        schk=MID$(s,2)
        s="&H0"+schk ' leading "0" retrieves an unsigned value (what a silly syntax hack !)
        uppercase(s) ' useless for pb
        legalchars = legalchars + hexdigitsCapsLows
    ELSE
        schk=s
    END IF
    IF verifystring(schk,legalchars)=true THEN
        v=VAL(s) ' crappy BASIC won't let us check conversion was ok
        rc=true
    ELSE
        rc = false
    END IF
    FUNCTION=rc
END FUNCTION

' yes, yes, WORDs and not LONGCARDs

FUNCTION buildTHSfromTOTAL (BYREF maxTrack AS LONGcard, _
                            BYREF maxHead AS LONGcard, BYREF maxSector AS LONGcard, _
                            BYVAL BESTFIT AS LONG, BYVAL totalSectors AS LONGcard, _
                            BYVAL POLLESC AS boolean, BYVAL DEBUG AS BOOLEAN, _
                            BYVAL redirected AS boolean) AS BOOLEAN
    LOCAL rebuilt,v,quotient AS LONGcard
    LOCAL t,h,s,smax AS LONGcard
    LOCAL headcount,trackcount,sectorcount AS LONGcard ' word
    LOCAL retry,ndx,ndxref AS LONG
    LOCAL rc AS BOOLEAN

    rc=TRUE
    retry = 1
    DO
        v=totalSectors
        SELECT CASE retry
        CASE  1
            s=maxsectorcount ' try 63 first
            IF trydiv(quotient, v,s,DEBUG)=true THEN
                v=quotient
            ELSE
                s=0
            END IF
            smax = maxsectorcount
        CASE  2
            s=0
            smax = maxsectorcountalt
        END SELECT
        'video(msgWait,true,redirected)
        ndx=factorize(minfactentry,v,POLLESC,DEBUG)
        'video(msgWait,false,redirected)
        IF ndx=ABORTED THEN
            maxTrack = ABORTED
            maxHead  = ABORTED
            maxSector= ABORTED
            FUNCTION = FALSE
            EXIT FUNCTION
        END IF

        IF s = 0 THEN s=findinfact(minfactentry,ndx,smax)
        h=findinfact(minfactentry,ndx,maxheadcount)
        t=findinfact(minfactentry,ndx,maxtrackcount)

        trackcount  = t
        headcount   = h
        sectorcount = s
        ' as usual with BASIC, let compiler take care of casts :-(
        rebuilt     = trackcount * headcount * sectorcount
        IF rebuilt = totalSectors THEN EXIT DO
        INCR retry
        IF retry > 2 THEN rc=FALSE : EXIT DO
    LOOP
    maxTrack    = trackcount + mintrack -1
    maxHead     = headcount  + minhead  -1
    maxSector   = sectorcount+ minsector-1
    FUNCTION =rc
END FUNCTION

FUNCTION findinfact (BYVAL where AS LONG, BYVAL ndx AS LONG, BYVAL limit AS LONGcard) AS LONGcard
    LOCAL v, k AS LONGcard
    LOCAL i AS LONG

    v = 1
    i = ndx+1
    DO
        DECR i
        IF i < minfactor THEN EXIT DO
        IF factor(where,i).flag = true THEN
            k=factor(where,i).k
            IF v * k <= limit THEN
                factor(where,i).flag = FALSE ' no longer useable
                v = v * k
            END IF
        END IF
    LOOP
    FUNCTION =  v
END FUNCTION

' yes, yes, only v needs to be a longcard

SUB showTHS (BYVAL t AS longcard, BYVAL h AS longcard, BYVAL s AS longcard, _
            BYVAL v AS longcard, BYVAL BEAUTIFY AS boolean)
    LOCAL r AS STRING
    LOCAL wi AS LONG
    R = "~ = ~ x ~ x ~"
    wi=1
    Subst(R,"~",fmtme(v,wi,BEAUTIFY))
    Subst(R,"~",fmtme( t-mintrack+1 ,wi,BEAUTIFY))
    Subst(R,"~",fmtme( h-minhead+1  ,wi,BEAUTIFY))
    Subst(R,"~",fmtme( s-minsector+1,wi,BEAUTIFY))
    WrStr(R)
    WrLn
END SUB

SUB showfactors (BYVAL what AS LONG, BYVAL ndx AS LONG, BYVAL num AS longcard, _
                BYVAL ONEPERLINE AS boolean , BYVAL BEAUTIFY AS BOOLEAN)
    LOCAL s AS STRING
    LOCAL v AS LONGcard
    LOCAL i,wi AS LONG

    IF ONEPERLINE=true  THEN
        wi= winum
    ELSE
        wi= 1
    END IF
    S=fmtme(num,wi,BEAUTIFY)
    WrStr(S)
    IF ndx = minfactor THEN
        WrStr(" is prime."):WrLn: EXIT SUB
    ELSE
        WrStr(" = ")
        IF ONEPERLINE = true THEN WrLn
    END IF
    FOR i=minfactor TO ndx
        v=factor(what,i).k
        S=fmtme(v,wi,BEAUTIFY)
        WrStr(S)
        IF ONEPERLINE = true THEN
            IF i < ndx THEN WrLn
        ELSE
            IF i < ndx THEN WrStr(" x ")
        END IF
    NEXT
    WrLn
END SUB

SUB showPrimeStatus (BYVAL ndx AS LONG, BYVAL num AS LONGcard, _
                    BYVAL ONEPERLINE AS boolean, BYVAL BEAUTIFY AS BOOLEAN)
    LOCAL S AS STRING
    LOCAL wi AS LONG

    IF ONEPERLINE = true THEN
        wi= winum
    ELSE
        wi= 1
    END IF
    S=fmtme(num,wi,BEAUTIFY)
    WrStr(S)
    IF ndx = minfactor THEN
        S=" is prime indeed. :-)"
    ELSE
        S=" does not look so prime at second sight. :-("
    END IF
    WrStr(S)
    WrLn
END SUB

'----------------------------------------------------------------------
'----------------------------------------------------------------------

FUNCTION PBMAIN()
    LOCAL ONEPERLINE,BEAUTIFY,THSMODE,PARANOIA,POLLESC,DEBUG,redirected AS BOOLEAN
    LOCAL lastparm,parmcount,i,optndx AS LONG
    LOCAL s,r AS STRING
    LOCAL v AS LONGcard
    LOCAL ndx AS LONGcard
    LOCAL maxTrack,maxHead,maxSector AS LONGcard
    LOCAL parm() AS STRING

    DIM factor (minfactentry TO maxfactentry, minfactor TO maxfactor) AS factortype

    DIM parm (minparm TO maxparm) AS STRING

    ' DO NOT FORGET TO INITIALIZE FAKE DWORD LONGCARD CONSTANT !!!
    maxlongcard = 4294967295 ' if we have maxlongcard as a constant, it becomes maxlongint !

    WrLn
    parmcount = getParamCount()
    IF parmcount = 0 THEN abort(errHelp,"")

    IF ISTRUE (CONSOUT) THEN
        redirected = true
    ELSE
        redirected = false
    END IF
    redirected = true ' hack to ignore CONSOUT lying about redirection !

    PARANOIA   = FALSE
    ONEPERLINE = FALSE
    BEAUTIFY   = TRUE
    POLLESC    = TRUE
    THSMODE    = FALSE
    DEBUG      = FALSE

    lastparm  = minparm-1
    FOR i = 1 TO parmcount
        s=COMMAND$(i)
        replaceall (s, tabul, blank)
        r=s
        UpperCase(R)
        IF isOption(R) = true THEN
            OPTndx = GetOptIndex    (true,delim,R,                                             _
                                    "?"+delim+"H"+delim+"HELP"+delim+                        _
                                    "L"+delim+"ONEPERLINE"+delim+                            _
                                    "R"+delim+"RAW"+delim+                                   _
                                    "THS"+delim+                                             _
                                    "P"+delim+"PRIME"+delim+"PARANOIA"+delim+                _
                                    "E"+delim+"ESC"+delim+                                   _
                                    "DEBUG"                                                  _
                                    )
            SELECT CASE optndx
            CASE 1,2,3 :    abort(errHelp,"")
            CASE 4,5 :      ONEPERLINE = TRUE
            CASE 6,7 :      BEAUTIFY   = FALSE
            CASE 8:         THSMODE    = TRUE
            CASE 9,10,11 :  PARANOIA   = TRUE
            CASE 12,13 :    POLLESC    = FALSE
            CASE 14 :       DEBUG      = TRUE
            CASE ELSE :     abort(errOption,S) ' could be errHelp, eh eh !
            END SELECT
        ELSE
            INCR lastparm
            IF lastparm > maxparm THEN abort(errParameter,S)
            parm(lastparm) = R
        END IF
    NEXT
    IF lastparm = minparm-1 THEN abort(errHelp,"")

    FOR i = minparm TO lastparm
        S = parm(i)
        filter(S,filteredChars)
        IF getvallc (S, v)=true THEN
            IF THSMODE = true THEN
                IF buildTHSfromTOTAL (maxTrack,maxHead,maxSector, _
                                     FORCEBEST,v,POLLESC,DEBUG,redirected)=true  THEN
                    showTHS(maxTrack,maxHead,maxSector,v,BEAUTIFY)
                ELSE
                    ndx=0
                    IF maxTrack= ABORTED THEN INCR ndx
                    IF maxHead=  ABORTED THEN INCR ndx
                    IF maxSector=ABORTED THEN INCR ndx
                    IF ndx=3 THEN abort(errAborted,"")
                    abort(errTHSfailure,S)
                END IF
            ELSE
                'video(msgWait,true,redirected)
                ndx=factorize(minfactentry,v,POLLESC,DEBUG)
                'video(msgWait,false,redirected)
                IF ndx=ABORTED THEN abort(errAborted,"")
                showfactors(minfactentry,ndx,v,ONEPERLINE,BEAUTIFY)
                IF PARANOIA = true THEN
                    IF ndx=minfactor THEN
                        ndx=chkPrime(v,POLLESC,DEBUG,redirected)
                        IF ndx=ABORTED THEN abort(errAborted,"")
                        showPrimeStatus(ndx,v,ONEPERLINE,BEAUTIFY)
                    END IF
                END IF
            END IF
        ELSE
            abort(errLongCard,S)
        END IF
        IF ONEPERLINE = true THEN
            IF i < lastparm THEN WrLn
        END IF
    NEXT
    abort errNone,""
END FUNCTION
