
' handle decimal separator allowing US as well as FR ? bah...

' v1.0b : added ugly globerk hack in order to fix a weird problem :
'         ONLY when typing in local the same value as in dollaros,
'         program would fetch data from dollaros
'         and would focus to clipboard button !

' yes, DOLLEUROS was much better a name but everyone is used to DOLLAROS now...
' also YOURIS for those Greek-speaking people (cf Besson's chronicle)


Option Explicit
DefInt A-Z

Global Const fromDOLLAROS = 0
Global Const fromLOCAL = 1

Sub doCopyToClipboard ()
Dim s$, r$, t$
s$ = f!txtDollaros.Text
r$ = f!txtLocal.Text

If Val(s$) > 1! Then
    t$ = gDollarosPlural$
Else
    t$ = gDollarosSingular$
End If
s$ = s$ + " " + t$

If Val(r$) > 1! Then
    t$ = gLocalPlural$
Else
    t$ = gLocalSingular$
End If
r$ = r$ + " " + t$

clipboard.SetText s$ + Chr$(13) + Chr$(10) + r$ + Chr$(13) + Chr$(10)

End Sub

Sub doQuit ()
savePosition f, ini$, sSection$, eXtsr$, eYtsr$
f.Hide
Unload f
End
End Sub

Function fixtrailing$ (ByVal s$)
Dim c$, r$
If s$ = "" Then
    r$ = s$
Else
    c$ = Right$(s$, 1)
    If InStr("0123456789", c$) = 0 Then
        r$ = Left$(s$, Len(s$) - 1)
    Else
        r$ = s$
    End If
End If
fixtrailing$ = r$
End Function

Sub main ()
Dim cli$, s$, i%

Set f = frmMain

' If isRunning%() = True Then quit False ' just in case

getDirectories windir$, sysdir$
exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$

f.AutoRedraw = True
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = FIXED_SINGLE
f.Caption = Caption$
f.WindowState = NORMAL

f.KeyPreview = False ' default therefore useless

resetPosition f, ini$, sSection$, eXtsr$, eYtsr$
retrieveParameters

s$ = "0."
For i = 1 To gDecimals%
    s$ = s$ + "#"
Next
gDisplayFormat$ = s$

f!lblDollaros.Caption = gLblDollaros
f!lblLocal.Caption = gLblLocal
f!txtDollaros.Text = ""
f!txtLocal.Text = ""
f!txtDollaros.MaxLength = MAXINPUT
f!txtLocal.MaxLength = MAXINPUT

f.Show
End Sub

Function processKey% (ByVal fromwhere%, ByVal keycode%, ctl As Control)
Dim c As Control
Dim c2 As Control
Dim s$, key$
Dim k!, v!
' directly replacing with TAB forces a sound alarm !
Select Case keycode%
Case KEY_BACK:
Case KEY_NUMPAD0, KEY_NUMPAD1, KEY_NUMPAD2, KEY_NUMPAD3, KEY_NUMPAD4:
Case KEY_NUMPAD5, KEY_NUMPAD6, KEY_NUMPAD7, KEY_NUMPAD8, KEY_NUMPAD9:
Case Asc("0"), Asc("1"), Asc("2"), Asc("3"), Asc("4"):
Case Asc("5"), Asc("6"), Asc("7"), Asc("8"), Asc("9"):
Case KEY_DECIMAL, Asc("."): keycode% = Asc(",")
Case Asc(","):
Case KEY_RETURN:  ' avoid invisible editbox
    ' //V10B ugly hack instead of "if c = f!txtDollaros"
    Select Case fromwhere%
    Case fromDOLLAROS
        Set c = f!txtDollaros
        Set c2 = f!txtLocal
        k! = gDollarosToLocal!
        key$ = "{TAB}"
    Case fromLOCAL
        Set c = f!txtLocal
        Set c2 = f!txtDollaros
        k! = 1! / gDollarosToLocal!
        key$ = "+{TAB}" ' shift-tab
    End Select

    s$ = c.Text
    If wasValidValue%(s$, v!) Then
        s$ = Format$(v!, gDisplayFormat$)
        s$ = fixtrailing$(s$)
        c.Text = s$

        v! = v! * k!
        s$ = Format$(v!, gDisplayFormat$)
        s$ = fixtrailing$(s$)
        c2.Text = s$
    End If

    SendKeys key$
    keycode% = 0 ' disable silly default beep
Case Else
    keycode% = 0
End Select
processKey% = keycode%
End Function

Function wasValidValue% (ByVal s$, v!)
Dim p%
Do
    p% = InStr(s$, ",")
    If p% = 0 Then Exit Do
    s$ = Left$(s$, p% - 1) + "." + Mid$(s$, p% + 1)
Loop

v! = Val(s$)
wasValidValue% = True
End Function
