Option Explicit
DefInt A-Z


Sub fmtDHfr (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, i1$, i2$, i3$)
formatdh v#, dsg$, dpl$, hsg$, hpl$, " et ", i2$
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Else
        i1$ = beforeFR1$: i3$ = beforeFR3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Else
        i1$ = afterFR1$: i3$ = afterFR3$
    End Select
End Select
End Sub

Sub fmtDHMfr (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, ByVal msg$, ByVal mpl$, i1$, i2$, i3$)
formatdhm v#, dsg$, dpl$, hsg$, hpl$, msg$, mpl$, " et ", i2$
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Else
        i1$ = beforeFR1$: i3$ = beforeFR3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Else
        i1$ = afterFR1$: i3$ = afterFR3$
    End Select
End Select
End Sub

Sub fmtDHMus (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, ByVal msg$, ByVal mpl$, i1$, i2$, i3$)
formatdhm v#, dsg$, dpl$, hsg$, hpl$, msg$, mpl$, " and ", i2$
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Else
        i1$ = beforeUS1$: i3$ = beforeUS3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Else
        i1$ = afterUS1$: i3$ = afterUS3$
    End Select
End Select
End Sub

Sub fmtDHus (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, i1$, i2$, i3$)
formatdh v#, dsg$, dpl$, hsg$, hpl$, " and ", i2$
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Else
        i1$ = beforeUS1$: i3$ = beforeUS3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Else
        i1$ = afterUS1$: i3$ = afterUS3$
    End Select
End Select
End Sub

Function fmtit$ (ByVal v#, ByVal singular$, ByVal plural$)
Dim r$
r$ = Trim$(Str$(v#)) + " "
Select Case v#
Case Is < LESSTHANTWO ' 0 or 1
    r$ = r$ + singular$
Case Else
    r$ = r$ + plural$
End Select
fmtit$ = r$
End Function

Sub fmtRealFR (ByVal v#, ByVal singular$, ByVal plural$, i1$, i2$, i3$)
i2$ = Trim$(Str$(Abs(v#))) + " "
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Is < LESSTHANTWO
        i1$ = beforeFR1$: i2$ = i2$ + singular$: i3$ = beforeFR3$
    Case Else
        i1$ = beforeFR1$: i2$ = i2$ + plural$: i3$ = beforeFR3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityFR$: i3$ = ""
    Case Is < LESSTHANTWO
        i1$ = afterFR1$: i2$ = i2$ + singular$: i3$ = afterFR3$
    Case Else
        i1$ = afterFR1$: i2$ = i2$ + plural$: i3$ = afterFR3$
    End Select
End Select
End Sub

Sub fmtRealUS (ByVal v#, ByVal singular$, ByVal plural$, i1$, i2$, i3$)
i2$ = Trim$(Str$(Abs(v#))) + " "
Select Case v#
Case Is < 0
    v# = Abs(v#)
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Is < LESSTHANTWO
        i1$ = beforeUS1$: i2$ = i2$ + singular$: i3$ = beforeUS3$
    Case Else
        i1$ = beforeUS1$: i2$ = i2$ + plural$: i3$ = beforeUS3$
    End Select
Case Else
    Select Case v#
    Case Is < NEARLYZERO
        i1$ = "": i2$ = verityUS$: i3$ = ""
    Case Is < LESSTHANTWO
        i1$ = afterUS1$: i2$ = i2$ + singular$: i3$ = afterUS3$
    Case Else
        i1$ = afterUS1$: i2$ = i2$ + plural$: i3$ = afterUS3$
    End Select
End Select
End Sub

Sub formatdh (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, ByVal et$, i2$)
Dim d#, h#
Dim dd$, hh$
v# = Abs(v#) ' en heures
d# = vint#(v# / 60#) ' en jours
h# = vint#(vmod#(v#, 60#)) ' en heures
dd$ = fmtit$(d#, dsg$, dpl$)
hh$ = fmtit$(h#, hsg$, hpl$)
i2$ = dd$ + et$ + hh$
End Sub

Sub formatdhm (ByVal v#, ByVal dsg$, ByVal dpl$, ByVal hsg$, ByVal hpl$, ByVal msg$, ByVal mpl$, ByVal et$, i2$)
Dim d#, h#, m#
Dim dd$, hh$, mm$
v# = Abs(v#) ' en minutes
m# = vint#(vmod#(v#, 60#)) ' en minutes
v# = vint#(v# / 60#)
h# = vint#(vmod#(v#, 24#)) ' en heures
d# = vint#(v# / 24#) ' en jours
dd$ = fmtit$(d#, dsg$, dpl$)
hh$ = fmtit$(h#, hsg$, hpl$)
mm$ = fmtit$(m#, msg$, mpl$)
i2$ = dd$ + ", " + hh$ + et$ + mm$
End Sub

Function getMonthFR$ (ByVal n%)
Dim s$
Select Case n%
Case 1: s$ = "janvier"
Case 2: s$ = "fvrier"
Case 3: s$ = "mars"
Case 4: s$ = "avril"
Case 5: s$ = "mai"
Case 6: s$ = "juin"
Case 7: s$ = "juillet"
Case 8: s$ = "aot"
Case 9: s$ = "septembre"
Case 10: s$ = "octobre"
Case 11: s$ = "novembre"
Case 12: s$ = "dcembre"
End Select
getMonthFR$ = s$
End Function

Function getMonthUS$ (ByVal n%)
Dim s$
Select Case n%
Case 1: s$ = "January"
Case 2: s$ = "February"
Case 3: s$ = "March"
Case 4: s$ = "April"
Case 5: s$ = "May"
Case 6: s$ = "June"
Case 7: s$ = "July"
Case 8: s$ = "August"
Case 9: s$ = "September"
Case 10: s$ = "October"
Case 11: s$ = "November"
Case 12: s$ = "December"
End Select
getMonthUS$ = s$
End Function

Function getWeekDayFR$ (ByVal n%)
Dim s$
Select Case n%
Case 0: s$ = "dimanche"
Case 1: s$ = "lundi"
Case 2: s$ = "mardi"
Case 3: s$ = "mercredi"
Case 4: s$ = "jeudi"
Case 5: s$ = "vendredi"
Case 6: s$ = "samedi"
End Select
getWeekDayFR$ = s$
End Function

Function getWeekDayUS$ (ByVal n%)
Dim s$
Select Case n%
Case 0: s$ = "Sunday"
Case 1: s$ = "Monday"
Case 2: s$ = "Tuesday"
Case 3: s$ = "Wednesday"
Case 4: s$ = "Thursday"
Case 5: s$ = "Friday"
Case 6: s$ = "Saturday"
End Select
getWeekDayUS$ = s$
End Function

