Option Explicit
DefInt A-Z

' globerk...

' for icon and form positions

Global Const eXtsr$ = "Xtsr"
Global Const eYtsr$ = "Ytsr"

Global Const eDollarosToLocal = "DollarosToLocal"
Global Const eDecimals = "Decimals"
Global Const eDollarosSingular = "DollarosSingular"
Global Const eDollarosPlural = "DollarosPlural"
Global Const eLocalSingular = "LocalSingular"
Global Const eLocalPlural = "LocalPlural"
Global Const eLblDollaros = "LblDollaros"
Global Const eLblLocal = "LblFrancs"

Global Const dDollarosToLocal! = 6.55957!
Global Const dDecimals% = 2
Global Const dDollarosSingular$ = "unit en monnaie d'occupation"
Global Const dDollarosPlural$ = "units en monnaie d'occupation"
Global Const dLocalSingular = "franc"
Global Const dLocalPlural = "francs"
Global Const dLblDollaros = "Dollaros"
Global Const dLblLocal = "Francs"

Global gXtsr%
Global gYtsr%
Global gDollarosToLocal!
Global gDecimals%
Global gDollarosSingular$
Global gDollarosPlural$
Global gLocalSingular$
Global gLocalPlural$
Global gLblDollaros$
Global gLblLocal$

' app

Global Const INIext$ = ".INI"

Global Const caption$ = "Q&D Dollaros v1.0b"
Global Const sSection$ = "Dollaros" ' use exe name !

Global Const MAXINPUT = 40

' global vars (easier with vb piece of crap, and saves typing too !)

Global f As form

Global windir$
Global sysdir$

Global exedir$
Global ini$

Global gDisplayFormat$ ' "0.##"

Sub retrieveParameters ()
Dim s$

s$ = readIni$(ini$, sSection$, eDollarosToLocal$)
gDollarosToLocal! = getReal!(s$, dDollarosToLocal!)

s$ = readIni$(ini$, sSection$, eDecimals$)
gDecimals% = getInt%(s$, dDecimals%)

s$ = readIni$(ini$, sSection$, eDollarosSingular$)
If s$ = "" Then s$ = dDollarosSingular$
gDollarosSingular$ = s$

s$ = readIni$(ini$, sSection$, eDollarosPlural$)
If s$ = "" Then s$ = dDollarosPlural$
gDollarosPlural$ = s$

s$ = readIni$(ini$, sSection$, eLocalSingular$)
If s$ = "" Then s$ = dLocalSingular$
gLocalSingular$ = s$

s$ = readIni$(ini$, sSection$, eLocalPlural$)
If s$ = "" Then s$ = dLocalPlural$
gLocalPlural$ = s$

s$ = readIni$(ini$, sSection$, eLblDollaros$)
If s$ = "" Then s$ = dLblDollaros$
gLblDollaros$ = s$

s$ = readIni$(ini$, sSection$, eLblLocal$)
If s$ = "" Then s$ = dLblLocal$
gLblLocal$ = s$

End Sub
