Option Explicit
DefInt A-Z

' app

Global Const Title$ = "2000 v1.0"
Global Const culprit$ = "by PhG"

Global Const sSection$ = "2000"

' globerk

Global gBackground$
Global gPicture$
Global gRows%
Global gColumns%
Global gBang%
Global gBangFile$
Global gGameOver%
Global gGameOverFile$
Global gPaper&
Global gSpeed% ' smiley animation
Global gFullScreen%
Global gAlwaysOnTop%
Global gParadeSpeed%
Global gParadeDeltaX%
Global gPauseBefore%
Global gPauseAfter%
Global gFaster%

Global gXpos%
Global gYpos%

' ini entries

Global Const eBackground$ = "Background"
Global Const ePicture$ = "Picture"
Global Const eRows$ = "Rows"
Global Const eColumns$ = "Columns"
Global Const eBang$ = "Bang"
Global Const eBangFile$ = "BangFile"
Global Const eGameOver$ = "GameOver"
Global Const eGameOverFile$ = "GameOverFile"
Global Const ePaper$ = "Paper"
Global Const eSpeed$ = "Speed"
Global Const eFullScreen$ = "FullScreen"
Global Const eAlwaysOnTop$ = "AlwaysOnTop"
Global Const eParadeSpeed$ = "ParadeSpeed"
Global Const eParadeDeltaX$ = "ParadeDeltaX"
Global Const ePauseBefore$ = "PauseBefore"
Global Const ePauseAfter$ = "PauseAfter"
Global Const eFaster$ = "Faster"

Global Const eXpos$ = "Xpos"
Global Const eYpos$ = "Ypos"

' defaults

Global Const dBackground$ = "2000.bmp"' 2xxx
Global Const dPicture$ = "2000a.bmp" ' end.bmp smileys
Global Const dRows% = 4 ' for 2000a.bmp
Global Const dColumns% = 5 ' for 2000a.bmp
Global Const dBang% = True
Global Const dBangFile$ = "2000a.wav" ' rifle.wav
Global Const dGameOver% = True
Global Const dGameOverFile$ = "2000b.wav" ' t2excel.wav
Global Const dPaper& = &H30303   ' black background
Global Const dSpeed% = 100
Global Const dFullScreen% = True
Global Const dAlwaysOnTop% = True
Global Const dParadeSpeed% = 1
Global Const dParadeDeltaX% = 1
Global Const dPauseBefore% = 2
Global Const dPauseAfter% = 2
Global Const dFaster% = True

Global Const dXpos% = -1
Global Const dYpos% = -1

' common globerks
' global vars (easier with vb piece of crap, and saves typing too !)

Global f As form

Global windir$
Global sysdir$

Global exedir$ ' avoid repeated getexepath$()
Global ini$

' common globerk constants

Global Const INIext$ = ".INI"
Global Const lY$ = "Y"
Global Const lN$ = "N"

' screen dimensions

Global XscreenInPixels%
Global YscreenInPixels%

' for animation

Global lastframe%

Global Const ONESECOND = 1000 ' in milliseconds
Global Const FIRSTFRAME = 0

Global Const FIRSTSMILEY = 0 ' 3 smileys
Global Const LASTSMILEY = 2

' still globerks because of this vb piece of crap !

Global Const BUILDBACKGROUND% = 0
Global Const BUILD2000% = 1
Global Const PAUSEBEFORE% = 2
Global Const PAUSEAFTER% = 3
Global Const ANIMATE% = 4

Global gTIMEREVENT%

Global gXposanim!
Global gXtarget!
Global gXposanimdelta!
Global gSmiley%
Global gOVER%

Global gCountdown%

Global gCurrentFrame%

Sub retrieveParameters ()
Dim s$
Dim flag%
Dim i%

s$ = readIni$(ini$, sSection$, eBackground$)
If s$ = "" Then s$ = dBackground$
gBackground$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, ePicture$)
If s$ = "" Then s$ = dPicture$
gPicture$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, eRows$)
gRows% = getInt%(s$, dRows%)
s$ = readIni$(ini$, sSection$, eColumns$)
gColumns% = getInt%(s$, dColumns%)

s$ = readIni$(ini$, sSection$, eBang$)
gBang% = getBool%(s$, dBang%)
s$ = readIni$(ini$, sSection$, eBangFile$)
If s$ = "" Then s$ = dBangFile$
gBangFile$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, eGameOver$)
gGameOver% = getBool%(s$, dGameOver%)
s$ = readIni$(ini$, sSection$, eGameOverFile$)
If s$ = "" Then s$ = dGameOverFile$
gGameOverFile$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, ePaper$)
If s$ = "" Then
    gPaper& = dPaper&
Else
    gPaper& = Val(rgbToHex$(s$))
End If

s$ = readIni$(ini$, sSection$, eSpeed$)
gSpeed% = getInt%(s$, dSpeed%)

s$ = readIni$(ini$, sSection$, eFullScreen$)
gFullScreen% = getBool%(s$, dFullScreen%)

s$ = readIni$(ini$, sSection$, eAlwaysOnTop$)
gAlwaysOnTop% = getBool%(s$, dAlwaysOnTop%)

s$ = readIni$(ini$, sSection$, eParadeSpeed$)
gParadeSpeed% = getInt%(s$, dParadeSpeed%)

s$ = readIni$(ini$, sSection$, eParadeDeltaX$)
gParadeDeltaX% = getInt%(s$, dParadeDeltaX%)

s$ = readIni$(ini$, sSection$, ePauseBefore$)
gPauseBefore% = getInt%(s$, dPauseBefore%)

s$ = readIni$(ini$, sSection$, ePauseAfter$)
gPauseAfter% = getInt%(s$, dPauseAfter%)

s$ = readIni$(ini$, sSection$, eFaster$)
gFaster% = getBool%(s$, dFaster%)

s$ = readIni$(ini$, sSection$, eXpos$)
gXpos% = getInt%(s$, dXpos%)
s$ = readIni$(ini$, sSection$, eYpos$)
gYpos% = getInt%(s$, dYpos%)

End Sub

