'
' part of Q&D Tools QDTOOLS.ZIP archive (c) by PhG
'

Option Explicit
DefInt A-Z

Sub doAbout ()
Dim s$, lf$
lf$ = Chr$(10)
s$ = progTitle$ + lf$ + lf$
s$ = s$ + "Yet Another Useless Program" + lf$ + lf$
s$ = s$ + "by" + lf$ + lf$
s$ = s$ + progCulprit$
doMsg "About...", True, s$
End Sub

Sub doCells (ByVal n%)
Dim s$
Dim rc%

Select Case n%
Case 3 To 8
    ' ok
Case Else
    n% = dCells%
End Select
f!mnu3.Checked = False
f!mnu4.Checked = False
f!mnu5.Checked = False
f!mnu6.Checked = False
f!mnu7.Checked = False
f!mnu8.Checked = False

Select Case n%
Case 3
    f!mnu3.Checked = True
Case 4
    f!mnu4.Checked = True
Case 5
    f!mnu5.Checked = True
Case 6
    f!mnu6.Checked = True
Case 7
    f!mnu7.Checked = True
Case 8
    f!mnu8.Checked = True
End Select
lastCell% = n%

s$ = intToStr$(lastCell%)
rc% = writeini%(ini$, sSection$, eCells$, s$)

initBoard lastCell%
End Sub

Sub doEndGame ()
Dim s$, nl$
If clicks& > 0 Then
    nl$ = Chr$(10)
    s$ = "Even after" + nl$ + nl$
    s$ = s$ + Mid$(Str$(clicks&), 2) + " click"
    If clicks& > 1 Then s$ = s$ + "s"
    s$ = s$ + nl$ + nl$
    s$ = s$ + "you have not won !"
    doMsg "Loser", False, s$
End If
doNewGame
End Sub

Sub doExit ()
quit True
End Sub

Sub doHelp ()
Dim s$, lf$
lf$ = Chr$(10)
s$ = "Try and pop down all the squares..." + lf$
s$ = s$ + "if possible !" + lf$ + lf$
s$ = s$ + "There is NO warranty" + lf$
s$ = s$ + "it can always be done ! ;-)" + lf$ + lf$
s$ = s$ + "Only one square left raised is" + lf$
s$ = s$ + "Easy level." + lf$ + lf$
s$ = s$ + "No square left raised is" + lf$
s$ = s$ + "Hard level."
doMsg "Help...", False, s$
End Sub

Sub doLevel (ByVal noteasy%)
Dim s$
Dim rc%
If noteasy% Then
    f!mnuEasy.Checked = False
    f!mnuHard.Checked = True
    difficult% = True
Else
    f!mnuEasy.Checked = True
    f!mnuHard.Checked = False
    difficult% = False
End If
s$ = boolToStr$(difficult%)
rc% = writeini%(ini$, sSection$, eDifficult$, s$)
End Sub

Sub doNewGame ()
doCells lastCell%
doLevel difficult%
End Sub

Sub doPush (ByVal index%)
Dim leftraised%, i%, x%, y%, won%
Dim s$, nl$
clicks& = clicks& + 1
updateneighborhood index%
leftraised% = 0
i% = firstCellIndex%
For y% = minCell To lastCell%
    For x% = minCell To lastCell%
        If f!button(i%).BevelOuter = SS_BEVELINNER_RAISED Then
            leftraised% = leftraised% + 1
        End If
        i% = i% + 1
    Next
Next

won% = False
If difficult% Then
    If leftraised% = 0 Then won% = True
Else
    If leftraised% <= 1 Then won% = True
End If
If won% Then
    nl$ = Chr$(10)
    s$ = "It took you" + nl$ + nl$
    s$ = s$ + Mid$(Str$(clicks&), 2) + " click"
    If clicks& > 1 Then s$ = s$ + "s"
    s$ = s$ + nl$ + nl$
    s$ = s$ + "but you won !"
    doMsg "Winner", False, s$
    doNewGame
End If
End Sub

Function getrndrange% (ByVal lower, ByVal upper)
Dim tmp%
tmp% = Rnd
tmp% = Rnd
getrndrange% = Int((upper% - lower% + 1) * Rnd + lower%)
End Function

Sub initBoard (ByVal lastCell%)
Dim i%, x%, y%
Dim hauteur!, largeur!

largeur! = (f.Width \ lastCell%) \ screen.TwipsPerPixelX
hauteur! = (f.Width \ lastCell%) \ screen.TwipsPerPixelY

i% = firstCellIndex%
For y% = minCell To lastCell%
    For x% = minCell To lastCell%
        f!button(i%).Visible = False
        i% = i% + 1
    Next
Next

i% = firstCellIndex%
For y% = minCell To lastCell%
    For x% = minCell To lastCell%
        f!button(i%).Width = largeur!
        f!button(i%).Height = hauteur!
        f!button(i%).Left = largeur! * (x% - minCell)
        f!button(i%).Top = hauteur * (y% - minCell)
        i% = i% + 1
    Next
Next

i% = firstCellIndex%
For y% = minCell To lastCell%
    For x% = minCell To lastCell%
        f!button(i%).BevelOuter = SS_BEVELINNER_RAISED ' not pushed
        f!button(i%).Visible = True
        i% = i% + 1
    Next
Next

Randomize
' now init cellinfo
For y% = minCell To lastCell%
    For x% = minCell To lastCell%
        cellinfo(x%, y%).flipN = getrndrange%(0, 1)
        cellinfo(x%, y%).flipS = getrndrange%(0, 1)
        cellinfo(x%, y%).flipE = getrndrange%(0, 1)
        cellinfo(x%, y%).flipW = getrndrange%(0, 1)
    Next
Next

clicks& = 0
End Sub

Sub main ()
Dim flag%, i%, x%, y%
Dim s$

Set f = frmPusher ' default, just in case
Set ff = frmMsg ' ditto

If isRunning%() Then quit False ' just in case

f.Hide
f.AutoRedraw = True
f.ScaleMode = PIXELS
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = FIXED_SINGLE
f.Caption = progTitle$
f.WindowState = NORMAL

' include title bar and menu heights
f.Height = f.Width + screen.TwipsPerPixelY * (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU))

exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$
If fileExists%(ini$) Then
    flag% = SW_SHOW
    restoreWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$, flag%
    If f.Top = 0 And f.Left = 0 Then centerform f
    flag% = SW_HIDE
    restoreWindowPosition ff, ini$, sSection$, eXtsrIconMsg$, eYtsrIconMsg$, eXtsrMsg$, eYtsrMsg$, flag%
    If ff.Top = 0 And ff.Left = 0 Then centerform ff
Else
    centerform f
    centerform ff
End If

s$ = readini$(ini$, sSection$, eCells$)
lastCell% = getInt%(s$, dCells%)
s$ = readini$(ini$, sSection$, eDifficult$)
difficult% = getBool%(s$, dDifficult%)

' now create board for maximum cell
i% = firstCellIndex%
f!button(i%).Caption = ""
f!button(i%).BevelWidth = 2
For y% = minCell To maxCell%
    For x% = minCell To maxCell%
        If i% <> firstCellIndex% Then Load f!button(i%)
        i% = i% + 1
    Next
Next

doNewGame

f.Show
End Sub

Sub quit (ByVal savepos%)
If savepos% Then saveWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$
While forms.Count > 0
    forms(0).Hide
    Unload forms(0)
Wend
End
End Sub

Sub toggleCell (ByVal x%, ByVal y%)
Dim index%
If x% < minCell% Then x% = lastCell%
If y% < minCell% Then y% = lastCell%
If x% > lastCell% Then x% = minCell%
If y% > lastCell% Then y% = minCell%

index% = (y% - minCell%) * lastCell% + (x% - minCell%)
If f.button(index%).BevelOuter = SS_BEVELINNER_RAISED Then
    f.button(index%).BevelOuter = SS_BEVELINNER_INSET
Else
    f.button(index%).BevelOuter = SS_BEVELINNER_RAISED
End If
End Sub

Sub updateneighborhood (ByVal index%)
Dim x%, y%
x% = index% Mod lastCell%
y% = index% \ lastCell%
x% = x% + minCell%
y% = y% + minCell%

toggleCell x%, y%

If cellinfo(x%, y%).flipN = 1 Then toggleCell x%, y% - 1
If cellinfo(x%, y%).flipS = 1 Then toggleCell x%, y% + 1
If cellinfo(x%, y%).flipE = 1 Then toggleCell x% + 1, y%
If cellinfo(x%, y%).flipW = 1 Then toggleCell x% - 1, y%
End Sub

