Option Explicit
DefInt A-Z

Sub doScreenAfter (fo As Form)
fo.Caption = fmtInt$(currentStep%) ' + "..."
currentStep% = currentStep% - 1
If currentStep% < 0 Then
    fo!tmrAfter.Enabled = False
    Unload fo
    End
End If
End Sub

Sub doScreenAnimation (fo As Form)
Dim motion%
motion% = 1
' some day, allow specification of # of frames !
currentStep% = currentStep% + motion%
If currentStep% > lastFrame% Then
    fo!tmrTimer.Enabled = False
    If gGameOver% Then playsound gGameOverFile$
    currentStep% = gAfter%
    'fo!tmrAfter.interval = ONESECOND
    If gAfter% > 0 Then
        fo!tmrAfter.Enabled = True
    Else
        cursorON
    End If
Else
    fo!picAnimation.Picture = fo!picSteps.GraphicCell(currentStep%) ' new frame
End If
End Sub

Sub doScreenBefore (fo As Form)
fo.Caption = fmtInt$(currentStep%) ' + "..."
currentStep% = currentStep% - 1
If currentStep% < 0 Then
    f!tmrBefore.Enabled = False
    f.Caption = "" ' Title$ ' + " " + culprit$
    If gBang% Then playsound gBangFile$
    currentStep% = FIRSTFRAME
    f!tmrTimer.Enabled = True
End If
End Sub

Sub doScreenMain ()

Set f = frmScreen

retrieveParameters

If fileExists%(gPicture$) = False Then doHelpMain

If gBang% Then gBang% = fileExists%(gBangFile$)
If gGameOver% Then gGameOver% = fileExists%(gGameOverFile$)

lastFrame% = gRows * gColumns% - 1

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = SINGLEFIXED
f.Caption = "" ' Title$ ' + " " + culprit$
f.BackColor = gPaper&
f.ScaleMode = PIXELS

'f!picSteps.ScaleMode = PIXELS
f!picSteps.Picture = LoadPicture("") ' clear just in case
f!picSteps.Picture = LoadPicture(gPicture$)
f!picSteps.Rows = gRows%
f!picSteps.Cols = gColumns%

f!picAnimation.ScaleMode = PIXELS
f!picAnimation.BorderStyle = NONE
' f!picAnimation.AutoSize = False ' default is false
' resize animation window to fit BMP
f!picAnimation.Height = (f!picSteps.Height) \ gRows% ' do NOT use \ integer division here !
f!picAnimation.Width = (f!picSteps.Width) \ gColumns% ' ditto

Select Case gFullScreen%
Case True ' center animation window
    f.WindowState = MAXIMIZED
    ' eh eh, values were not updated because form is not shown yet !
    ' let's do it anyway
    f!picAnimation.Left = (xScreenInPixels - f!picAnimation.Width) / 2
    f!picAnimation.Top = (yScreenInPixels% - GetSystemMetrics(SM_CYCAPTION) - f!picAnimation.Height) / 2
Case False ' resize form window to animation window
    f.Left = gXpos%
    f.Top = gYpos%
    f.WindowState = NORMAL
    f!picAnimation.Left = 0' upper left of form
    f!picAnimation.Top = 0
    ' now resize form to fit picture
    ' warning : should include title bar height!!!
    f.Height = screen.TwipsPerPixelY * (f!picAnimation.Height + GetSystemMetrics(SM_CYCAPTION))
    f.Width = screen.TwipsPerPixelX * f!picAnimation.Width
    If ((gXpos% = dXpos%) And (gYpos% = dYpos%)) Then centerform f
End Select
' show animation first step
f!picAnimation.Picture = f!picSteps.GraphicCell(FIRSTFRAME)
f.Show

initStayOnTop f, gAlwaysOnTop%

cursorOFF

f!tmrTimer.Enabled = False
f!tmrTimer.Interval = gSpeed%
f!tmrBefore.Enabled = False
f!tmrBefore.Interval = ONESECOND
f!tmrAfter.Enabled = False
f!tmrAfter.Interval = ONESECOND

If gBefore% > 0 Then
    currentStep% = gBefore%
    'fo!tmrBefore.interval = ONESECOND
    f!tmrBefore.Enabled = True
Else
    If gBang% Then playsound gBangFile$
    currentStep% = FIRSTFRAME
    f!tmrTimer.Enabled = True
End If
End Sub

Sub doScreenQuit (fo As Form)
fo!tmrTimer.Enabled = False
fo!tmrBefore.Enabled = False
fo!tmrAfter.Enabled = False
cursorON ' just in case
If gBang% Or gGameOver% Then stopSound
If fo.WindowState = NORMAL Then
    savePosition fo, ini$, sSection$, eYpos$, eXpos$
End If
End Sub

Sub initStayOnTop (f As Form, ByVal flag%)
Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Dim rc%
Select Case flag%
Case True
    rc% = SetWindowPos%(f.hWnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
Case False
    rc% = SetWindowPos%(f.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
End Select
End Sub

