Option Explicit
DefInt A-Z

Sub beautifyScreen ()
Dim ximg!, yimg!
Dim xdt!, ydt!
Dim xi1!, yi1!
Dim xi2!, yi2!
Dim xi3!, yi3!
Dim yy!
Dim flag%

' first, reset fonts, colors and display alignment

f.BackColor = Val(savPaperRGB$)

flag% = False
f!imgPicture.Visible = flag%
f!lblDateAndTime.Visible = flag%
f!lblInfo1.Visible = flag%
f!lblInfo2.Visible = flag%
f!lblInfo3.Visible = flag%

f!lblDateAndTime.FontName = savFontDateAndTime$
f!lblDateAndTime.FontBold = savBoldDateAndTime%
f!lblDateAndTime.FontSize = savSizeDateAndTime%
f!lblDateAndTime.ForeColor = Val(savInkRGBDateAndTime$)
f!lblDateAndTime.BackColor = Val(savPaperRGB$)
f!lblDateAndTime.Alignment = CENTER
f!lblDateAndTime.BackStyle = BACK_TRANSPARENT

f!lblInfo1.FontName = savFontCountdown$
f!lblInfo1.FontBold = savBoldCountdown%
f!lblInfo1.FontSize = savSizeCountdown%
f!lblInfo1.ForeColor = Val(savInkRGBCountdown$)
f!lblInfo1.BackColor = Val(savPaperRGB$)
f!lblInfo1.Alignment = CENTER
f!lblInfo1.BackStyle = BACK_TRANSPARENT

f!lblInfo2.FontName = savFontCountdown$
f!lblInfo2.FontBold = savBoldCountdown%
f!lblInfo2.FontSize = savSizeCountdown%
f!lblInfo2.ForeColor = Val(savInkRGBCountdown$)
f!lblInfo2.BackColor = Val(savPaperRGB$)
f!lblInfo2.Alignment = CENTER
f!lblInfo2.BackStyle = BACK_TRANSPARENT

f!lblInfo3.FontName = savFontCountdown$
f!lblInfo3.FontBold = savBoldCountdown%
f!lblInfo3.FontSize = savSizeCountdown%
f!lblInfo3.ForeColor = Val(savInkRGBCountdown$)
f!lblInfo3.BackColor = Val(savPaperRGB$)
f!lblInfo3.Alignment = CENTER
f!lblInfo3.BackStyle = BACK_TRANSPARENT

' normalize some dimensions

f!lblDateAndTime.Height = f!lblInfo1.Height

f!lblInfo2.Height = f!lblInfo1.Height
f!lblInfo2.Width = f!lblInfo1.Width

f!lblInfo3.Height = f!lblInfo1.Height
f!lblInfo3.Width = f!lblInfo1.Width

' center controls in X

ximg! = (f.ScaleWidth - f!imgPicture.Width) / 2

xdt! = (f.ScaleWidth - f!lblDateAndTime.Width) / 2

xi1! = (f.ScaleWidth - f!lblInfo1.Width) / 2
xi2! = xi1!
xi3! = xi1!

' center controls in Y

Select Case savShowDateAndTime%
Case True
    f!lblDateAndTime.Visible = True
    yy! = f!imgPicture.Height + f!lblDateAndTime.Height
    ydt! = (f.ScaleHeight - yy!) / 2
    yimg! = ydt! + f!lblDateAndTime.Height
Case False
    f!lblDateAndTime.Visible = False
    yy! = f!imgPicture.Height
    ydt! = (f.ScaleHeight - yy!) / 2
    yimg! = ydt! ' not a problem here for label is not to be seen
End Select

yy! = f!lblInfo1.Height + f!lblInfo2.Height + f!lblInfo3.Height
yy! = f!imgPicture.Height - yy!
yi1! = yimg! + yy! / 2
yi2! = yi1! + f!lblInfo2.Height
yi3! = yi2! + f!lblInfo3.Height

f!imgPicture.Left = ximg!
f!imgPicture.Top = yimg!

f!lblDateAndTime.Left = xdt!
f!lblDateAndTime.Top = ydt!

f!lblInfo1.Left = xi1!
f!lblInfo1.Top = yi1!
f!lblInfo2.Left = xi2!
f!lblInfo2.Top = yi2!
f!lblInfo3.Left = xi3!
f!lblInfo3.Top = yi3!

flag% = True
f!imgPicture.Visible = flag%
f!lblDateAndTime.Visible = flag%
f!lblInfo1.Visible = flag%
f!lblInfo2.Visible = flag%
f!lblInfo3.Visible = flag%

End Sub

Sub chkSound (ByVal m%, ByVal s%)
If savChimeAtHour% Then
    If ((m% = 0) And (s% = 0)) Then
        If HourBell% = 0 Then
            playtune True, savHourSound$
            HourBell% = 1
        End If
    Else
        HourBell% = 0
    End If
End If
If savChimeAtHalfHour% Then
    If ((m% = 30) And (s% = 0)) Then
        If HalfHourBell% = 0 Then
            playtune True, savHalfHourSound$
            HalfHourBell% = 1
        End If
    Else
        HalfHourBell% = 0
    End If
End If
End Sub

Sub computeJDTargetAndJDDeltaUT ()
Dim v#
Dim zDay#, zMonth#, zYear#

v# = savSSUT% / 60# ' seconds to minutes
v# = (savMMUT% + v#) / 60# ' minutes to hours
v# = (Abs(savHHUT%) + v#) / 24#  ' hours to days
If savHHUT% < 0 Then
    JDDeltaUT# = -v#
Else
    JDDeltaUT# = v#
End If

v# = savSS% / 60# ' seconds to minutes
v# = (savMM% + v#) / 60# ' minutes to hours
v# = (savHH% + v#) / 24#  ' hours to days
zDay# = savDay% + v#

JDTarget# = DateToJD#(zDay#, savMonth%, savYear%)
End Sub

Sub doScreenMain ()
Dim rc%
Dim fi$

Set f = frmScreen
cursorOFF ' before screen form is shown

retrieveParameters

computeJDTargetAndJDDeltaUT

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = NONE
f.Caption = ""
f.WindowState = MAXIMIZED
f.ScaleMode = PIXELS
centerform f

fi$ = savPictureFile$
If InStr(fi$, ":\") = 0 Then fi$ = exedir$ + fi$
If fileexists%(savPictureFile$) Then
    f!imgPicture.Picture = LoadPicture(fi$) ' now !
Else
    f!imgPicture.Picture = LoadPicture("")
End If
If savChimeAtHour% Then
    savChimeAtHour% = fileexists%(savHourSound$)
End If
If savChimeAtHalfHour% Then
    savChimeAtHalfHour% = fileexists%(savHalfHourSound$)
End If
If savChimeOnExit% Then
    savChimeOnExit% = fileexists%(savHourSound$)
End If

f!TimerScreen.Enabled = False
f!TimerScreen.Interval = Val(savRefreshInterval$)

f!TimerMoveScreen.Enabled = False
f!TimerMoveScreen.Interval = Val(savMoveInterval$) * 1000' seconds now in milliseconds

f.Show ' really does NOT like MODAL here !

beautifyScreen
updateScreen

playtune savChimeOnStart%, savHourSound$

newpos% = 0
motion% = Val(savMotion$)
maxmotion% = Val(savMaxMotion$)

justRunCount% = MINJUSTRUNCOUNT
HourBell% = 0
HalfHourBell% = 0

f!TimerMoveScreen.Enabled = True ' this one first
f!TimerScreen.Enabled = True

f.Visible = True ' silly because of previous f.show !

' make screen topmost and system modal
If FROZEN Then
    'in form_load event but again is really needed !!!
    stayOnTop f.hWnd, True
    SystemModal f.hWnd
End If
End Sub

Sub quitss ()
If (savPasswordProtected% And (gIgnorePassword% = False)) Then
    turnItOff% = False
    doGetPasswordMain
Else
    turnItOff% = True
End If
If turnItOff% Then quit
End Sub

Sub quitssMouse (ByVal x!, ByVal y!)
Static oldx!, oldy!
If justRunCount% <= MAXJUSTRUNCOUNT Then
    justRunCount% = justRunCount% + 1
    oldx! = x!
    oldy! = y!
    Exit Sub
End If
If (x! = oldx!) And (y! = oldy!) Then
    Exit Sub
End If
quitss ' here at last !
End Sub

Sub updatePositions ()
Dim c As control
newpos% = newpos% + motion%
If Abs(newpos%) > maxmotion% Then
    motion% = -motion%
    newpos% = newpos% + motion%
End If
Set c = f!lblDateAndTime
c.Left = c.Left + motion%
Set c = f!imgPicture
c.Left = c.Left + motion%
Set c = f!lblInfo1
c.Left = c.Left + motion%
Set c = f!lblInfo2
c.Left = c.Left + motion%
Set c = f!lblInfo3
c.Left = c.Left + motion%
End Sub

Sub updateScreen ()
Static olddmy$
Static oldhms$

Dim datetime As Variant
Dim dmy$, hms$
Dim jj%, mm%, aa%
Dim h%, m%, s%
Dim v#
Dim zJour#, zMois#, zAnnee#
Dim jour$, mois$, annee$
Dim heures$, minutes$, secondes$
Dim jjindex%, joursemaine$
Dim r$
Dim deltaDays#
Dim inDays#, inHours#, inMinutes#
Dim i1$, i2$, i3$
Dim vbjour%
' get current date and time

datetime = Now
dmy$ = Format$(datetime, "d m yyyy")
hms$ = Format$(datetime, "h n s")

'we can test hms for central infos are exact to the minute, not to the second
If hms$ = oldhms$ Then Exit Sub ' useless to check dmy$ too !
' If (hms$ = oldhms$) And (dmy$ = olddmy$) Then Exit Sub ' unlikely with 2/10 refresh interval !

' get j/m/a and h:m:s

jj% = Val(argv$(dmy$, 1))
mm% = Val(argv$(dmy$, 2))
aa% = Val(argv$(dmy$, 3))

h% = Val(argv$(hms$, 1))
m% = Val(argv$(hms$, 2))
s% = Val(argv$(hms$, 3))

chkSound m%, s%

' compute jd for now, taking deltaUT into account

v# = s% / 60# ' seconds to minutes
v# = (m% + v#) / 60# ' minutes to hours
v# = (h% + v#) / 24#  ' hours to days
zJour# = jj% + v#

JDnow# = DateToJD#(zJour#, mm%, aa%) + JDDeltaUT#

If savShowDateAndTime% Then
    
    If savShowUT% Then
        ' recalc j/m/a h:m:s for UT
        JDtoDate JDnow#, zJour#, zMois#, zAnnee#
        jjindex% = JDtoWeekday%(JDnow#)
    
        jj% = vint#(zJour#)
        mm% = vint#(zMois#)
        aa% = vint#(zAnnee#)

        zJour# = frac#(zJour#)
        h% = vint#(zJour# * 24#)
        m% = vint#(zJour# * 24# * 60#) Mod 60#
        s% = vint#(zJour# * 24# * 60# * 60#) Mod 60#
    Else
        vbjour% = Val(Format$(datetime, "w"))' 1=sunday 7=saturday
        jjindex% = vbjour% - 1 ' in vb, sunday = 1, in meeus, sunday = 0
    End If

    heures$ = Trim$(Str$(h%))
    minutes$ = Trim$(Str$(m%))
    If m% < 10 Then minutes$ = "0" + minutes$
    secondes$ = Trim$(Str$(s%))
    If s% < 10 Then secondes$ = "0" + secondes$
    annee$ = Trim$(Str$(aa%))

    Select Case savShowLanguage$
    Case "FR"
        joursemaine$ = getWeekDayFR$(jjindex%)
        If jj% = 1 Then
            jour$ = "1er"
        Else
            jour$ = Trim$(Str$(jj%))
        End If
        mois$ = getMonthFR$(mm%)
        Select Case savDateFormat$
        Case "DMY"
            r$ = jour$ + " " + mois$ + " " + annee$
        Case "MDY" ' illogical therefore ignored (should have been filtered anyway)
            r$ = jour$ + " " + mois$ + " " + annee$
        End Select
        'r$ = "Nous sommes le " + joursemaine$ + " " + r$
        'r$ = r$ + ", il est " + heures$ + "h " + minutes$ + "mn " + secondes$ + "s"
        r$ = joursemaine$ + " " + r$
        r$ = r$ + ", " + heures$ + "h " + minutes$ + "mn " + secondes$ + "s"

        If savShowUT% Then r$ = r$ + " T.U."
    Case "US"
        If h% < 10 Then heures$ = "0" + heures$

        joursemaine$ = getWeekDayUS$(jjindex%)
        jour$ = Trim$(Str$(jj%))
        mois$ = getMonthUS$(mm%)
        Select Case savDateFormat$
        Case "DMY"
            r$ = jour$ + " " + mois$ + " " + annee$
        Case "MDY"
            r$ = mois$ + " " + jour$ + ", " + annee$
        End Select
        'r$ = "Today is " + joursemaine$ + ", " + r$
        'r$ = r$ + ", time is " + heures$ + ":" + minutes$ + ":" + secondes$
        r$ = joursemaine$ + ", " + r$
        r$ = r$ + ", " + heures$ + ":" + minutes$ + ":" + secondes$
        If savShowUT% Then r$ = r$ + " U.T."
    End Select
    'r$ = r$ + Chr$(10) + dmy$ + " -- " + hms$ // DEBUG
    f!lblDateAndTime.Caption = r$
End If

deltaDays# = JDnow# - JDTarget#
' round
inDays# = vint#(deltaDays#)
inHours# = vint#(deltaDays# * 24#)
inMinutes# = vint#(deltaDays# * 24# * 60#)
Select Case savShowLanguage$
Case "FR"
    Select Case savRemainingFormat$
    Case "D" ' special if today included in count // to be checked
        If savIncludeTodayInDaysRemaining% Then inDays# = inDays + 1#
        fmtRealFR inDays#, "jour", "jours", i1$, i2$, i3$
    Case "H"
        fmtRealFR inHours#, "heure", "heures", i1$, i2$, i3$
    Case "M"
        fmtRealFR inMinutes#, "minute", "minutes", i1$, i2$, i3$
    Case "DH"
        fmtDHfr inHours#, "jour", "jours", "heure", "heures", i1$, i2$, i3$
    Case "DHM"
        fmtDHMfr inMinutes#, "jour", "jours", "heure", "heures", "minute", "minutes", i1$, i2$, i3$
    End Select
Case "US"
    Select Case savRemainingFormat$
    Case "D" ' special if today included in count // to be checked
        If savIncludeTodayInDaysRemaining% Then inDays# = inDays + 1#
        fmtRealUS inDays#, "day", "days", i1$, i2$, i3$
    Case "H"
        fmtRealUS inHours#, "hour", "hours", i1$, i2$, i3$
    Case "M"
        fmtRealUS inMinutes#, "minute", "minutes", i1$, i2$, i3$
    Case "DH"
        fmtDHus inHours#, "day", "days", "hour", "hours", i1$, i2$, i3$
    Case "DHM"
        fmtDHMus inMinutes#, "day", "days", "hour", "hours", "minute", "minutes", i1$, i2$, i3$
    End Select
End Select

f!lblInfo1.Caption = i1$
f!lblInfo2.Caption = i2$
f!lblInfo3.Caption = i3$

olddmy$ = dmy$
oldhms$ = hms$
End Sub

