Option Explicit
DefInt A-Z

Sub doScreenMain ()
Dim rc%

Set f = frmScreen
cursorOFF ' before screen form is shown

retrieveParameters

f!TimerNow.Enabled = False
f!TimerMove.Enabled = False

f.Visible = False
f.AutoRedraw = True ' ///
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = NONE
f.Caption = ""
f.WindowState = MAXIMIZED
f.ScaleMode = PIXELS

centerform f

f!TimerNow.Interval = gRefreshnow%
f!TimerMove.Interval = gNowMoveInterval% * 1000 ' seconds now in milliseconds \ 4
newpos% = 0' for lblNow
currMove% = gNowMove%

f.Show ' really does NOT like MODAL here !

prepareScreen

f.Visible = True ' silly because of previous f.show !

' make screen topmost and system modal
If FROZEN Then
    'in form_load event but again is really needed !!!
    stayOnTop f.hWnd, True
    SystemModal f.hWnd
End If

f!TimerNow.Enabled = True
f!TimerMove.Enabled = True ' this one first

updateDateTime

f!lblNow.Visible = gShowNow%

End Sub

Sub prepareScreen ()
Dim c As control
Dim i%
Dim s$
Dim x!, y!, w!, h!
Dim xxmin!, yymin!, xxmax!, yymax!
Dim xnow!, ynow!

f.BackColor = dPaper&

' for picpages
xxmin! = 0
yymin! = 0
xxmax! = screen.Width \ screen.TwipsPerPixelX + 1' obtain 640 or so now !
yymax! = screen.Height \ screen.TwipsPerPixelY + 1' obtain 480 or so now !

    Set c = f!lblNow
    c.Visible = False
    c.BorderStyle = NONE
    c.Visible = gShowNow%
    c.Alignment = CENTER
    c.BackStyle = BACK_TRANSPARENT
    c.Caption = ""
    c.BackColor = dPaper&
    c.ForeColor = gNowInk&
    c.FontName = gNowFont$
    Select Case gNowSize%
    Case kFONT8: s$ = "8.25"
    Case kFONT10: s$ = "9.75"
    Case kFONT12: s$ = "12"
    Case kFONT14: s$ = "13.5"
    Case Else: s$ = "13.5"
    End Select
    c.FontSize = Val(s$)
    c.FontBold = gNowBold%

    xnow! = (f.ScaleWidth - c.Width) / 2
    ynow! = (f.ScaleHeight - c.Height) / 2
    c.Left = xnow!
    c.Top = ynow!

End Sub

Sub quitss ()
If gPasswordProtected% Then
    turnItOff% = False
    doGetPasswordMain
Else
    turnItOff% = True
End If
If turnItOff% Then quit
End Sub

Sub quitssMouse (ByVal x!, ByVal y!)
Static oldx!, oldy!
If justRunCount% <= MAXJUSTRUNCOUNT Then
    justRunCount% = justRunCount% + 1
    oldx! = x!
    oldy! = y!
    Exit Sub
End If
If (x! = oldx!) And (y! = oldy!) Then
    Exit Sub
End If
quitss ' here at last !
End Sub

Sub updateDateTime ()
Static olddmy$
Static oldhms$
Static oldhm$
Static oldcaption$

Dim datetime As Variant

Dim dmy$, hms$, hm$

Dim jj%, mm%, aa%
Dim h%, m%, s%
Dim vbjour%, jjindex%

Dim r$

If gShowNow% = False Then Exit Sub

datetime = Now
dmy$ = Format$(datetime, "d m yyyy")
hms$ = Format$(datetime, "h n s")
hm$ = Format$(datetime, "h n")

If hms$ = oldhms$ Then
    Exit Sub
    r$ = oldcaption$
Else
    
    ' get j/m/a and h:m:s

    jj% = Val(argv$(dmy$, 1))
    mm% = Val(argv$(dmy$, 2))
    aa% = Val(argv$(dmy$, 3))

    h% = Val(argv$(hms$, 1))
    m% = Val(argv$(hms$, 2))
    s% = Val(argv$(hms$, 3))

    vbjour% = Val(Format$(datetime, "w"))' 1=sunday 7=saturday
    jjindex% = vbjour% - 1 ' in vb, sunday = 1, in meeus, sunday = 0
    
    r$ = fmtNow$(jj%, mm%, aa%, h%, m%, s%, jjindex%)

    olddmy$ = dmy$
    oldhms$ = hms$
    oldhm$ = hm$

    oldcaption$ = r$
End If
f!lblNow.Caption = r$
End Sub

Sub updateNowPosition ()
Dim c As control
newpos% = newpos% + currMove%
If Abs(newpos%) > gNowMaxMove% Then
    currMove% = -currMove%
    newpos% = newpos% + currMove%
End If
Set c = f!lblNow
c.Left = c.Left + currMove%
End Sub

