Option Explicit
DefInt A-Z

Sub doSetupCancel ()
Unload f
End Sub

Sub doSetupMain ()
Set f = frmSetup

retrieveParameters

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = False
' f.MaxButton = False
' f.MinButton = False
' f.BorderStyle = DOUBLEFIXED
f.Caption = title$ + " " + culprit$ + " : Setup"
f.WindowState = NORMAL

centerform f

showSetupParms

f.Show
f.Visible = True
End Sub

Sub doSetupOK ()
saveSetupParms
Unload f
End Sub

Sub saveSetupParms ()
Dim rc%
Dim s$
Dim i%

s$ = gPicture$
rc% = writeIni%(ini$, sSection$, ePicture$, s$)

s$ = fmtInt$(f!hbarRows.Value)
rc% = writeIni%(ini$, sSection$, eRows$, s$)
s$ = fmtInt$(f!hbarColumns.Value)
rc% = writeIni%(ini$, sSection$, eColumns$, s$)

s$ = fmtInt$(f!hbarSpeed.Value)
rc% = writeIni%(ini$, sSection$, eSpeed$, s$)

s$ = fmtInt$(f!hbarBefore.Value)
rc% = writeIni%(ini$, sSection$, eBefore$, s$)

s$ = fmtInt$(f!hbarAfter.Value)
rc% = writeIni%(ini$, sSection$, eAfter$, s$)

s$ = chkToStr$(f!chkFullScreen.Value)
rc% = writeIni%(ini$, sSection$, eFullScreen$, s$)
s$ = chkToStr$(f!chkAlwaysOnTop.Value)
rc% = writeIni%(ini$, sSection$, eAlwaysOnTop$, s$)

s$ = chkToStr$(f!chkBang.Value)
rc% = writeIni%(ini$, sSection$, eBang$, s$)
s$ = gBangFile$
rc% = writeIni%(ini$, sSection$, eBangFile$, s$)

s$ = chkToStr$(f!chkGameOver.Value)
rc% = writeIni%(ini$, sSection$, eGameOver$, s$)
s$ = gGameOverFile$
rc% = writeIni%(ini$, sSection$, eGameOverFile$, s$)

s$ = "&h" + Hex$(f!lblPaper.BackColor) + "&"
rc% = writeIni%(ini$, sSection$, ePaper$, s$)

' gXpos%
' gYpos%

End Sub

Sub showSetupParms ()
Dim c As Control
Dim s$
Dim crlf$

f!lblPicture.Alignment = LEFT_JUSTIFY
updateName gPicture$, f!lblPicture

Set c = f!hbarRows
c.Min = MINROW
c.Max = MAXROW
c.SmallChange = SMALLCHANGEROW
c.LargeChange = LARGECHANGEROW
c.Value = gRows%
f!lblRows.Alignment = CENTER
updateValue c, f!lblRows

Set c = f!hbarColumns
c.Min = MINCOLUMN
c.Max = MAXCOLUMN
c.SmallChange = SMALLCHANGECOLUMN
c.LargeChange = LARGECHANGECOLUMN
c.Value = gColumns%
f!lblColumns.Alignment = CENTER
updateValue c, f!lblColumns

Set c = f!hbarSpeed
c.Min = MINSPEED
c.Max = MAXSPEED
c.SmallChange = SMALLCHANGESPEED
c.LargeChange = LARGECHANGESPEED
c.Value = gSpeed%
f!lblSpeed.Alignment = CENTER
updateValue c, f!lblSpeed

Set c = f!hbarBefore
c.Min = MINBEFORE
c.Max = MAXBEFORE
c.SmallChange = SMALLCHANGEBEFORE
c.LargeChange = LARGECHANGEBEFORE
c.Value = gBefore%
f!lblBefore.Alignment = CENTER
updateValue c, f!lblBefore

Set c = f!hbarAfter
c.Min = MINAFTER
c.Max = MAXAFTER
c.SmallChange = SMALLCHANGEAFTER
c.LargeChange = LARGECHANGEAFTER
c.Value = gAfter%
f!lblAfter.Alignment = CENTER
updateValue c, f!lblAfter

f!chkFullScreen.Value = boolToChk%(gFullScreen%)
f!chkAlwaysOnTop.Value = boolToChk%(gAlwaysOnTop%)

f!chkBang.Value = boolToChk%(gBang%)
f!lblBangFile.Alignment = LEFT_JUSTIFY
updateName gBangFile$, f!lblBangFile

f!chkGameOver.Value = boolToChk%(gGameOver%)
f!lblGameOverFile.Alignment = LEFT_JUSTIFY
updateName gGameOverFile$, f!lblGameOverFile

f!lblPaper.Caption = ""
f!lblPaper.BackColor = gPaper&

' update if required
updateBangParms
updateGameOverParms
End Sub

Sub updateBangParms ()
Dim flag%
flag% = f!chkBang.Value
flag% = chkToBool%(flag%)
f!cmdPickBang.Enabled = flag%
End Sub

Sub updateGameOverParms ()
Dim flag%
flag% = f!chkGameOver.Value
flag% = chkToBool%(flag%)
f!cmdPickGameOver.Enabled = flag%
End Sub

Sub updateName (ByVal f$, c As Control)
If Right$(f$, 1) = "\" Then
    c.Caption = "" ' do not show directory, i.e. unselected file
Else
    c.Caption = LCase$(f$)
End If
End Sub

Sub updateValue (bar As Control, lbl As Control)
Dim s$
s$ = fmtInt$(bar.Value)
lbl.Caption = s$
End Sub

