
'
' part of Q&D Tools QDTOOLS.ZIP archive (c) by PhG
'


Option Explicit
DefInt A-Z

Function chkEXE% (ByVal f$, windowsheader&)
Dim hnd%
Dim addr%
Dim id$
Dim s$

hnd% = FreeFile
Open f$ For Binary As #hnd%
readWord hnd%, &H0, id$, addr%
If (id$ <> "MZ") And (id$ <> "ZM") Then
	Close #hnd%
	chkEXE% = False
	Exit Function
End If
readWord hnd%, &H18, id$, addr%
If addr% < &H40 Then
	Close #hnd%
	chkEXE% = False
	Exit Function
End If
readDword hnd%, &H3C, s$, windowsheader&
readWord hnd%, windowsheader&, id$, addr%
Close #hnd%
Select Case id$
Case "EN" ' NE Windows or OS/2 1.x segmented ("new") executable
    chkEXE% = True
Case Else
    chkEXE% = False
End Select
End Function

Sub doButtons ()
Dim c As Control
Dim he!, ypos!
' reference is lstSaver combon and big setup button
ypos! = f!lstSaver.Top + f!lstSaver.Height
he! = f!cmdSetup.Height

f!cmdRun.Visible = Not (gOneLine%)
f!cmdSetup.Visible = Not (gOneLine%)
f!cmdQuit.Visible = Not (gOneLine%)
f!cmdRunAlt.Visible = gOneLine%
f!cmdSetupAlt.Visible = gOneLine%
f!cmdQuitAlt.Visible = gOneLine%
If gOneLine% Then
    Set c = f!cmdSetupAlt
    c.Width = f!cmdSetup.Width / 3
    c.Height = he!
    c.Left = f!cmdSetup.Left
    c.Top = ypos!
    Set c = f!cmdRunAlt
    c.Width = f!cmdSetup.Width / 3
    c.Height = he!
    c.Left = f!cmdSetup.Width / 3
    c.Top = ypos!
    Set c = f!cmdQuitAlt
    c.Width = f!cmdSetup.Width / 3
    c.Height = he!
    c.Left = (f!cmdSetup.Width / 3) * 2
    c.Top = ypos!
    ypos! = ypos! + he!
Else
    ypos! = ypos! + he!
    Set c = f!cmdRun
    c.Width = f!cmdSetup.Width
    c.Height = he!
    c.Left = f!cmdSetup.Left
    c.Top = ypos!
    ypos! = ypos! + he!
    Set c = f!cmdQuit
    c.Width = f!cmdSetup.Width
    c.Height = he!
    c.Left = f!cmdSetup.Left
    c.Top = ypos!
    ypos! = ypos! + he!
End If
' include title bar !
f.Height = ypos! + screen.TwipsPerPixelY * (GetSystemMetrics(SM_CYCAPTION))
End Sub

Sub doCall (ByVal runit%, ByVal cli$)
Dim s$
Dim rc%
If cli$ = "" Then Exit Sub ' undefined default saver
Select Case runit%
Case True
    s$ = "S" ' save screen
    If gMinOnRun% Then
	If gRunAndQuit% = False Then
	    f.WindowState = MINIMIZED
	    DoEvents ' allow screen refresh
	End If
    End If
Case False
    s$ = "C" ' config
End Select
s$ = cli$ + " /" + s$
'MsgBox s$: Exit Sub
'rc% = Shell(s$, SW_SHOWMAXIMIZED)
rc% = winexec%(s$, SW_SHOWMAXIMIZED)
DoEvents
If runit% Then
    If gRunAndQuit% Then quit True
End If
End Sub

Sub doConfig ()
ff.Hide
ff!chkOneLine.Value = boolToChk%(gOneLine%)
ff!chkMinOnRun.Value = boolToChk%(gMinOnRun%)
ff!chkRunAndQuit.Value = boolToChk%(gRunAndQuit%)
ff.Show
End Sub

Sub doConfigCancel ()
ff.Hide
End Sub

Sub doConfigOK ()
Dim rc%
Dim s$

ff.Hide
rc% = ff!chkOneLine.Value
gOneLine% = chkToBool%(rc%)
rc% = ff!chkMinOnRun.Value
gMinOnRun% = chkToBool%(rc%)
rc% = ff!chkRunAndQuit.Value
gRunAndQuit% = chkToBool%(rc%)

s$ = boolToStr$(gOneLine%)
rc% = writeIni%(ini$, sSection$, eOneLine$, s$)
s$ = boolToStr$(gMinOnRun%)
rc% = writeIni%(ini$, sSection$, eMinOnRun$, s$)
s$ = boolToStr$(gRunAndQuit%)
rc% = writeIni%(ini$, sSection$, eRunAndQuit$, s$)

doButtons
End Sub

Function getdescription$ (ByVal f$, ByVal windowsheader&)
Dim hnd%
Dim s$
Dim tabledesnomsnonresidents&
Dim strlen%
Dim de$
Dim v%
Dim i%

hnd% = FreeFile
Open f$ For Binary As #hnd%
readDword hnd%, windowsheader& + &H2C, s$, tabledesnomsnonresidents&
readbyte hnd%, tabledesnomsnonresidents&, s$, strlen%
de$ = ""
For i% = 1 To strlen%
    readbyte hnd%, tabledesnomsnonresidents& + i%, s$, v%
    de$ = de$ + s$
Next
Close #hnd%

getdescription$ = de$
End Function

Function getpath$ (clist As Control, cpath As Control)
Dim ndx%

ndx% = clist.ListIndex
getpath$ = cpath.List(ndx%)
End Function

Sub main ()
Dim clist As Control
Dim cpath As Control
Dim includeHidden%
Dim filecount%
Dim flag%
Dim ndx%
Dim s$

Set f = frmMain

Set clist = f!lstSaver
Set cpath = f!lstPath

If isRunning%() = True Then quit False ' just in case

getDirectories windir$, sysdir$
exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$

defaultsaver$ = retrieveDefaultSaver$(windir$)

includeHidden% = True
retrieveNames clist, cpath, windir$, sysdir$, includeHidden%, defaultsaver$, filecount%
If filecount% = 0 Then quit False ' should not happen !

s$ = readini$(ini$, sSection$, eRunAndQuit$)
gRunAndQuit% = getBool%(s$, dRunAndQuit%)
s$ = readini$(ini$, sSection$, eMinOnRun$)
gMinOnRun% = getBool%(s$, dMinOnRun%)
s$ = readini$(ini$, sSection$, eOneLine$)
gOneLine% = getBool%(s$, dOneLine%)

doButtons

f.Hide
f.AutoRedraw = True
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = FIXED_SINGLE
f.Caption = Caption$
f.WindowState = NORMAL

cpath.Visible = False

flag% = SW_SHOW
restoreWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$, flag%

f.Show

' now for possible setup form

Set ff = frmConfig
ff.Hide
ff.AutoRedraw = True
' ff.ControlBox = true
' ff.MaxButton = False
' ff.MinButton = true
' ff.BorderStyle = FIXED_SINGLE
ff.Caption = Caption$
ff.WindowState = NORMAL
centerform ff

End Sub

Sub quit (ByVal savepos%)
If savepos% Then saveWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$
f.Hide
Unload f
End
End Sub

Sub readbyte (ByVal hnd%, ByVal position&, b$, bval%)
b$ = Chr$(0)
Get #hnd%, 1 + position&, b$ ' we MUST add one here because first byte is 1, not 0 !!!
bval% = Asc(b$)
End Sub

Sub readDword (ByVal hnd%, ByVal position&, dw$, dwval&)
Dim slo$
Dim wlo%
Dim shi$
Dim whi%
slo$ = "??"
shi$ = "??"
readWord hnd%, position&, slo$, wlo%
readWord hnd%, position& + 2, shi$, whi%
dwval& = whi% * 256 * 256 + wlo%
dw$ = shi$ + slo$
End Sub

Sub readWord (ByVal hnd%, ByVal position&, w$, wval%)
Dim lob$
Dim lo%
Dim hib$
Dim hi%
lob$ = "?"
hib$ = "?"
readbyte hnd%, position&, lob$, lo%
If EOF(hnd%) Then
    hi% = 0
    hib$ = ""
Else
    readbyte hnd%, position& + 1, hib$, hi%
End If
wval% = hi% * 256 + lo%
w$ = hib$ + lob$
End Sub

Function retrieveDefaultSaver$ (ByVal basedir$)
Dim s$
s$ = readini$(basedir$ + sysini$ + INIext$, sBoot$, eScrnSaveEXE$)
retrieveDefaultSaver$ = UCase$(s$)
End Function

Function retrievemodulename$ (ByVal pa$, ByVal s$)
Dim p%
Dim windowsheader&

If chkEXE%(pa$ + s$, windowsheader&) Then
    s$ = getdescription$(pa$ + s$, windowsheader&)
    p% = InStr(s$, ":")
    s$ = Mid$(s$, p% + 1)
    s$ = Trim(s$)
Else
    pa$ = s$
    p% = InStr(pa$, SCRext$)
    s$ = Left$(pa$, p% - 1)
End If

retrievemodulename$ = s$
End Function

Sub retrieveNames (clist As Control, cpath As Control, ByVal dir1$, ByVal dir2$, ByVal useHidden%, ByVal default$, filecount%)
Const MatchAllFilesWithHidden% = ATTR_NORMAL Or ATTR_READONLY Or ATTR_HIDDEN Or ATTR_ARCHIVE
Const MatchAllFilesWithoutHidden% = ATTR_NORMAL Or ATTR_READONLY Or ATTR_ARCHIVE
Dim p$, s$, s2$
Dim attr%
Dim i%
Dim ndx%

Select Case useHidden%
Case True: attr% = MatchAllFilesWithHidden%
Case False: attr% = MatchAllFilesWithoutHidden%
End Select

clist.Clear
cpath.Clear

For i% = 1 To 2
    Select Case i%
    Case 1: p$ = dir1$
    Case 2: p$ = dir2$
    End Select
    p$ = UCase(p$)
    s$ = Dir$(p$ + "*" + SCRext$, attr%)
    Do Until s$ = ""
	s$ = UCase(s$)
	s2$ = retrievemodulename$(p$, s$) ' pass uppercase !!!
	clist.AddItem s2$
	ndx% = clist.NewIndex
	cpath.AddItem p$ + s$, ndx%
	s$ = Dir$
    Loop
Next

If default$ <> "" Then
    clist.AddItem "Default screen saver"
    ndx% = clist.NewIndex
    cpath.AddItem (default$), ndx%
Else
    ndx% = 0' first in sorted list
End If
clist.ListIndex = ndx%
filecount% = clist.ListCount
End Sub

