(* -----------------------------------------------------------

Notes     : this is ugly Q&D hack
            this is not bullet-proof
            this is still work IN progress i.e. BETA stage !

            note multiple nested boundary= definitions seem legal,
            thus forcing us to use a stack !

Bugs      : html with =??=?? are not correctly processed yet
            isl.args if we try to include ini file
            (whatever we try with threshold !)
Wish list :

------------------------------------------------------------ *)

MODULE unMBOX;

IMPORT FIO,Lib,Str;

FROM IO IMPORT WrStr,WrLn,WrLngCard;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileSupportLFN;

(* shortened list *)

FROM QD_LFN IMPORT unicodeConversionFlagType, findDataRecordType,
w9XfindFirst, w9XfindClose, w9XfindNext, w9XshortToLong;

FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available,
HeapTotalAvail, MainHeap;

(* ------------------------------------------------------------ *)

CONST
    extMSG              = ".MSG";
    extINI              = ".INI";
    skippedextensions   = extMSG;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOpt              = 2;
    errParm             = 3;
    errExpecting        = 4;
    errBadSpec          = 5;
    errNoMatch          = 6;
    errTooMany          = 7;
    errAborted          = 8;
    errIniNotFound      = 9;
    errIniProblem       = 10;
    errNonsense         = 11;
CONST
    exe     = "UNMBOX";
    version = "v0.9c";
    who     = "PhG";
CONST
    msgHelp =
"Q&D MBOX to TXT converter "+version+" by "+who+nl+
nl+
"Syntax : "+exe+" <source> [option]..."+nl+
nl+
"This program reads Thunderbird MBOX files, removes any attachement"+nl+
"then tries and converts messages to DOS ASCII."+nl+
nl+
"  -d    dump converted data to screen without creating matching text file"+nl+
'  -w    preprocess "=##" form to OEM Windows (default is DOS ASCII)'+nl+
"  -r    leave message text as is without any character conversion"+nl+
"  -o    overwrite existing matching target text file (default is to skip it)"+nl+
"  -n    rename existing matching target text file"+nl+
"  -p    create "+extMSG+" target in <source> directory (default is in current)"+nl+
"  -x    disable LFN support even if available"+nl+
nl+
"a) Note source date and time stamp is copied to "+extMSG+" target."+nl+
"b) Files matching *"+extMSG+" will not be processed."+nl+
"c) "+exe+extINI+" must exist."+nl+
"   It is first searched for in current then in executable directory."+nl+
"d) As of "+version+", note a few HTML files can produce garbage."+nl+
"   Do not forget this program is still a work in progress i.e. in BETA stage !"+nl;

PROCEDURE abort (rc:CARDINAL;S:ARRAY OF CHAR);
BEGIN
    CASE rc OF
    | errNone: ;
    | errHelp:
        WrStr(msgHelp);
    ELSE
        IF Str.Length(S) # 0 THEN
            WrStr(exe+" : ");WrStr(S);WrLn;
        END;
    END;
    Lib.SetReturnCode( SHORTCARD(rc) );
    HALT;
END abort;

PROCEDURE dbg ( ok,enquote:BOOLEAN; S1,S2,S3:ARRAY OF CHAR  );
BEGIN
    IF ok THEN
        WrStr("/// ");WrStr(S1);
        WrStr("::: ");WrStr(S2);
        WrStr(" : ");
        IF enquote THEN WrStr(dquote);END;
        WrStr(S3);
        IF enquote THEN WrStr(dquote);END;
        WrLn;
    END;
END dbg;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType    = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    ioBufferIn,ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showmem(debug:BOOLEAN; S:ARRAY OF CHAR );
VAR
    heapsize    : CARDINAL; (* in PARAGRAPHS and not in bytes ! help is wrong ! *)
    n           : LONGCARD;
BEGIN
    IF debug THEN
        heapsize :=HeapTotalAvail(MainHeap);
        n := 16 * LONGCARD(heapsize);
        WrStr("/// ");
        WrLngCard(n,6);
        WrStr(" byte(s) free -- ");WrStr(S);WrLn;
    END;
END showmem;

(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;     (* variable length *)
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF Available(needed)=FALSE THEN RETURN FALSE; END;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
VAR
    u,d,n,e,ext:pathtype;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        useLFN,DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    unicodeconversion:unicodeConversionFlagType;
    w9Xentry : findDataRecordType;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,entry);
    END;
    WHILE found DO
        IF useLFN THEN
            Str.Copy(entryname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(entryname,entry.Name);
        END;
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        excludeme2 := isReservedPattern (entryname,skippedextensions );
        IF NOT(excludeme1 OR excludeme2) THEN
            IF useLFN THEN
                dosattr:=FIO.FileAttr(w9Xentry.attr AND 0FFH);
            ELSE
                dosattr:=entry.attr;
            END;
            IF NOT (aD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(entry);
        END;
    END;
    IF useLFN THEN ok:=w9XfindClose(w9Xhandle,errcode); END;
    RETURN count;
END buildFileList;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (VAR currdir,basepath:pathtype;
                   DEBUG,useLFN:BOOLEAN;spec:pathtype);
CONST
    me = "makebase()";
VAR
    u,d,n,e:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    dbg(DEBUG,TRUE,me,"spec",spec);
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    dbg(DEBUG,TRUE,me,"basepath",basepath);

    drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
    doGetCurrent(useLFN,drive,  unit,currdir); (* "u:" and "\" or "\*\" *)

    IF same(basepath,"") THEN Str.Concat(basepath, unit,currdir); END;
    Str.Prepend(currdir,unit);
    dbg(DEBUG,TRUE,me,"basepath",basepath);
END makebase;

PROCEDURE WrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);  WrStr(S);  WrStr(dquote);
END WrQuoted;

PROCEDURE WrFname (useLFN:BOOLEAN;S:pathtype );
BEGIN
    IF useLFN THEN
        WrQuoted(S);
    ELSE
        WrStr(S);
    END;
END WrFname;

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE newExt(VAR S:pathtype;ext:str16);
VAR
    R:pathtype;
    p:CARDINAL;
BEGIN
    Str.Copy(R,S);
    p:=Str.RCharPos(R,dot);
    IF p # MAX(CARDINAL) THEN R[p]:=nullchar;END;
    Str.Concat(S,R,ext);
END newExt;

PROCEDURE num2str (n,digits,base: CARDINAL;prefix,padchar : CHAR):str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    R    : str16;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,R,base,ok);
    len := Str.Length(R);
    IF len < digits THEN
        IF padchar="" THEN padchar:=" ";END; (* //FIX *)
    END;
    LOOP
        IF Str.Length(R) >= digits THEN EXIT; END;
        Str.Prepend(R,padchar);
    END;
    Str.Prepend(R,prefix);
    IF base=16 THEN Str.Lows(R);END;
    RETURN R;
END num2str;

PROCEDURE printable (c : SHORTCARD):CHAR;
BEGIN
    IF c < ORD(blank) THEN
        RETURN blank;
    ELSE
        RETURN CHR(c);
    END;
END printable;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    nocharset      = 0;
    utf8           = 1; (* fixhtm.bat *)
    iso8859        = 2; (* win2pc *)
    windows1252    = 3; (* =## win OR &;# *)
    usascii        = 4;
CONST
    (* "text/plain OR text/html *)
    patutf8        = "*content-type*text*charset*utf*";
    patiso8859     = "*content-type*text*charset*iso*";
    patwindows1252 = "*content-type*text*charset*windows*";
    patusascii     = "*content-type*text*charset*us-ascii*";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    str8 = ARRAY [0..8-1] OF CHAR;
    str4 = ARRAY [0..4-1] OF CHAR;
TYPE
    entitytype = RECORD
                     defined        : BOOLEAN;
                     string         : str8;
                     DOSreplacement : str4;
                     WINreplacement : str4;
    END;

CONST
    maxstring   = 8;
    maxnew      = 4;
    minEntity   = 1;
    maxEntity   = 500;
VAR
    entity : ARRAY[minEntity..maxEntity] OF entitytype;

PROCEDURE findfreeEntity (  ):CARDINAL;
VAR
    i:CARDINAL;
BEGIN
    i:=minEntity;
    LOOP
        IF entity[i].defined=FALSE THEN EXIT;END;
        INC(i);
        IF i > maxEntity THEN i:=MAX(CARDINAL);EXIT;END;
    END;
    RETURN i;
END findfreeEntity;


PROCEDURE gotstr (S : ARRAY OF CHAR; VAR R : ARRAY OF CHAR) : BOOLEAN;
CONST
    markdec  = "\";
    markhex1 = "&";
    markhex2 = "H";
    decdigits="0123456789";
    hexdigits=decdigits+"ABCDEF";
VAR
    new    : str128;
    i      : CARDINAL;
    len    : CARDINAL;
    p      : CARDINAL;
    ch     : CHAR;
    status : (waiting,indec,inhex1,inhex2);
    number : str16;
    n      : LONGCARD;
    ok     : BOOLEAN;
BEGIN
    len    := Str.Length(S);
    i      := 0;
    p      := 0;
    status := waiting;
    LOOP
        IF i = len THEN EXIT; END;
        ch := S[i];
        CASE status OF
        | waiting :
            CASE ch OF
            | markdec :
                status:=indec;
                number:="";
            | markhex1:
                status:=inhex1;
                number:="";
            ELSE
                new[p]:=ch;
                INC(p);
            END;
            INC(i);
        | indec :
            IF Str.CharPos(decdigits,ch)#MAX(CARDINAL)THEN
                Str.Append(number,ch);
                INC(i);
            ELSE
                IF same(number,"") THEN
                    new[p]:=markdec;
                ELSE
                    n:=Str.StrToCard(number,10,ok);
                    IF ok=FALSE THEN RETURN FALSE; END;
                    n := n MOD 256;
                    new[p]:=CHR( CARDINAL(n));
                END;
                INC(p);
                status:=waiting;
            END;
        | inhex1 :
            IF ch=markhex2 THEN
                status:=inhex2;
                INC(i);
            ELSE
                new[p]:=markhex1;
                INC(p);
                status:=waiting;
            END;
        | inhex2 :
            IF Str.CharPos(hexdigits,ch)#MAX(CARDINAL)THEN
                Str.Append(number,ch);
                INC(i);
            ELSE
                IF same(number,"") THEN
                    new[p]:=markhex1;
                    INC(p);
                    new[p]:=markhex2;
                ELSE
                    n:= Str.StrToCard(number,16,ok);
                    IF ok=FALSE THEN RETURN FALSE; END;
                    n := n MOD 256;
                    new[p]:=CHR( CARDINAL(n));
                END;
                INC(p);
                status:=waiting;
            END;
        END;
    END;
    CASE status OF
    | indec :
        IF same(number,"") THEN
            new[p]:=markdec;
        ELSE
            n:=Str.StrToCard(number,10,ok);
            IF ok=FALSE THEN RETURN FALSE; END;
            n := n MOD 256;
            new[p]:=CHR( CARDINAL(n));
        END;
        INC(p);
    | inhex1 :
        new[p]:=markhex1;
        INC(p);
    | inhex2 :
        IF same(number,"") THEN
            new[p]:=markhex1;
            INC(p);
            new[p]:=markhex2;
        ELSE
            n:=Str.StrToCard(number,16,ok);
            IF ok=FALSE THEN RETURN FALSE; END;
            n := n MOD 256;
            new[p]:=CHR( CARDINAL(n));
        END;
        INC(p);
    END;
    IF p > maxnew THEN RETURN FALSE; END;
    new[p]:=CHR(0);
    Str.Copy(R,new);
    RETURN TRUE;
END gotstr;

PROCEDURE storeEntity (index:CARDINAL;  S : ARRAY OF CHAR) : BOOLEAN;
CONST
    sep = "_";
VAR
    R : str128;
    i : CARDINAL;
    newDOS : str4;
    newWIN : str4;
    tmp : str128;
BEGIN
    Str.ItemS(R,S,space+tabul,0);
    IF Str.Length(R) > maxstring THEN RETURN FALSE; END;
    entity[index].string:=str8(R);
    Str.ItemS(R,S,space+tabul,2);     (* skip the = sign ! *)
    i := CharCount(R,sep);
    IF i >= 4 THEN (* _7bit_DOS_WIN_ *)
        Str.ItemS(tmp,R,sep,1);
        IF gotstr(tmp,newDOS)=FALSE THEN RETURN FALSE; END;
        Str.ItemS(tmp,R,sep,2);
        IF gotstr(tmp,newWIN)=FALSE THEN RETURN FALSE; END;
    ELSE (* char or \### *)
        IF gotstr(R,newDOS)=FALSE THEN RETURN FALSE; END;
        Str.Copy(newWIN,newDOS);
    END;
    entity[index].DOSreplacement:=newDOS;
    entity[index].WINreplacement:=newWIN;
    entity[index].defined:=TRUE;
    RETURN TRUE;
END storeEntity;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minseq = MIN(SHORTCARD);
    maxseq = MAX(SHORTCARD);
    maxlenseq = 4;
TYPE
    bindeftype = RECORD
        count : SHORTCARD;
        bincode:ARRAY[0..maxlenseq-1] OF SHORTCARD;
    END;
    seqdeftype = RECORD
        defined : BOOLEAN;
        orgstr  : bindeftype;
        newstr  : bindeftype;
    END;

VAR
    isodef : ARRAY[minseq..maxseq] OF seqdeftype;
    utfdef : ARRAY[minseq..maxseq] OF seqdeftype;

PROCEDURE initini (  );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=minseq TO maxseq DO
        isodef[i].orgstr.count :=1;
        isodef[i].orgstr.bincode[0]:=SHORTCARD(i);
        isodef[i].newstr.count :=1;
        isodef[i].newstr.bincode[0]:=SHORTCARD(i);
        isodef[i].defined:=TRUE;

        utfdef[i].defined:=FALSE;
    END;
    FOR i:=minEntity TO maxEntity DO
        entity[i].defined:=FALSE;
    END;
END initini;

PROCEDURE findfreeutf (  ):CARDINAL;
VAR
    i:CARDINAL;
BEGIN
    i:=minseq;
    LOOP
        IF utfdef[i].defined=FALSE THEN EXIT;END;
        INC(i);
        IF i > maxseq THEN i:=MAX(CARDINAL);EXIT;END;
    END;
    RETURN i;
END findfreeutf;

PROCEDURE unpackbin (VAR R:str16;v:bindeftype);
VAR
    i:CARDINAL;
BEGIN
    Str.Copy(R,"~ ~ ~ ~");
    FOR i:=1 TO CARDINAL(v.count) DO
        Str.Subst(R,"~", num2str(CARDINAL( v.bincode[i-1] ),2,16,"","0"));
    END;
    FOR i:=CARDINAL(v.count)+1 TO maxlenseq DO
        Str.Subst(R,"~","  ");
    END;
END unpackbin;

PROCEDURE bin2str (VAR R:str16;v:bindeftype );
VAR
    i:CARDINAL;
BEGIN
    Str.Copy(R,"");
    FOR i:=1 TO CARDINAL(v.count) DO
        Str.Append(R, CHR(v.bincode[i-1]) );
    END;
END bin2str;

(* try not to recurse nor overlap *)

PROCEDURE oldnew (VAR R:str1024;oldstr,newstr:str16);
VAR
    p,newp,oldlen,newlen:CARDINAL;
BEGIN
    IF same(oldstr,newstr) THEN RETURN; END; (* avoid nonsense *)
    oldlen:=Str.Length(oldstr);
    newlen:=Str.Length(newstr);
    p:=0;
    LOOP
        newp:=Str.NextPos(R,oldstr,p);
        IF newp = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(R,newp,oldlen);
        Str.Insert(R,newstr,newp);
        p:=newp+newlen;
        IF p >= Str.Length(R) THEN EXIT; END;
    END;
END oldnew;

PROCEDURE dmpseq (  );
CONST
    wi = 3+1+1+1+8+3;
VAR
    S:str128;
    i,j:CARDINAL;
    v1,v2:bindeftype;
    ok:BOOLEAN;
    Z:str16;
BEGIN
    FOR j:=1 TO 2 DO
        FOR i:=minseq TO maxseq DO
            CASE j OF
            | 1:
                ok:=isodef[i].defined;
                v1:=isodef[i].orgstr;
                v2:=isodef[i].newstr;
            | 2:
                ok:=utfdef[i].defined;
                v1:=utfdef[i].orgstr;
                v2:=utfdef[i].newstr;
            END;
            IF ok THEN
                S:="~ : ~ ==> ~";
                Str.Subst(S,"~",num2str(i,3,10,""," ")); (* //FIX empty padchar means infinite loop *)
                unpackbin(Z,v1);
                Str.Subst(S,"~",Z);
                unpackbin(Z,v2);
                Str.Subst(S,"~",Z);
                WrStr(S);WrLn;
            END;
        END;
        WrLn;
    END;
    FOR i:=minEntity TO maxEntity DO
        IF entity[i].defined THEN
            S:="~ : ~ ";
            Str.Subst(S,"~",num2str(i,3,10,""," ")); (* //FIX empty padchar means infinite loop *)
            Str.Subst(S,"~",entity[i].string);
            FOR j:=Str.Length(S)+1 TO wi DO
                Str.Append(S," ");
            END;
            Str.Append(S,' ==> "');
            Str.Append(S,entity[i].DOSreplacement);
            Str.Append(S,'"');
            WrStr(S);WrLn;
        END;
    END;
END dmpseq;

PROCEDURE strToBin (VAR b:bindeftype;S:str16  ):BOOLEAN;
CONST
    me = "strToBin()";
VAR
    i,j,len,base:CARDINAL;
    v:LONGCARD;
    ok:BOOLEAN;
    hx:str16;
BEGIN
    b.count:=0;
    CASE S[0] OF
    | dollar:
        base:=16;
        Str.Delete(S,0,1);
        Str.Caps(S);
        len:=Str.Length(S);
        IF ODD(len) THEN RETURN FALSE;END;
        IF (len DIV 2) > maxlenseq THEN RETURN FALSE;END;
        b.count:=0;
        j:=0;
        FOR i:=1 TO len BY 2 DO
            Str.Concat(hx,S[i-1],S[i]);
            v:=Str.StrToCard(hx,base,ok);
            IF NOT(ok) THEN RETURN FALSE;END;
            IF v > MAX(SHORTCARD) THEN RETURN FALSE;END;
            IF v = 0 THEN RETURN FALSE;END;
            INC(b.count);
            b.bincode[j]:=SHORTCARD(v);
            INC(j);
        END;
    ELSE
        len:=Str.Length(S);
        IF len > maxlenseq THEN RETURN FALSE;END;
        FOR i:=1 TO len DO
            INC(b.count);
            b.bincode[i-1]:=SHORTCARD( ORD(S[i-1]) );
        END;
    END;
    RETURN TRUE;
END strToBin;

PROCEDURE loadini (VAR strline:ARRAY OF CHAR;
                  DEBUG,useLFN:BOOLEAN;ini:pathtype):CARDINAL;
CONST
    endofsection = star;
    remark       = semicolon;
VAR
    u,d,n,e,F:pathtype;
    hin:FIO.File;
    S:str128;
    rc,line,len,i:CARDINAL;
    v1,v2:bindeftype;
    state:(grabiso,grabutf,grabentities,grabdone);
    tok1,tok2:str16;
BEGIN
    qdSplitAllPath(ini,u,d,n,e);
    Lib.MakeAllPath(F,"","",n,e);
    IF fileExists(useLFN,F) THEN
        Str.Copy(ini,F);
    ELSE
        IF fileExists(useLFN,ini)=FALSE THEN RETURN errIniNotFound;END;
    END;
    hin:=fileOpenRead(useLFN,ini);
    FIO.AssignBuffer(hin,ioBufferIn);
    line:=0;
    state:=grabiso;
    rc:=errIniProblem;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hin,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        len:=Str.Length(S);
        IF ( (len=0) AND FIO.EOF ) THEN EXIT;END;
        INC(line);
        CASE S[0] OF
        | charnull,remark :
            ;
        | endofsection:
            INC(state);
            IF state = grabdone THEN rc:=errNone; EXIT; END;
        ELSE
            CASE state OF
            | grabiso,grabutf:
                IF argc(S,FALSE) # 2 THEN EXIT;END;
                argv(tok1, S,1,FALSE);
                argv(tok2, S,2,FALSE);
                IF strToBin(v1,tok1)=FALSE THEN EXIT;END;
                IF strToBin(v2,tok2)=FALSE THEN EXIT;END;
                CASE state OF
                | grabiso:
                    IF v1.count # 1 THEN EXIT;END;
                    IF v2.count # 1 THEN EXIT;END;
                    i:=CARDINAL( v1.bincode[0] );
                    isodef[ i ].orgstr:=v1;
                    isodef[ i ].newstr:=v2;
                | grabutf:
                    i:=findfreeutf();
                    IF i = MAX(CARDINAL) THEN EXIT;END;
                    utfdef[ i ].defined:=TRUE;
                    utfdef[ i ].orgstr:=v1;
                    utfdef[ i ].newstr:=v2;
                END;
            | grabentities:
                i:=findfreeEntity();
                IF i = MAX(CARDINAL) THEN EXIT; END;
                IF storeEntity (i,S)=FALSE THEN EXIT;END;
            END;
        END;
    END;
    fileClose(useLFN,hin);
    IF rc # errNone THEN Str.Copy(strline,num2str(line,1,10,"",""));END;

    IF DEBUG THEN dmpseq();END;

    isodef[minseq].defined:=FALSE; (* $00 is not allowed *)

    RETURN rc;
END loadini;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE procMBOX ( useLFN,onlydump,convert,oem,DEBUG:BOOLEAN;
                     source,target:pathtype):BOOLEAN;
CONST
    msgWorking        = "Working, please wait... ";
    me="procMBOX()";
    patidfrom         = "From *";
    patidboundary     = "*boundary=*";
    patidattachment   = "Content-disposition*attachment*";
    minndx            = 1;
    maxndx            = 10;
VAR
    hin,hout:FIO.File;
    S,US:str1024;
    uPat : str128;
    i,lastndx,len,p,charset:CARDINAL;
    ok,dmp,skipme:BOOLEAN;
    dtstamp:LONGCARD;
    patboundary:ARRAY[minndx..maxndx] OF str128;
    orgstr,newstr:str16;
    v1,v2:bindeftype;
    alcatraz:BOOLEAN;
    currpoll,poll:CARDINAL;
BEGIN
    alcatraz:=FALSE;
    IF useLFN THEN
        poll := 50; (* vindoze does not like frequent calls TO chkEscape() *)
    ELSE
        poll := 5;
    END;
    currpoll:=0;

    uPat:=patidboundary;
    ReplaceChar(uPat,star,"");
    Str.Caps(uPat);

    hin:=fileOpenRead(useLFN,source);
    FIO.AssignBuffer(hin,ioBufferIn);
    dtstamp:=FIO.GetFileDate(hin);
    IF onlydump THEN
        hout:=FIO.StandardOutput;
    ELSE
        video(msgWorking,TRUE);
        hout:=fileCreate(useLFN,target);
        FIO.AssignBuffer(hout,ioBufferOut);
    END;

    (* better safe than sorry *)
    lastndx:=minndx-1;
    patboundary[lastndx]:="";
    patboundary[lastndx+1]:="";

    charset:=nocharset;
    skipme:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT;END;
        FIO.RdStr(hin,S);
        len:=Str.Length(S);
        IF ( (len=0) AND FIO.EOF ) THEN EXIT;END;
        dbg(DEBUG,TRUE,me,"S",S);
        dmp:=TRUE;

        IF Str.Match(S,patidfrom) THEN
            skipme:=FALSE;
        ELSIF Str.Match(S,patidattachment) THEN
            skipme:=TRUE;
        ELSIF Str.Match(S,patutf8) THEN
            charset := utf8;
        ELSIF Str.Match(S,patiso8859) THEN
            charset := iso8859;
        ELSIF Str.Match(S,patwindows1252) THEN
            charset := windows1252;
        ELSIF Str.Match(S,patusascii) THEN
            charset := usascii;
        ELSIF Str.Match(S,patidboundary) THEN
            INC(lastndx);
            IF lastndx > maxndx THEN lastndx:=maxndx;END;
            Str.Copy(US,S);
            Str.Caps(US);
            p:=Str.Pos(US,uPat);
            Str.Delete(S,0,p+Str.Length(uPat));
            Str.Concat(patboundary[lastndx],star,S);
            Str.Append(patboundary[lastndx],star);
            ReplaceChar(patboundary[lastndx],dquote,"");
        ELSIF Str.Match(S,patboundary[lastndx]) THEN
            IF lastndx > minndx THEN DEC(lastndx);END;
            skipme:=FALSE;
        END;

        IF skipme THEN dmp:= FALSE;END;

        IF dmp THEN
            IF convert THEN
                    (* handle =?? *)
                    FOR i:=minseq TO maxseq DO
                        ok:=isodef[i].defined;
                        v1:=isodef[i].orgstr;
                        v2:=isodef[i].newstr;
                        IF ok THEN
                            Str.Copy(orgstr, num2str(CARDINAL(v1.bincode[0]),2,16,"","0"));
                            Str.Caps(orgstr);
                            Str.Prepend(orgstr,"=");
                            IF oem THEN
                                bin2str(newstr,v2);
                            ELSE
                                Str.Copy(newstr,CHR(v1.bincode[0]));
                            END;
                            oldnew(S,orgstr,newstr);
                        END;
                    END;

                CASE charset OF
                | utf8,iso8859:
                    FOR i:=minseq TO maxseq DO
                        CASE charset OF
                        | utf8:    ok:=utfdef[i].defined;
                                   v1:=utfdef[i].orgstr;
                                   v2:=utfdef[i].newstr;
                        | iso8859: ok:=isodef[i].defined;
                                   v1:=isodef[i].orgstr;
                                   v2:=isodef[i].newstr;
                        END;
                        IF ok THEN
                            bin2str(orgstr,v1);
                            bin2str(newstr,v2);
                            oldnew(S,orgstr,newstr);
                        END;
                    END;
                | windows1252:
                | usascii:
                END;
                    (* handle html entities *)
                    FOR i:=minEntity TO maxEntity DO
                        ok:=entity[i].defined;
                        IF ok THEN
                            Str.Copy(orgstr,entity[i].string);
                            Str.Copy(newstr,entity[i].DOSreplacement);
                            oldnew(S,orgstr,newstr);
                        END;
                    END;
            END;
            FIO.WrStr(hout,S);FIO.WrLn(hout);
        END;

        INC(currpoll);
        IF (currpoll MOD poll) = 0 THEN
            IF ChkEscape() THEN alcatraz:=TRUE;EXIT;END;
            currpoll:=0;
        END;

    END;

    (* handle pending commands *)

    IF onlydump=FALSE THEN
        fileClose(useLFN,hout);
        (* //WEIRD close/reopen trick required to update existing target stamp ! *)
        hout:=fileOpenRead(useLFN,target);
        FIO.SetFileDate(hout,dtstamp);
        fileClose(useLFN,hout);
        video(msgWorking,FALSE);
    END;
    fileClose(useLFN,hin);
    RETURN NOT(alcatraz);
END procMBOX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped from PCOPY v1.2s *)

CONST
    renfixdefault   = 0;
    renfixLFN       = 4;

PROCEDURE buildnewname (useLFN,DEBUG:BOOLEAN;renfix:CARDINAL;
          VAR S : pathtype):BOOLEAN ;
CONST
    me = "buildnewname()";
    firsttry = 1; (* was 0 *)
    maxtries = 9999;
    maxf8    = 8;
    max9X    = 128; (* should be more than enough *)
CONST
    dosrenmask      = "(#";
    lfnrenmask      = "(#)";
    lfnrenmasklong  = "(####)";
VAR
    u,d,n,e,newfile,fname : pathtype;
    i   : LONGCARD;
    value,num : str16;
    ok  : BOOLEAN;
    len,maxlen,wi : CARDINAL;
BEGIN
    IF useLFN THEN
        maxlen := max9X;
    ELSE
        maxlen := maxf8;
    END;
    qdSplitAllPath(S,u,d,n,e);
    len:=Str.Length(n);
    i:=firsttry;
    LOOP
        Str.CardToStr(i,value,10,ok);
        FOR wi:=Str.Length(value)+1 TO renfix DO Str.Prepend(value,"0");END;
        IF useLFN THEN
            num:=lfnrenmask;
        ELSE
            num:=dosrenmask;
        END;
        Str.Subst(num,"#",value);
        WHILE (len+Str.Length(num)) > maxlen DO
            Str.Delete(n,len-1,1); (* delete last char of name *)
            DEC(len);
        END;
        Str.Concat(fname,n,num); (* build new name *)
        Lib.MakeAllPath(newfile,u,d,fname,e);
        dbg(DEBUG,TRUE,me,"newfile",newfile);
        IF fileExists(useLFN,newfile)=FALSE THEN
            Str.Copy(S,newfile);
            RETURN TRUE;
        END;
        INC(i);
        IF i > maxtries THEN EXIT; END;
    END;
    RETURN FALSE;
END buildnewname;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstparm = 1;
    maxparm   = 1;
VAR
    parm : ARRAY [firstparm..maxparm] OF pathtype;
    i,opt,parmcount,lastparm:CARDINAL;
    S,R,filespec,basedir,source,target,ini,currdir:pathtype;
    ok,onlydump,oem,overwrite,convert,rename,usecurr,useLFN,DEBUG:BOOLEAN;
    ptr,anchor:pFname;
    renfix,countFile:CARDINAL;
    cmd:(undefinedfornow,processmbox);
BEGIN
    FIO.IOcheck := FALSE; (* don't let topspeed handle problems *)
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    cmd      := undefinedfornow;
    onlydump := FALSE;
    oem      := FALSE;
    convert  := TRUE;
    overwrite:= FALSE;
    rename   := FALSE;
    usecurr  := TRUE;
    useLFN   := TRUE;
    DEBUG    := FALSE;

    lastparm := firstparm-1;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,msgHelp);END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "D"+delim+"DUMP"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "R"+delim+"RAW"+delim+
                                  "W"+delim+"OEM"+delim+
                                  "N"+delim+"RENAME"+delim+
                                  "P"+delim+"PATH"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3   : abort(errHelp,msgHelp);
            | 4,5     : onlydump := TRUE;
            | 6,7     : useLFN   := FALSE;
            | 8,9     : overwrite:= TRUE;
            | 10,11   : convert  := FALSE;
            | 12,13   : oem      := TRUE;
            | 14,15   : rename   := TRUE;
            | 16,17   : usecurr  := FALSE;
            | 18      : DEBUG    := TRUE;
            ELSE
                abort(errOpt,"Unknown option !");
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParm,"Too many parameters !");END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    useLFN := ( useLFN AND fileSupportLFN() );

    Lib.ParamStr(ini,0);
    newExt(ini,extINI);

    IF cmd = undefinedfornow THEN cmd:=processmbox; END;

    (* processmbox *)

    CASE lastparm OF
    | firstparm-1 : abort(errExpecting,"<source> parameter expected !");
    ELSE                (* already trapped *)
                    ;
    END;

    useLFN:=(useLFN AND fileSupportLFN() );
    Str.Copy(filespec,parm[firstparm]);

    (* a few q&d sanity checks *)

    IF (overwrite AND rename) THEN abort(errNonsense,"-o and -n options are mutually exclusive !");END;
    IF chkUD(filespec)=FALSE THEN abort(errBadSpec,"Illegal <source> !");END;
    IF same(filespec,dot) THEN Str.Copy(filespec,star+dot); END;
    IF same(filespec,star) THEN Str.Copy(filespec,star+dot); END;
    IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
    IF chkJoker(filespec)=FALSE THEN
        IF fileIsDirectorySpec ( useLFN,filespec) THEN
            fixDirectory(filespec);
            Str.Append(filespec,stardotstar);
        END;
    END;
    makebase(currdir,basedir, DEBUG,useLFN,filespec);
    dbg(DEBUG,TRUE,"main()","currdir",currdir);
    dbg(DEBUG,TRUE,"main()","basedir",basedir);

    initini();
    i:=loadini(R,DEBUG,useLFN,ini);
    CASE i OF
    | errNone: ;
    | errIniNotFound:
         abort(i,"INI not found whether in current or in executable directory !");
    | errIniProblem:
         S:="Problem at INI line ~ !";
         Str.Subst(S,"~",R);
         abort(i,S);
    END;

    showmem(DEBUG,"Before buildFileList()");

    initList(anchor);
    countFile := buildFileList(anchor,useLFN,DEBUG,filespec);

    showmem(DEBUG,"After buildFileList()");

    CASE countFile OF
    | 0 :            abort(errNoMatch,"<source> does not exist !");
    | 1 : ;
    | MAX(CARDINAL): abort(errTooMany,"Too many files match <source> !");
    END;


    ptr:=anchor;
    WHILE ptr # NIL DO
        getStr(filespec,ptr);
        Str.Concat(source,basedir,filespec);
        dbg(DEBUG,TRUE,"main()","filespec",filespec);
        dbg(DEBUG,TRUE,"main()","source",source);
        IF usecurr THEN
            Str.Concat(target,currdir,filespec);
        ELSE
            Str.Concat(target,basedir,filespec);
        END;
        newExt(target,extMSG);
        dbg(DEBUG,TRUE,"main()","target",target);
        IF fileExists(useLFN,target) THEN
            IF rename THEN
                IF useLFN THEN
                    renfix:=renfixLFN;
                ELSE
                    renfix:=renfixdefault;
                END;
                    ok:=buildnewname (useLFN,DEBUG,renfix, target);
                              S:="::: Rename target ~";
            ELSE
                IF overwrite THEN
                    ok:=TRUE; S:="::: Overwrite existing target ~";
                ELSE
                    ok:=FALSE;S:="::: Skip existing target ~";
                END;
            END;
        ELSE
                    ok:=TRUE; S:="::: Create target ~";
        END;
        Str.Subst(S,tilde,dquote+tilde+dquote);
        Str.Subst(S,tilde,target);
        IF NOT(onlydump) THEN WrStr(S);WrLn; END;

        IF ok THEN
            ok:=procMBOX(useLFN,onlydump,convert,oem,DEBUG,source,target);
            IF NOT(ok) THEN
                freeList(anchor);
                abort(errAborted,"Aborted by user !");
            END;
        END;

        ptr:=ptr^.next;
    END;
    freeList(anchor);

    showmem(DEBUG,"After freeList()");

    abort(errNone,"");
END unMBOX.




(*

; first ISO then UTF then entities
; each section MUST end with "*" marker
; $00 is not allowed

;
; ISO : vindoze to PC
;
; token 1 : hex value
; token 2 : hex value or DOS char
;

$7F         
$80         
$81         
$82         
$83         
$84         
$85         
$86         
$87         
$88         
$89         
$8a         
$8b         
$8c         
$8d         
$8e         
$8f         
$90         
$91         '
$92         '
$93         
$94         
$95         
$96         
$97         
$98         
$99         
$9a         
$9b         
$9c         
$9d         
$9e         
$9f         
$A0         
$A1         
$A2         
$A3         
$A4         
$A5         
$A6         |
$A7         $15
$A8         
$A9         
$AA         
$AB         
$AC         
$AD         -
$AE         
$AF         -
$B0         
$B1         
$B2         
$B3         
$B4         
$B5         
$B6         $14
$B7         
$B8         
$B9         
$BA         
$BB         
$BC         
$BD         
$BE         
$BF         
$C0         A
$C1         A
$C2         A
$C3         A
$C4         
$C5         
$C6         
$C7         
$C8         E
$C9         
$CA         E
$CB         E
$CC         I
$CD         I
$CE         I
$CF         I
$D0         
$D1         
$D2         O
$D3         O
$D4         O
$D5         O
$D6         
$D7         X
$D8         O
$D9         U
$DA         U
$DB         U
$DC         
$DD         Y
$DE         
$DF         
$E0         
$E1         
$E2         
$E3         a
$E4         
$E5         
$E6         
$E7         
$E8         
$E9         
$EA         
$EB         
$EC         
$ED         
$EE         
$EF         
$F0         
$F1         
$F2         
$F3         
$F4         
$F5         o
$F6         
$F7         
$F8         o
$F9         
$FA         
$FB         
$FC         
$FD         y
$FE         
$FF         

*


;
; UTF : order does matter (longest first, substrings after)
;
; token 1 : hex string
; token 2 : hex string or DOS string
;

; open and close typo quotes
$c2ab20 $22
$20c2bb $22
$e2809c $22
$e2809d $22

; single quote
$e28099 $27

$e280a6 ...

$c3a9 
$c3b4 
$c3a0 
$c3a8 
$c3aa 
$c3b9 
$c3bb 
$c3ae 
$c3a2 
; A circonflex
$c382 
$c3a7 
$c3a7 
$c3af 
$c3b6 
$c3ab 
; n tilde
$c3b1 n
; power of 2
$c2b2 $fd
; ae
$c3a6 ae

; open and close typo quotes
$c2ab   $22
$c2bb   $22

; maj 
$c38b E

$c592 O

$c593   oe

; maj 
$b6   E

*

;
; HTM2ASC.INI
;

; entities shamelessly taken from HTMSTRIP.INI !
; 7bit_DOS_WIN

&AElig;    = _AE___             ; Capital AE dipthong (ligature)
&Aacute;   = _A_A__              ; Capital A, acute accent
&Acirc;    = _A_A__              ; Capital A, circumflex access
&Agrave;   = _A_A__              ; Capital A, grave accent
&Aring;    = _A___              ; Capital A, ring
&Atilde;   = _A_A__              ; Capital A, tilde
&Auml;     = _A___              ; Capital A, dieresis or umlaut mark
&Ccedil;   = _C___              ; Capital C, cedilla
&ETH;      = _D_D__              ; Capital Eth, Icelandic
&Eacute;   = _E___              ; Capital E, acute accent
&Ecirc;    = _E_E__              ; Capital E, circumflex accent
&Egrave;   = _E_E__              ; Capital E, grave accent
&Euml;     = _E_E__              ; Capital E, dieresis or umlaut mark
&Iacute;   = _I_I__              ; Capital I, acute accent
&Icirc;    = _I_I__              ; Capital I, circumflex accent
&Igrave;   = _I_I__              ; Capital I, grave accent
&Iuml;     = _I_I__              ; Capital I, dieresis or umlaut mark
&Ntilde;   = _N___              ; Capital N, tilde
&Oacute;   = _O_O__              ; Capital O, acute accent
&Ocirc;    = _O_O__              ; Capital O, circumflex accent
&Ograve;   = _O_O__              ; Capital O, grave accent
&Oslash;   = _O_O__              ; Capital O, slash
&Otilde;   = _O_O__              ; Capital O, tilde
&Ouml;     = _O___              ; Capital O, dieresis or umlaut mark
&Uacute;   = _U_U__              ; Capital U, acute accent
&Ucirc;    = _U_U__              ; Capital U, circumflex accent
&Ugrave;   = _U_U__              ; Capital U, grave accent
&Uuml;     = _U___              ; Capital U, dieresis or umlaut mark
&Yacute;   = _Y_Y__              ; Capital Y, acute accent
&THORN;    = _D_D__              ; Capital THORN, Icelandic
&aacute;   = _a___              ; Small a, acute accent
&acirc;    = _a___              ; Small a, circumflex accent
&aelig;    = _a___              ; Small ae dipthong (ligature)
&agrave;   = _a___              ; Small a, grave accent
&aring;    = _a___              ; Small a, ring
&atilde;   = _a_a__              ; Small a, tilde
&auml;     = _a___              ; Small a, dieresis or umlaut mark
&ccedil;   = _c___              ; Small c, cedilla
&eacute;   = _e___              ; Small e, acute accent
&ecirc;    = _e___              ; Small e, circumflex accent
&egrave;   = _e___              ; Small e, grave accent
&eth;      = _e_e__              ; Small etc, Icelandic
&euml;     = _e___              ; Small e, dieresis or umlaut mark
&iacute;   = _i___              ; Small i, acute accent
&icirc;    = _i___              ; Small i, circumflex accent
&igrave;   = _i___              ; Small i, grave accent
&iuml;     = _i___              ; Small i, dieresis or umlaut mark
&ntilde;   = _n___              ; Small n, tilde
&oacute;   = _o___              ; Small o, acute accent
&ocirc;    = _o___              ; Small o, circumflex accent
&ograve;   = _o___              ; Small o, grave accent
&oslash;   = _o___              ; Small o, slash
&otilde;   = _o_o__              ; Small o, tilde
&ouml;     = _o___              ; Small o, dieresis or umlaut mark
&szlig;    = _ss___             ; Small sharp s, German (sz ligature)
&thorn;    = _D_D__              ; Small thorn, Icelandic
&uacute;   = _u___              ; Small u, acute accent
&ucirc;    = _u_u__              ; Small u, circumflex accent
&ugrave;   = _u___              ; Small u, grave accent
&uuml;     = _u___              ; Small u, dieresis or umlaut mark
&yacute;   = _y_y__              ; Small y, acute accent
&yuml;     = _y___              ; Small y, dieresis or umlaut mark
&amp;      = &                    ; Ampersand
&brvbar;   = _|_|__              ; Broken vertical bar (pipe symbol)
&cdots;    = _...__..._        ; Three dots on center line
&cedil;    = _c_c__              ; Cedilla
&cent;     = _cents___          ; Cent symbol
&copy;     = _(c)_(c)__          ; Copyright symbol
&deg;      = _degree___         ; Degree symbol
&emsp;     = \032                 ; Thick space
&endash;   = -                    ; Dash
&ensp;     = \032                 ; Thin space
&frac12;   = _1/2___            ; One half
&frac14;   = _1/4___            ; One quarter
&frac34;   = _3/4_3/4__          ; Three quarters
&gt;       = >                    ; Greater than
&iexcl;    = _!___              ; Inverted exclamation point
&iquest;   = _?___              ; Inverted question mark
&laquo;    = _\034___           ; Left bracket double quote
&ldots;    = _..._...__          ; Three dots on lower line
&lt;       = <                    ; Less than
&macr;     = _-_-__              ; Macron accent
&mdash;    = -                    ; Big dash
&micro;    = _u___              ; Micron symbol
&middot;   = _.___              ; Small dot on the middle of the line
&nbsp;     = \032                 ; Non-breakable space
&ndash;    = -                    ; Small dash
&not;      = _^___              ; Not symbol
&ordf;     = _^a___             ; Feminine ordinal
&ordm;     = _^o___             ; Masculine ordinal
&para;     = _P___              ; Paragraph symbol
&plusmn;   = _+/-___            ; Plus-minus character
&pound;    = _L___              ; British pound Sterling
&quadsp;   = \032                 ; Huge space
&quot;     = \034                 ; Quotation mark
&raquo;    = _\034___           ; Right bracket double quote
&reg;      = _(R)_(R)__          ; Registered trademark
&sect;     = _(s)___            ; Section
&shy;      = _-_-__              ; Soft hyphen
&sp;       = \032                 ; Space
&sup1;     = _^1_^1__            ; Superscript one
&sup2;     = _^2___             ; Superscript two
&sup3;     = _^3_^3__            ; Superscript three
&thinsp;   = \032                 ; Thin space
&times;    = _x_x__              ; Multiplication symbol
&trade;    = _TM_TM__            ; Registered trademark -- unofficial
&vdots;    = |                    ; Three vertical dots
&yen;      = _Y___              ; Japanese yen
&lsquo;    = _`_`__              ; Left single quote
&rsquo;    = _'_'__              ; Right single quote
&ldquo;    = _\034___           ; Left double quote
&rdquo;    = _\034___           ; Right double quote

&#9;       = \032                 ; Vertical tab; handling as space
&#10;      = \013\010             ; Line feed; handling as new line
&#32;      = \032                 ; Space
&#33;      = !                    ; Exclamation point
&#34;      = \034                 ; Double quotation mark
&#35;      = #                    ; Number (pound) sign
&#36;      = $                    ; Dollar sign
&#37;      = %                    ; Percent sign
&#38;      = &                    ; Ampersand
&#39;      = '                    ; Apostrophe
&#40;      = (                    ; Left parenthesis
&#41;      = )                    ; Right parenthesis
&#42;      = *                    ; Asterisk
&#43;      = +                    ; Plus sign
&#44;      = ,                    ; Comma
&#45;      = -                    ; Hyphen
&#46;      = .                    ; Period (full stop)
&#47;      = /                    ; Solidus (slash)
&#48;      = 0                    ; Digit 0
&#49;      = 1                    ; Digit 1
&#50;      = 2                    ; Digit 2
&#51;      = 3                    ; Digit 3
&#52;      = 4                    ; Digit 4
&#53;      = 5                    ; Digit 5
&#54;      = 6                    ; Digit 6
&#55;      = 7                    ; Digit 7
&#56;      = 8                    ; Digit 8
&#57;      = 9                    ; Digit 9
&#58;      = :                    ; Colon
&#59;      = ;                    ; Semi-colon
&#60;      = <                    ; Less than
&#61;      = =                    ; Equals sign
&#62;      = >                    ; Greater than
&#63;      = ?                    ; Question mark
&#64;      = @                    ; Commercial at
&#65;      = A                    ; Capital letter A
&#66;      = B                    ; Capital letter B
&#67;      = C                    ; Capital letter C
&#68;      = D                    ; Capital letter D
&#69;      = E                    ; Capital letter E
&#70;      = F                    ; Capital letter F
&#71;      = G                    ; Capital letter G
&#72;      = H                    ; Capital letter H
&#73;      = I                    ; Capital letter I
&#74;      = J                    ; Capital letter J
&#75;      = K                    ; Capital letter K
&#76;      = L                    ; Capital letter L
&#77;      = M                    ; Capital letter M
&#78;      = N                    ; Capital letter N
&#79;      = O                    ; Capital letter O
&#80;      = P                    ; Capital letter P
&#81;      = Q                    ; Capital letter Q
&#82;      = R                    ; Capital letter R
&#83;      = S                    ; Capital letter S
&#84;      = T                    ; Capital letter T
&#85;      = U                    ; Capital letter U
&#86;      = V                    ; Capital letter V
&#87;      = W                    ; Capital letter W
&#88;      = X                    ; Capital letter X
&#89;      = Y                    ; Capital letter Y
&#90;      = Z                    ; Capital letter Z
&#91;      = [                    ; Left square bracket
&#92;      = \                    ; Reverse solidus (backslash)
&#93;      = ]                    ; Right square bracket
&#94;      = ^                    ; Carat
&#95;      = _                    ; Horizontal bar
&#96;      = `                    ; Acute accent
&#97;      = a                    ; Small letter a
&#98;      = b                    ; Small letter b
&#99;      = c                    ; Small letter c
&#100;     = d                    ; Small letter d
&#101;     = e                    ; Small letter e
&#102;     = f                    ; Small letter f
&#103;     = g                    ; Small letter g
&#104;     = h                    ; Small letter h
&#105;     = i                    ; Small letter i
&#106;     = j                    ; Small letter j
&#107;     = k                    ; Small letter k
&#108;     = l                    ; Small letter l
&#109;     = m                    ; Small letter m
&#110;     = n                    ; Small letter n
&#111;     = o                    ; Small letter o
&#112;     = p                    ; Small letter p
&#113;     = q                    ; Small letter q
&#114;     = r                    ; Small letter r
&#115;     = s                    ; Small letter s
&#116;     = t                    ; Small letter t
&#117;     = u                    ; Small letter u
&#118;     = v                    ; Small letter v
&#119;     = w                    ; Small letter w
&#120;     = x                    ; Small letter x
&#121;     = y                    ; Small letter y
&#122;     = z                    ; Small letter z
&#123;     = {                    ; Left curly brace
&#124;     = |                    ; Vertical bar
&#125;     = }                    ; Right curly brace
&#126;     = ~                    ; Tilde
&#131;     = ____              ; Looks like that musical forte indicator
&#133;     = _..._...__          ; Elipses
&#136;     = _^_^__              ; Circumflex
&#138;     = _S_S__              ; Comes up in Netscape as a capital S with reverse umlaut
&#139;     = _<_<__              ; Less than
&#140;	   = _OE_OE_OE_			  ; fix!
&#145;     = _`_`__              ; Left single quote
&#146;     = _'_'__              ; Right single quote
&#147;     = _\034_\034__        ; Left double quote
&#148;     = _\034_\034__        ; Right double quote
&#149;     = ____              ; Middle dot
&#150;     = _-_-__              ; Short dash
&#151;     = _--_--__            ; Long dash
&#153;     = _TM_TM__            ; Isn't in the book but Netscape uses it
&#155;     = _>_>__              ; Greater than
&#156;	   = _oe_oe_oe_			  ; fix!
&#159;     = _Y_Y__              ; Y umlaut
&#160;     = _\032_\032_\160_     ; Space
&#161;     = _!___              ; Inverted exclamation
&#162;     = _c___              ; Cent sign
&#163;     = _L___              ; Pound sterling
&#164;     = _$_$__              ; General currency sign
&#165;     = _Y___              ; Yen sign
&#166;     = _|_|__              ; Broken vertical bar; pipe symbol
&#167;     = _(s)___            ; Section sign
&#168;     = _\034_\034__        ; Umlaut (diaresis)
&#169;     = _(c)_(c)__          ; Copyright symbol
&#170;     = _a_a__              ; Feminine ordinal
&#171;     = _\034___           ; Left angle quote, guillemot left
&#172;     = _^___              ; Not sign
&#173;     = _-_-__              ; Soft hyphen (shhhh)
&#174;     = _(R)_(R)__          ; Registered trademark
&#175;     = _-_-__              ; Macron accent
&#176;     = _degree___         ; Degree sign
&#177;     = _+/-___            ; Plus or minus
&#178;     = _^2___             ; Superscript two
&#179;     = _^3_^3__            ; Superscript three
&#180;     = _'_'__              ; Acute accent
&#181;     = _u___              ; Micro sign
&#182;     = _P___              ; Paragraph symbol
&#183;     = _.___              ; Middle dot
&#184;     = _c___              ; Cedilla
&#185;     = _^1_^1__            ; Superscript one
&#186;     = _degree___         ; Masculine ordinal
&#187;     = _\034___           ; Right angle quote, guillemot right
&#188;     = _1/4___            ; Fraction one-fourth
&#189;     = _1/2___            ; Fraction one-half
&#190;     = _3/4_3/4__          ; Fraction three-fourths
&#191;     = _?___              ; Inverted question mark
&#192;     = _A_A__              ; Capital A, acute accent
&#193;     = _A_A__              ; Capital A, grave accent
&#194;     = _A_A__              ; Capital A, circumflex access
&#195;     = _A_A__              ; Capital A, tilde
&#196;     = _A___              ; Capital A, dieresis or umlaut mark
&#197;     = _A___              ; Capital A, ring
&#198;     = _AE___             ; Capital AE dipthong (ligature)
&#199;     = _C___              ; Capital C, cedilla
&#200;     = _E___              ; Capital E, acute accent
&#201;     = _E_E__              ; Capital E, grave accent
&#202;     = _E_E__              ; Capital E, circumflex accent
&#203;     = _E_E__              ; Capital E, dieresis or umlaut mark
&#204;     = _I_I__              ; Capital I, acute accent
&#205;     = _I_I__              ; Capital I, grave accent
&#206;     = _I_I__              ; Capital I, circumflex accent
&#207;     = _I_I__              ; Capital I, dieresis or umlaut mark
&#208;     = _D_D__              ; Capital Eth, Icelandic
&#209;     = _N___              ; Capital N, tilde
&#210;     = _O_O__              ; Capital O, acute accent
&#211;     = _O_O__              ; Capital O, grave accent
&#212;     = _O_O__              ; Capital O, circumflex accent
&#213;     = _O_O__              ; Capital O, tilde
&#214;     = _O___              ; Capital O, dieresis or umlaut mark
&#215;     = _x_x__              ; Multiplication sign
&#216;     = _O___              ; Capital O, slash
&#217;     = _U_U__              ; Capital U, acute accent
&#218;     = _U_U__              ; Capital U, grave accent
&#219;     = _U_U__              ; Capital U, circumflex accent
&#220;     = _U___              ; Capital U, dieresis or umlaut mark
&#221;     = _Y_Y__              ; Capital Y, acute accent
&#222;     = _D_D__              ; Capital THORN, Icelandic
&#223;     = _B___              ; Small sharp s, German (sz ligature)
&#224;     = _a___              ; Small a, acute accent
&#225;     = _a___              ; Small a, grave accent
&#226;     = _a___              ; Small a, circumflex accent
&#227;     = _a_a__              ; Small a, tilde
&#228;     = _a___              ; Small a, dieresis or umlaut mark
&#229;     = _a___              ; Small a, ring
&#230;     = _ae___             ; Small ae dipthong (ligature)
&#231;     = _c___              ; Small c, cedilla
&#232;     = _e___              ; Small e, acute accent
&#233;     = _e___              ; Small e, grave accent
&#234;     = _e___              ; Small e, circumflex accent
&#235;     = _e___              ; Small e, dieresis or umlaut mark
&#236;     = _i___              ; Small i, acute accent
&#237;     = _i___              ; Small i, grave accent
&#238;     = _i___              ; Small i, circumflex accent
&#239;     = _i___              ; Small i, dieresis or umlaut mark
&#240;     = _D_D__              ; Small etc, Icelandic
&#241;     = _n___              ; Small n, tilde
&#242;     = _o___              ; Small o, acute accent
&#243;     = _o___              ; Small o, grave accent
&#244;     = _o___              ; Small o, circumflex accent
&#245;     = _o_o__              ; Small o, tilde
&#246;     = _o___              ; Small o, dieresis or umlaut mark
&#247;     = _/___              ; Division sign
&#248;     = _o___              ; Small o, slash
&#249;     = _u___              ; Small u, acute accent
&#250;     = _u___              ; Small u, grave accent
&#251;     = _u___              ; Small u, circumflex accent
&#252;     = _u___              ; Small u, dieresis or umlaut mark
&#253;     = _y_y__              ; Small u, acute accent
&#254;     = _D_D__              ; Small thorn, Icelandic
&#255;     = _y___              ; Small y, dieresis or umlaut mark

&#8217;    = _'_'_'_			  ; sometimes seen in newer files
&#8216;    = _`_`_`_
&#8220;    = _"_"_"_
&#8221;    = _"_"_"_

*






*)







