Option Explicit
DefInt A-Z

' ------------------------------------------------------------------------

Function fileexists% (ByVal fi$)
Dim p%
On Error Resume Next
p% = Len(Dir$(fi$)) ' only normal file here
If (Err <> 0) Or (p% = 0) Then ' prevent vb box for disk error
    fileexists% = False
Else
    fileexists% = True
End If
End Function

Function getEXEname$ ()
Dim p$
p$ = App.EXEName
getEXEname$ = p$
End Function

' retrieve program path
Function getEXEpath$ ()
Dim p$
p$ = App.Path
If Right$(p$, 1) <> "\" Then p$ = p$ + "\"
getEXEpath$ = p$
End Function

Sub parseCanonical (ByVal canonical$, unit$, subdir$, FileName$)
Dim lastslash, firstslash, p
lastslash = 0
p = Len(canonical$)
Do While p > 0
    If Mid$(canonical$, p, 1) = "\" Then
    lastslash = p
    Exit Do
    End If
    p = p - 1
Loop

firstslash = 0
p = 1
Do While p < Len(canonical$)
    If Mid$(canonical$, p, 1) = "\" Then
    firstslash = p
    Exit Do
    End If
    p = p + 1
Loop

If firstslash = 0 And lastslash = 0 Then
    unit$ = ""
    subdir$ = ""
    FileName$ = canonical$
Else
    unit$ = Left$(canonical$, 1)
    subdir$ = Mid$(canonical$, firstslash, lastslash - firstslash + 1)
    FileName$ = Mid$(canonical$, lastslash + 1)
End If
End Sub

