Option Explicit
DefInt A-Z

' warn about progressive JPGs and JPGs with comments
Const sBuildWarn$ = "A few JPG variations MAY crash the program !"













Sub BuildUnsupportedList (fl As Control, ctrlimg As Control, lbl As Control)
Const padndx% = 5 ' "#####"
Const paderr% = 5 ' "(-xx)"
Const padinf% = 12 ' "xxxxXxxxxXxx"
Dim i%, hrpt%, rc%, n%, w%, h%, bpp%
Dim udf$, rpt$, ud$, s$, ss$, s1$, s2$, crlf$

crlf$ = Chr$(13) + Chr$(10)

waiting True
ctrlimg.Visible = False
lbl.Caption = ""

ud$ = fl.Path
If Right$(ud$, 1) <> "\" Then ud$ = ud$ + "\" ' only root has trailing "\"

rpt$ = ud$ + getEXEname$() + RPText$
rpt$ = LCase$(rpt$)
hrpt% = FreeFile
Open rpt$ For Output As #hrpt%

s$ = ";"
Print #hrpt%, s$
s$ = "; List of pictures (un)supported by ImageMan V5 VBX"
Print #hrpt%, s$
s$ = ";"
Print #hrpt%, s$

For i% = 1 To fl.ListCount
    DoEvents
    s$ = fmtInt$(i%) + " out of " + fmtInt$(fl.ListCount)
    s$ = "Checking " + s$ + ", please wait..."
    fff!lblBuild.Caption = s$

    udf$ = ud$ + fl.List(i% - 1)

    ' now for retrieving infos

    'ctrlimg.GetFileInfo = udf$

    ' seems these values are not updated until real load !
    'w% = ctrlimg.ImageWidth
    'h% = ctrlimg.ImageHeight
    'bpp% = ctrlimg.ImageBitspix

    's1$ = fmtInt$(i%)
    's1$ = pad$(s1$, " ", -padndx%)

    's2$ = fmtInt$(w%) + "x" + fmtInt$(h%) + "x" + fmtInt$(bpp%)
    's2$ = pad$(s2$, " ", -padinf%)
    's$ = s1$ + " : " + s2$ + " : " + udf$
    's$ = s1$ + " : " + udf$

    'Print #hlst%, s$

    ' now for load and possibly crash !

    ctrlimg.Picture = ""
    ctrlimg.Refresh

    ctrlimg.Picture = udf$
    rc% = ctrlimg.ErrCode
    If rc% > IM_ERRORNONE Then
        ss$ = "(" + fmtInt(rc%) + ")"
        s$ = "--- " + pad$(ss$, " ", -paderr%) + " " + udf$
    Else
        s$ = "+++ " + udf$
    End If
    Print #hrpt%, s$
Next
Close #hrpt%

ctrlimg.Picture = ""
ctrlimg.Refresh

'ctrlimg.Visible = True
fff!lblBuild.Caption = sBuildWarn$
waiting False

s$ = rpt$ + crlf$ + crlf$ + "contains report of (un)supported pictures !"
MsgBox s$, MB_ICONINFORMATION
End Sub

Sub doPickDIRcancel (fo As Form)
updateAutoPreview fo!chkAutoPreview, fo!cmdPreview
fo.Hide
Unload fo
End Sub

Sub doPickDIRmain (ByVal udf$, ByVal useHidden%, ByVal Pattern$, ByVal lastfile$)
Dim unit$, SUBDIR$, filename$
Dim u$, d$
Dim n%

gLastLoadErrorCode% = IM_ERRORNONE% + 256' better safe than sorry

Set fff = frmPickDIR

fff.Hide
fff.Visible = False
fff.AutoRedraw = True
' fff.ControlBox = False
' fff.MaxButton = False
' fff.MinButton = False
' fff.BorderStyle = DOUBLEFIXED
fff.Caption = Title$ + " : Directory selection"
fff.WindowState = Normal
fff!lblFiles.Caption = "Files :"

fff!lblWarn.Alignment = CENTER
fff!lblWarn.Caption = ""
fff!lblWarn.BackColor = fff.BackColor
fff!lblWarn.ForeColor = fff.ForeColor

fff!picPanel.BackColor = fff.BackColor
fff!picPanel.BorderStyle = NONE
'fff!picPanel.BorderStyle = FIXED_SINGLE' FIX

fff!chkAutoPreview.Value = boolToChk%(gAutoPreview%)
updateAutoPreview fff!chkAutoPreview, fff!cmdPreview

fff!lblBuild.Alignment = CENTER
fff!lblBuild.Caption = sBuildWarn$

centerform fff

' keep default

gNewdir$ = udf$

' init a few things
' vb imageman specific -- should already be set at design time but who knows ?

fff!imgPreview.Visible = False ' avoid nice green rectangle if no previous pic to display
fff!imgPreview.BackColor = fff.BackColor ' no effect, it's always default !
fff!imgPreview.Width = fff!picPanel.Width
fff!imgPreview.Height = fff!picPanel.Height
fff!imgPreview.Move 0, 0

initImageMan fff!imgPreview
fff!imgPreview.AutoScale = IM_AUTOSCALEMAINTAIN ' initImageMan sets IM_AUTOSCALENONE

' init attributes and patterns

fff!fileList.Pattern = Pattern$ ' "*.GIF;*.JPG;*.BMP;*.PCX;*.PNG"
fff!fileList.Normal = True
fff!fileList.Archive = True
fff!fileList.Hidden = useHidden%
fff!fileList.System = True

initPreviousDrive ' just in case...

If udf$ = "" Then ' should never happen !
    udf$ = exedir$
Else
    If fileexists(udf$) = False Then udf$ = exedir$ ' unlikely but who knows ?
End If
parseCanonical udf$, unit$, SUBDIR$, filename$

fff!unitList.Drive = Left$(unit$, 1) ' u from u:
If SUBDIR$ <> "\" Then
    SUBDIR$ = Left$(SUBDIR$, Len(SUBDIR$) - 1)
End If
fff!dirList.Path = SUBDIR$
fff!fileList.Path = SUBDIR$

' now display last file if possible
' remember we passed SUBDIR, added LASTFILEPATH
parseCanonical lastfile$, u$, d$, filename$
filename$ = UCase$(filename$)
If filename$ <> "" Then
    For n% = 0 To (fff!fileList.ListCount - 1)
        If UCase$(fff!fileList.List(n%)) = filename$ Then
            fff!fileList.ListIndex = n%
            doPickDIRpreview fff!fileList, fff!imgPreview, fff!lblWarn, fff!picPanel
            Exit For
        End If
    Next
End If

fff.Show MODAL

End Sub

Sub doPickDIRok (fo As Form, c As Control)
Dim s$
updateAutoPreview fo!chkAutoPreview, fo!cmdPreview

If c.ListIndex <> -1 Then
    gLastIndex% = c.ListIndex ' change to last picture selected
End If

gLastFileName$ = getFileFullPath$(c)

s$ = getDirFullPath$(c)
If s$ <> "" Then
    If LCase$(s$) <> LCase$(gNewdir$) Then
        'gLastIndex% = dLastIndex%' reset to firstNDXPIC% i.e. 0 because we changed directory
    End If
    gNewdir$ = LCase$(s$)
End If

fo.Hide
Unload fo
End Sub

Sub doPickDIRpreview (fl As Control, ctrlimg As Control, warn As Control, panel As Control)
Dim fi$, rc$
Dim picmodified%, autoreduced%
Dim paper&, ink&
Dim w%, h%, ratio!, postop!, posleft!, panelratio!
Dim currColorReduction%, currColorReductionCode%
Dim currDither%, currDitherCode%
Dim currChangeGamma%, currGamma%

fi$ = getFileFullPath$(fl)
If fi$ <> "" Then

    picmodified% = 0 ' for effects

    ctrlimg.Visible = False
    ctrlimg.Width = panel.Width
    ctrlimg.Height = panel.Height
    posleft! = 0
    postop! = 0
    ctrlimg.Move posleft!, postop! ' default repositionning

    ' almost same code than for real processing
    ' but we need to retrieve values as if we were saving global vars
    ' not yet saved (fixed in user interface only)

    currColorReduction% = f!clstColorReduction.ListIndex
    currColorReductionCode% = f!clstColorReduction.ItemData(currColorReduction%)
    currDither% = f!clstDither.ListIndex
    currDitherCode% = f!clstDither.ItemData(currDither%)

    ctrlimg.Picture = fi$ ' it should be best fitted as set in initaccusoft
    gLastLoadErrorCode% = ctrlimg.ErrCode ' for cmdSetWallPaper
    ' here, use globerk fff for ease
    If ctrlimg.ErrCode > IM_ERRORNONE% Then
        paper& = QBColor(QB_LIGHTRED)
        ink& = QBColor(QB_WHITE)
        rc$ = "Picture not loaded ! (error code = " + intToStr$(ctrlimg.ErrCode) + ")"
        ctrlimg.Picture = "" ' safety
        ctrlimg.Refresh
    Else
        paper& = fff.BackColor
        ink& = fff.ForeColor

        w% = ctrlimg.ImageWidth
        h% = ctrlimg.ImageHeight

        ratio! = w% / h%
        panelratio! = panel.Width / panel.Height
        ' remember imvb autoscales picture : thus, one dimension already fits panel
        If ratio! > panelratio! Then
            ' center V
            posleft! = 0
            postop! = (panel.Height - (panel.Height / ratio! * panelratio!)) / 2
        Else
            ' center H
            postop! = 0
            posleft! = (panel.Width - (panel.Width * ratio! / panelratio!)) / 2
        End If
        ctrlimg.Move posleft!, postop!

        rc$ = intToStr$(w%) + "x" + intToStr$(h%)
        rc$ = rc$ + "x" + intToStr$(bitspix(ctrlimg))
    End If
    ctrlimg.Visible = True

    warn.BackColor = paper&
    warn.ForeColor = ink&
    warn.Caption = rc$

    retrieveGlobalGammaForExtension fi$, currChangeGamma%, currGamma%

    If currChangeGamma% Then
        'ctrlimg.Gamma = (currGamma% / 100!)
        ctrlimg.brightness = currGamma%
        ctrlimg.Refresh
        picmodified% = picmodified% + 1
    End If

    If currColorReductionCode% <> IM_NOREDUCTION Then
        ctrlimg.DitherMethod = currDitherCode%
        ctrlimg.ReduceTo = currColorReductionCode%
        ctrlimg.Refresh
        picmodified% = picmodified% + 1
    End If
    ' we could use picmodified% to do only one refresh but safety first... though refresh seems useless
End If
End Sub

Sub doPickDIRsetwallpaper (fl As Control, cpic As Control)
Dim filetoshow$
Dim upperSizePercentage%, lowerSizePercentage%
Dim flagForceResize%
Dim k&
Dim targetWi%, targetHe%
Dim upperWi%, upperHe%
Dim lowerWi%, lowerHe%
Dim maxW%, maxH%, minW%, minH%
Dim h%, w%, newW%, newH% ' picHeight%, picWidth%

filetoshow$ = getFileFullPath$(fl)
If filetoshow$ <> "" Then

    ' cpic.Visible = False

    ' cut/fix/paste from getNewPicAndIndex

    ' too many globerks...

    ' compute coefficients for lower and upper sizes, ensuring lower is at least 0,2 (i.e. 20 here)
    upperSizePercentage% = gTargetSize% + gAddedMargin%
    lowerSizePercentage% = gTargetSize% - gSubstractedMargin%
    If lowerSizePercentage% < MINTARGETSIZE% Then lowerSizePercentage% = MINTARGETSIZE%

    ' damn types ! to avoid overflow, we need at least one long
    k& = XscreenInPixels%: targetWi% = (k& * gTargetSize%) \ 100
    k& = YscreenInPixels%: targetHe% = (k& * gTargetSize%) \ 100
    k& = XscreenInPixels%: upperWi% = (k& * upperSizePercentage%) \ 100
    k& = YscreenInPixels%: upperHe% = (k& * upperSizePercentage%) \ 100
    k& = XscreenInPixels%: lowerWi% = (k& * lowerSizePercentage%) \ 100
    k& = YscreenInPixels%: lowerHe% = (k& * lowerSizePercentage%) \ 100

    If gLastLoadErrorCode% >= IM_ERRORNONE Then
        h% = cpic.ImageHeight
        w% = cpic.ImageWidth
        Call bestfit(newW%, newH%, w%, h%, targetWi%, targetHe%)
        ' now we have our target dimensions, check for allowable (no-resize) range
        Call bestfit(maxW%, maxH%, w%, h%, upperWi%, upperHe%)
        Call bestfit(minW%, minH%, w%, h%, lowerWi%, lowerHe%)
        flagForceResize% = isOutOfRange%(minW%, minH%, w%, h%, maxW%, maxH%)

        If flagForceResize% = True Then
            '///FIXME
            'cpic.ResizeWidth = newW%
            'cpic.ResizeHeight = newH%
            'cpic.Resize = True
        End If
        ' again, too many globerks...
        processNewPic cpic, filetoshow$
    End If
End If
End Sub

Function pad$ (ByVal s$, ByVal ch$, ByVal wi%)
Dim i%
For i% = Len(s$) + 1 To Abs(wi%)
    If wi% < 0 Then
        s$ = ch$ + s$
    Else
        s$ = s$ + ch$
    End If
Next
pad$ = s$
End Function

Sub retrieveGammaForExtension (ByVal s$, currflag%, currval%)
Dim c As Control
Dim c2 As Control
Dim p%, flag%
p% = InStr(s$, ".")
s$ = UCase$(Mid$(s$, p%))
Select Case s$
Case GIFext$
    Set c = f!chkChangeGammaGIF: Set c2 = f!hbarGammaGIF
Case JPGext$
    Set c = f!chkChangeGammaJPG: Set c2 = f!hbarGammaJPG
Case PNGext$
    Set c = f!chkChangeGammaPNG: Set c2 = f!hbarGammaPNG
Case BMPext$
    Set c = f!chkChangeGammaBMP: Set c2 = f!hbarGammaBMP
Case PCXext$
    Set c = f!chkChangeGammaPCX: Set c2 = f!hbarGammaPCX
Case Else ' impossible ! ;-)
    Set c = f!chkChangeGammaGIF: Set c2 = f!hbarGammaGIF
End Select
flag% = c.Value
currflag% = chkToBool%(flag%)
currval% = c2.Value
End Sub

Sub updateAutoPreview (c As Control, cmd As Control)
Dim flag%
flag% = c.Value
gAutoPreview% = chkToBool%(flag%)
cmd.Enabled = Not (gAutoPreview%)
End Sub
