
' --- from APICONST.TXT

'' System parameters support

Global Const SPI_GETBEEP = 1
Global Const SPI_SETBEEP = 2
Global Const SPI_GETMOUSE = 3
Global Const SPI_SETMOUSE = 4
Global Const SPI_GETBORDER = 5
Global Const SPI_SETBORDER = 6
Global Const SPI_GETKEYBOARDSPEED = 10
Global Const SPI_SETKEYBOARDSPEED = 11
Global Const SPI_LANGDRIVER = 12
Global Const SPI_ICONHORIZONTALSPACING = 13
Global Const SPI_GETSCREENSAVETIMEOUT = 14
Global Const SPI_SETSCREENSAVETIMEOUT = 15
Global Const SPI_GETSCREENSAVEACTIVE = 16
'Global Const SPI_SETSCREENSAVEACTIVE = 17
Global Const SPI_GETGRIDGRANULARITY = 18
Global Const SPI_SETGRIDGRANULARITY = 19
Global Const SPI_SETDESKWALLPAPER = 20
Global Const SPI_SETDESKPATTERN = 21
Global Const SPI_GETKEYBOARDDELAY = 22
Global Const SPI_SETKEYBOARDDELAY = 23
Global Const SPI_ICONVERTICALSPACING = 24
Global Const SPI_GETICONTITLEWRAP = 25
Global Const SPI_SETICONTITLEWRAP = 26
Global Const SPI_GETMENUDROPALIGNMENT = 27
Global Const SPI_SETMENUDROPALIGNMENT = 28
Global Const SPI_SETDOUBLECLKWIDTH = 29
Global Const SPI_SETDOUBLECLKHEIGHT = 30
Global Const SPI_GETICONTITLELOGFONT = 31
Global Const SPI_SETDOUBLECLICKTIME = 32
Global Const SPI_SETMOUSEBUTTONSWAP = 33
Global Const SPI_SETICONTITLELOGFONT = 34
Global Const SPI_GETFASTTASKSWITCH = 35
Global Const SPI_SETFASTTASKSWITCH = 36

' SystemParametersInfo flags
Global Const SPIF_UPDATEINIFILE = 1
Global Const SPIF_SENDWININICHANGE = 2

' --- from APIDECS.TXT slightly modified

' stupid Appleman had forgotten BYVAL for lpvParam$ !!! with as any, does NOT work !!!

Declare Function SystemParametersInfo% Lib "User" (ByVal uAction%, ByVal uParam%, ByVal lpvParam$, ByVal fuWinIni%)

' ------------------------------------------------------------------------

Sub ChangeWallPaper (ByVal BMPpath$)
Dim action%
Dim subparm%
Dim flagIni%
Dim rc%

action% = SPI_SETDESKWALLPAPER
subparm% = 0 ' null when setting something
flagIni% = SPIF_SENDWININICHANGE ' + SPIF_UPDATEINIFILE' update WIN.INI just in case
rc% = SystemParametersInfo%(action%, subparm%, BMPpath$, flagIni%)
End Sub

