IMPLEMENTATION MODULE BGIsvga;

IMPORT SYSTEM;
IMPORT Lib;

(*
16 color palette
PalBuf = RGB values for all 16 colors
RGB values = [0..63]
*)

PROCEDURE SetVGAPalette16(PalBuf : DacPalette16);
VAR
  R : SYSTEM.Registers;
BEGIN
  R.AX := 1012H;
  R.BX := 0000H;
  R.CX := 0010H;
  R.ES := Seg(PalBuf);
  R.DX := Ofs(PalBuf);
  Lib.Intr(R,10H);
END SetVGAPalette16;

PROCEDURE GetVGAPalette16(VAR PalBuf : DacPalette16);
VAR
  R : SYSTEM.Registers;
BEGIN
  R.AX := 1017H;
  R.BX := 0000H;
  R.CX := 0010H;
  R.ES := Seg(PalBuf);
  R.DX := Ofs(PalBuf);
  Lib.Intr(R,10H);
END GetVGAPalette16;

(*
256 color palette
PalBuf = RGB values for all 256 colors
RGB values = [0..63]
*)

PROCEDURE SetVGAPalette256(PalBuf : DacPalette256);
VAR
  R : SYSTEM.Registers;
BEGIN
  R.AX := 1012H;
  R.BX := 0000H;
  R.CX := 0100H;
  R.ES := Seg(PalBuf);
  R.DX := Ofs(PalBuf);
  Lib.Intr(R,10H);
END SetVGAPalette256;

PROCEDURE GetVGAPalette256(VAR PalBuf : DacPalette256);
VAR
  R : SYSTEM.Registers;
BEGIN
  R.AX := 1017H;
  R.BX := 0000H;
  R.CX := 0100H;
  R.ES := Seg(PalBuf);
  R.DX := Ofs(PalBuf);
  Lib.Intr(R,10H);
END GetVGAPalette256;

BEGIN

END BGIsvga.