(* ---------------------------------------------------------------
Title         Q&D Fortune Cookie
Author        PhG
Overview      another useless program
Notes         minimal error messages and checking, etc.
              too many globerks... ;-)
              clipboard works with Win92 and Win98SE but NOT with WinXP :-(

              note "." applies to currdir while "*" applies to exedir

Bugs          when building an index, cookies count is always count-1
              (eof is not seen as terminator)
              bah, who cares ? not even me, now...
              just warn about trailing separator needed ! check with -t[t]
              huge fortune files require more than a CARDINAL...
              but it's better to split them anyway

              v1.2 feature could not be added to Win32 port
              because of quirks (not to say : bugs) found IN XSD compiler.
              No wonder Modula-2 is no longer used... :-(

              XDS bugs forced use to use seperate indexes for DOS and Win32

Wish List     are we kidding ? ah ah, only serious !

              run from readonly device ? bof...
              a more clever sentence concatenation ? bof... (bis)
              resist improving, for we'd rewrite the whole stuff !

--------------------------------------------------------------- *)

MODULE Fortune;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT BiosIO;
IMPORT MsMouse;

IMPORT IO;

FROM QD_ASCII IMPORT dash, slash, nullchar, tabchar, cr, lf, nl, bs,
space, dot, deg, degree, doublequote, quote, colon, percent, vbar,
blank, equal, dquote, charnull, singlequote, antislash, dollar,
star, backslash, coma, question, underscore, underbar, tabul, hbar,
comma, semicolon, diese, pound, openbracket, closebracket, tilde, exclam,
stardotstar, dotdot, escCh, escSet, letters, digits,
lettersUpp, lettersLow, openbrace, closebrace, ampersand;

FROM QD_Box IMPORT str80, str2, cmdInit, cmdShow, cmdStop, delim,
Work, video, Ltrim, Rtrim, UpperCase, LowerCase, ReplaceChar,
ChkEscape, Waitkey, WaitkeyDelay, Flushkey, IsRedirected, chkJoker,
isOption, GetOptIndex, GetLongCard, GetLongInt, GetString, CharCount,
same, aR, aH, aS, aD, aA, everything, isDirectory, fixDirectory, qdSplitAllPath,
str128, str256, Animation, allfiles, Belongs, FixAE, CodePhonetic,
CodeSoundex, CodeSoundexOrg, isReadOnly, LtrimBlanks, RtrimBlanks,
getStrIndex, cmdSHOW,BiosWaitkey,BiosWaitkeyShifted,BiosFlushkey,
str1024, isoleItemS, dmpTTX, str2048, Elapsed, TerminalReadString,
getDosVersion, DosVersion, warning95, runningWindows,
aV, reallyeverything, chkClassicTextMode, setClassicTextMode,
AltAnimation, str16, getCurrentDirectory, setReadWrite, setReadOnly,
getFileSize, verifyString, str4096, unfixDirectory,
animShow, animSHOW, animAdvance, animEnd, animClear,
animInit, animGetSdone, anim, cleantabs, UpperCaseAlt, LowerCaseAlt,
completedInit, completedShow, completedSHOW, completedEnd, completed,
removeDups, isValidHDunit, removePhantoms, removeFloppies,
getCDROMunits, getCDROMletters, removeCDROMs, getAllHDunits,
getAllLegalUnits, metaproc, getCli, argc, argv;

FROM QD_rand IMPORT InitRnd, GetRnd, GetRndCardRange;

FROM QD_Text IMPORT
colortype, cursorshapetype, scrolltype,
ff, (* cr, lf, bs, tab, nl, *) mincolor, maxcolor,
BW40, CO40, BW80, CO80, CO80x43, CO80x50, MONO,
vesa80x60, vesa132x25, vesa132x43, vesa132x50, vesa132x60,
selectCursorEmulation,
setCursorShape,
handleVesa, setBrightPaper, setBlinkMode,
setFillChar, setFillInk, setFillPaper,
setFillInkPaper, setTxtInk, setTxtPaper, setTxtInkPaper, setWrapMode,
setUseBiosMode, setTabWidth, getScreenData, setWindow,
setMode, restoreMode,
gotoXY, xyToHtabVtab, home, setVisualPage, setActivePage,
scrollWindow, fillTextAttr, cls, writeStr, writeLn, getScreenWidth,
getScreenHeight, getScreenMinX, getScreenMinY, getScreenMaxX, getScreenMaxY,
getMinHtab, getMaxHtab, getMinVtab, getMaxVtab,
getWindowWidth, getWindowHeight,
initScreenConsole,
findInkPaperAtStartup, getInkAtStartup, getPaperAtStartup;

FROM QD_LFN IMPORT path9X, huge9X, findDataRecordType,
unicodeConversionFlagType, w9XchangeDir,
w9XgetDOSversion, w9XgetTrueDOSversion, w9XisWindowsEnh, w9XisMSDOS7,
w9XfindFirst, w9XfindNext, w9XfindClose, w9XgetCurrentDirectory,
w9XlongToShort, w9XshortToLong, w9XtrueName, w9XchangeDir,
w9XmakeDir, w9XrmDir, w9Xrename, w9XopenFile, w9XcloseFile,
w9XsupportLFN;

FROM QD_File IMPORT pathtype, w9XnothingRequired,
fileOpenRead, fileOpen, fileExists, fileExistsAlt,
fileIsRO, fileSetRW, fileSetRO,
fileErase, fileCreate, fileRename, fileGetFileSize, fileGetFileStamp,
fileIsDirectorySpec, fileClose, fileFlush, fileSupportLFN;

(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "FORTUNE";
    ProgTitle     = "Q&D Fortune Cookies";
    ProgVersion   = "v1.2";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE";
    extTXT        = ".TXT";
    extNDX        = ".NDX";
    extNDXWIN     = ".DEX"; (* .idx and .inx already used BY other programs *)
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extSYS        = ".SYS";
    extBIN        = ".BIN";
    extBAT        = ".BAT";
    extensions    = extBAK+delim+extCOM+delim+extEXE+delim+extBAT+delim+
                    extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                    extSYS+delim+extBIN+delim+extNDX+delim+extNDXWIN;

    cmdANSI       = CHR(27)+"["; (* ANSI.SYS command *)

CONST
    firstCookie       = 1;               (* 1-based *)
    maxCookie         = MAX(CARDINAL)-2; (* ..65533, was MAX(CARDINAL) DIV SIZE(LONGCARD)-2 *)
    sMAX              = "65533rd";
    minCookie         = firstCookie-1;   (* 0-based, will contain count of cookies *)
    ndxCountCookie    = minCookie;       (* 0th entry contains count of cookies *)
CONST
    ALREADYDUMPEDCOOKIE  = MAX(LONGCARD);  (* impossible fpos will do for "already dumped" flag *)
    SHOWRANDOMCOOKIE     = MAX(CARDINAL);
    SHOWMOSTRECENTCOOKIE = MAX(CARDINAL)-1;
    NOCOOKIEYET          = MAX(CARDINAL);

(* ------------------------------------------------------------ *)

(*
    data file structure :

    separator single character
    text
    separator single character
    text
    ...
    separator character

    or
    single line tagline
    single line tagline
    ...

    if wantedcookie # SHOWRANDOMCOOKIE :
    - just update this cookie address in RAM ARRAY
    - lastCookie will be wrong

    eh eh, bug : last cookie is never counted nor displayed,
    because eof may happen without last separator
    yes, we could fake it but we don't care...
    if we begin, we'd rewrite everything !
*)

CONST
    strmagic = "m2_ndx"+CHR(26); (* exactly 4+3 chars *)
TYPE
    indexHeaderType = RECORD
        magic             : ARRAY[0..6] OF CHAR; (* 7 bytes *)
        TAGLINEMODE       : BOOLEAN;  (* 1 byte *)
        MOSTRECENTCOOKIE  : CARDINAL; (* can be NOCOOKIEYET *)
        COUNTOFCOOKIES    : LONGCARD; (* cardinal would do but so we can easily update prev 1.2 indexes *)
    END;
    (* LONGCARD offset for entry[1]..., ALREADYDUMPEDCOOKIE i.e. MAX(LONGCARD) if dumped  *)

(* ------------------------------------------------------------ *)

VAR
    (* YAUG -- Yet Another Ugly Globerk *)
    (* we split fpos LONGCARD to 4 bytes : yes, we're NOT proud of it *)
    entryA  : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryB  : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryC  : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryD  : ARRAY [minCookie..maxCookie] OF SHORTCARD;

TYPE
    tricktype = RECORD
        CASE : BOOLEAN OF
        | TRUE:
            a,b,c,d:SHORTCARD; (* 4 bytes *)
        | FALSE:
            lc:LONGCARD;       (* 4 bytes too -- surprise ! *)
        END;
    END;
    str144 = ARRAY [0..144-1] OF CHAR; (* 128+16 just in case *)
CONST
    firstline  = 1;
    maxline    = 100; (* was 64, should be more than enough *)
VAR
    (* globerk'em the BASIC way ! ;-) but avoid compiling crash too ! *)
    sline  : ARRAY [firstline..maxline] OF str144; (* was str128 *)
    slen   : ARRAY [firstline..maxline] OF CARDINAL;
    lastline  : CARDINAL;
    longest   : CARDINAL;
CONST
    frameNone   = 0;
    frameSingle = 1;
    frameDouble = 2;
    frameAscii  = 3;
    frameRaw    = 4;
    minframe    = frameNone;
    maxframe    = frameRaw;
    msgWait       = "Hit any key to continue... ";
    msgWaitMouse  = "Hit any key or click any mouse button to continue... ";
    msgWaitFR     = "Appuyez sur une touche pour continuer... ";
    msgWaitMouseFR= "Appuyez sur une touche ou sur un bouton pour continuer... ";
CONST
    minpause     = 0;
    maxpause     = 30;
    defaultpause = 1;
    defaultalwayspause  = 10; (* always pause 1 seconds PLUS # s per line *)
CONST
    (*            012345     *)
    sSingle    = "ڳ";
    sDouble    = "ɺͼ";
    sAscii     = "+!++-+";
    sNone      = "      ";
CONST
    wiHORIZ    = 4; (* bar, space, ... , space, bar *)
    wiVERTI    = 4; (* line, filler, ... , filler, line *)
    wiHORIZalt = 2; (* space, ... , space *)
    wiVERTIalt = 2; (* filler, ... , filler *)

(* ------------------------------------------------------------ *)

CONST
    (* aliases for our own procedures *)
    WrStr ::= writeStr;
    WrLn  ::= writeLn;
    WrChar::= writeStr;
CONST
    progink   = cyan;
    progpaper = darkblue;

PROCEDURE colorhelp ();
BEGIN
    setTxtInk(getInkAtStartup());      (* was green *)
    setTxtPaper(getPaperAtStartup());  (* was black *)
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colorhelp;

PROCEDURE colortext (ink,paper:CARDINAL );
BEGIN
    setTxtInk   (VAL(colortype,ink));
    setTxtPaper (VAL(colortype,paper));
    setFillInkPaper(getInkAtStartup(),getPaperAtStartup());
END colortext;

(* ------------------------------------------------------------ *)

CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParameter      = 3;
    errNotFound       = 4;
    errBadNumber      = 5;
    errNotFoundReally = 6;
    errNotInNormalMode= 7;
    errInkRange       = 8;
    errPaperRange     = 9;
    errWidthRange     = 10;
    errTabRange       = 11;
    errPauseRange     = 12;
    errNotInSaverMode = 13;
    errTooManyFiles   = 14;
    errCookieVal      = 15;
    errCookieRange    = 16;
    errNotWithMultifile=17;
    errCmdConflict    = 18;
    errNoCookieYet    = 19;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
00000000011111111112222222222333333333344444444445555555555666666666677777777778
1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg=nl+
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [file["+extTXT+"]] [option]..."+nl+
nl+
"  -n:#   display cookie or tagline number # whatever its state (updated anyway)"+nl+
"  -i     reinit *"+extNDX+" index file (no cookie will be displayed twice in a cycle)"+nl+
"  -x[x]  show index statistics (-xx = alternate display)"+nl+
"  -t[t]  test for single character separator at start and at end of file"+nl+
"  -f:#   frame type (0=none, 1=single, 2=double, 3=ascii, 4=raw), default is 0"+nl+
"  -w[w]  wait for keypress or mouseclick (-ww = -w -m)"+nl+
"  -m     ignore mouse if present"+nl+
"  -p[p]  -w[w] with French prompt"+nl+
"  -n     add a newline (CR+LF) in order to beautify display (useful with PEXEC)"+nl+
"  -t:#   tab width [1..64], default is 8"+nl+
"  -i:#   ink [0..15], default is cyan"+nl+
"  -p:#   paper [0..15], default is dark blue"+nl+
"  -b     monochrome BIOS output (no colors)"+nl+
"  -o     reverse 8+3 format directory search sequence (current then executable)"+nl+
"  -w:#   set line width, default is screen width"+nl+
"  -s[s]  screensaver mode, next = Enter, quit = Escape (-ss = -s -c)"+nl+
"  -s:#   in screensaver mode, pause [0..30] in seconds per line, default is 1"+nl+
"  -m:#   in screensaver mode, minimum pause [0..30] in seconds, default is 10"+nl+
"  -z     in screensaver mode, next = left click, quit = right click"+nl+
"  -r     in screensaver mode, randomize position, default is center"+nl+
"  -c     in screensaver mode, do not clear screen at exit"+nl+
"  -13    apply ROT13 to each line"+nl+
"  -y     copy raw text to Vindoze clipboard if available (ignored by -s option)"+nl+
"  -lfn   disable LFN support even if available"+nl+
nl+
'a) Default data file is "'+ProgEXEname+extTXT+'".'+nl+
"   File specification should be unambiguous. Jokers are allowed."+nl+
'   "'+dot+'" and "'+star+'" specifications are replaced with "'+star+extTXT+'".'+nl+
"   If specified without path, data file is searched for"+nl+
"   first in executable directory, then in current directory."+nl+
"   If data file's first line is not a single character separator,"+nl+
"   tagline mode (single line entries) is assumed."+nl+
"   Data file's last line must be the single character separator"+nl+
"   (unless, of course, lines are taglines). Entries beyond "+sMAX+" are ignored."+nl+
"   If data file comes from *n*x world, it WILL require preprocessing :"+nl+
"   CRLF utility will change LF to CR+LF ; if file contains fortune cookies,"+nl+
"   the required single character separator must be prepended to file."+nl+
(* "   using CONCAT, WITH and USRBRAIN (!) DOS utilities."+nl+ *)
"b) Program will handle up to 200 files, always excluding from processing files"+nl+
"   matching *<"+extensions+">."+nl+
"c) -y option tries and converts text from DOS ASCII to Win OEM character set."+nl+
"d) -n:* will display most recently dumped cookie or tagline."+nl+
"e) Dark [0..7] : black, blue, green, cyan, red, magenta, brown and gray."+nl+
"   Bright [8..15] : gray, blue, green, cyan, red, magenta, yellow and white."+nl+
"f) With DR-DOS 6.0 or Novell DOS 7.0, "+ProgEXEname+" can be called after each"+nl+
"   external command by setting SET PEXEC=path\"+ProgEXEname+extEXE+" -n and PROMPT $x$p$g"+nl+
"g) NEVER forget Murphy's Law : "+'"If anything CAN go wrong, it WILL !" ;-)'+nl;

VAR
    S : str1024; (* was str256 *)
BEGIN
    colorhelp();
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption :
        S:='Illegal "~" option !';
    | errParameter :
        S:='"~" is one parameter too many !';
    | errNotFound:
        S:='No file matches "~" specification !';
    | errBadNumber:
        S:='Illegal value in "~" option !';
    | errNotFoundReally:
        S:='No file matches "~" specification anywhere !';
    | errNotInNormalMode:
        Str.Copy(S,einfo);
    | errInkRange:
        S := "Ink range is [0..15] !";
    | errPaperRange:
        S := "Paper range is [0..15] !";
    | errWidthRange:
        S := "Illegal width !";
    | errTabRange:
        S := "Tab width range is [1..64] !";
    | errPauseRange   :
        S := "Pause range is [0..30] !";
    | errNotInSaverMode:
        Str.Copy(S,einfo);
    | errTooManyFiles:
        S:='Too many files match "~" specification !';
    | errCookieVal:
        S:='Illegal "~" cookie value !';
    | errCookieRange:
        Str.Copy(S,einfo);
    | errNotWithMultifile:
        S := "-n:# option requires only one datafile !";
    | errCmdConflict:
        S := "-i, -x[x] and -t[t] options are mutually exclusive !";
    | errNoCookieYet:
        S := 'Most recent cookie in "~" is undefined !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        WrLn;
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    Lib.SetReturnCode(SHORTCARD(e));
    HALT;
END abort;

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead;
VAR
    IObuffer , IObufferx : ARRAY [1..IObufferSize] OF BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtbignum (v:LONGCARD; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr( v, S, base,ok);
    FOR i:=Str.Length(S)+1 TO ABS(wi) DO
         IF wi < 0 THEN
             Str.Append(S,pad);
         ELSE
             Str.Prepend(S,pad);
         END;
    END;
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END fmtbignum;

(* <s|g>etEntry require entry[A|B|C|D] globerks *)

PROCEDURE setEntry (i:CARDINAL; fpos:LONGCARD);
VAR
    trick : tricktype;
BEGIN
    trick.lc  := fpos;
    entryA[i] := trick.a;
    entryB[i] := trick.b;
    entryC[i] := trick.c;
    entryD[i] := trick.d;
END setEntry;

PROCEDURE getEntry (i:CARDINAL ):LONGCARD;
VAR
    trick : tricktype;
BEGIN
    trick.a := entryA[i];
    trick.b := entryB[i];
    trick.c := entryC[i];
    trick.d := entryD[i];
    RETURN trick.lc;
END getEntry;

PROCEDURE retrieveEntries (VAR indexheader:indexHeaderType; VAR valid:BOOLEAN;
                          hin:FIO.File;DEBUG:BOOLEAN);
VAR
    i,got,count:CARDINAL;
    trick:tricktype;
    lc:LONGCARD;
    fpos,fsize:LONGCARD;
BEGIN
    valid:=FALSE;

    indexheader.MOSTRECENTCOOKIE    := NOCOOKIEYET;
    indexheader.COUNTOFCOOKIES      := 0;

    setEntry(ndxCountCookie,0); (* safety *)

    fsize:=FIO.Size(hin);
    IF fsize < SIZE(indexheader) THEN RETURN; END; (* safety *)
    DEC(fsize,SIZE(indexheader));
    count:=CARDINAL ( fsize >> 2 ); (* faster DIV 4 *)
    IF count=0 THEN RETURN; END; (* safety *)

    got:=FIO.RdBin(hin,indexheader,SIZE(indexheader));
    IF same(indexheader.magic,strmagic)=FALSE THEN RETURN;END;

    valid:=TRUE;

    setEntry(firstCookie-1,LONGCARD(indexheader.COUNTOFCOOKIES)); (* [0] is count *)
    FOR i:= firstCookie TO count DO (* 1.. *)
        got:=FIO.RdBin(hin, trick, SIZE(trick));
        setEntry(i,trick.lc);
    END;

    IF DEBUG THEN
        lc := getEntry(ndxCountCookie); (* [0] *)
        WrLn;
        WrStr(fmtbignum( lc,10,5,space));
        WrStr(" entr");
        IF count < 2 THEN
            WrStr("y");
        ELSE
            WrStr("ies");
        END;
        WrLn;
        WrLn;
        count := CARDINAL (lc);
        FOR i:=firstCookie TO count DO (* 1.. *)
            fpos:=getEntry(i);
            WrStr( fmtbignum(LONGCARD(i),10,5,space));
            WrStr(" -- $");
            WrStr( fmtbignum(fpos,16,8,"0"));
            IF fpos = ALREADYDUMPEDCOOKIE THEN WrStr(" (used)"); END;
            WrLn;
        END;
        WrLn;
    END;

END retrieveEntries;

PROCEDURE getmostrecent (useLFN:BOOLEAN;indexfile:pathtype):CARDINAL;
VAR
    indexheader:indexHeaderType;
    hndx:FIO.File;
    got:CARDINAL;
BEGIN
    hndx:=fileOpenRead(useLFN,indexfile);
    got:=FIO.RdBin(hndx,indexheader,SIZE(indexheader));
    fileClose(useLFN,hndx);
    IF got # SIZE(indexheader) THEN RETURN NOCOOKIEYET;END; (* error but who cares ? *)
    IF same(indexheader.magic,strmagic)=FALSE THEN RETURN NOCOOKIEYET;END;

    RETURN indexheader.MOSTRECENTCOOKIE;
END getmostrecent;

(*
PROCEDURE mouseclick (  ):BOOLEAN;
VAR
    msdata:MsMouse.MsData;
BEGIN
    MsMouse.GetStatus(msdata);
    IF msdata.left_pressed THEN RETURN TRUE; END;
    IF msdata.right_pressed THEN RETURN TRUE; END;
    RETURN msdata.middle_pressed;
END mouseclick;
*)

CONST
    delai       = 100; (* 0.1 second *)
    delaimickey = 300; (* avoid too fast a change with a mouseclick *)
TYPE
    mousebuttonstype = SET OF (leftbutton,rightbutton,middlebutton);
VAR
    which : mousebuttonstype;

PROCEDURE mouseclick ( ):BOOLEAN;
VAR
    msdata:MsMouse.MsData;
BEGIN
    MsMouse.GetStatus(msdata);
    which:=mousebuttonstype{};
    IF msdata.left_pressed   THEN INCL(which,leftbutton); END;
    IF msdata.right_pressed  THEN INCL(which,rightbutton); END;
    IF msdata.middle_pressed THEN INCL(which,middlebutton);END;
    RETURN (which # mousebuttonstype{} );
END mouseclick;

PROCEDURE getLastPressed (  ):mousebuttonstype;
BEGIN
    Lib.Delay(delaimickey); (* force a small delay *)
    RETURN which;
END getLastPressed;

CONST
    keyEscape  = 01B00H;
    keySpace   = 02000H;
    keyCR      = 00D00H;

PROCEDURE flushKeyboard (  );
VAR
    c : CHAR;
BEGIN
    LOOP
        IF BiosIO.KeyPressed()=FALSE THEN EXIT; END;
        c := BiosIO.RdKey();
        IF c = CHR(0) THEN c := BiosIO.RdKey(); END;
    END;
END flushKeyboard;

PROCEDURE getKeyboardCode (VAR keycode:CARDINAL):BOOLEAN;
VAR
    c1,c2:CHAR;
BEGIN
    IF BiosIO.KeyPressed()=FALSE THEN RETURN FALSE; END;
    c1 := BiosIO.RdKey();
    IF c1 = CHR(0) THEN
        c2 := BiosIO.RdKey();
    ELSE
        c2 := CHR(0);
    END;
    keycode := (ORD(c1) << 8) + ORD(c2);
    RETURN TRUE;
END getKeyboardCode;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE detab (tabwidth:CARDINAL;S:ARRAY OF CHAR; VAR R : ARRAY OF CHAR  );
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabul THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END detab;

PROCEDURE stripANSI (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.Pos(S,cmdANSI);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        S[p]:="["; (* neutralize ! *)
    END;
END stripANSI;

PROCEDURE stripchar (ch:CHAR;  VAR S : ARRAY OF CHAR   );
VAR
    p:CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,ch);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1);
    END;
END stripchar;

(* english only *)

PROCEDURE unrot13me (VAR S : ARRAY OF CHAR );
CONST
    k=13;
VAR
    ch:CHAR;
    i:CARDINAL;
BEGIN
    FOR i:= 1 TO Str.Length(S) DO
        ch:=S[i-1];
        CASE ch OF
        | "A".."M", "a".."m" : S[i-1]:=CHR( ORD(ch)+k );
        | "N".."Z", "n".."z" : S[i-1]:=CHR( ORD(ch)-k );
        END;
    END;
END unrot13me;

PROCEDURE isTaglineFile (hnd:FIO.File;VAR separator:CHAR):BOOLEAN ;
VAR
    rc : BOOLEAN;
    S  : str2048; (* oversized *)
BEGIN
    LOOP
        FIO.RdStr(hnd,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE Str.Length(S) OF
        | 0 : ;
        | 1 :
            separator:=S[0];
            rc:=FALSE;
            EXIT;
        ELSE
            rc:=TRUE;
            EXIT;
        END;
        IF FIO.EOF THEN
            rc:=TRUE;
            EXIT;
        END;
    END;
    IF rc THEN FIO.Seek(hnd,0); END; (* not a fortune file : let's rewind ! *)
    RETURN rc;
END isTaglineFile;

PROCEDURE buildIndex (datafile,indexfile:pathtype;
                     useLFN,verbose:BOOLEAN;wantedcookie:CARDINAL;
                     VAR lastCookie:CARDINAL);
VAR
    S       : str2048; (* oversized *)
    pos     : LONGCARD;
    separator:CHAR;
    taglinemode:BOOLEAN;
    hnd,hndx:FIO.File;
    indexheader:indexHeaderType;
BEGIN
    IF wantedcookie # SHOWRANDOMCOOKIE THEN verbose:=FALSE;END; (* added safety *)

    IF verbose THEN
        WrStr("Building "); WrStr(indexfile); WrStr(" index file... ");
        Animation(cmdInit);
    END;

    hnd := fileOpenRead(useLFN,datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    taglinemode := isTaglineFile(hnd,separator);

    lastCookie := 0;
    IF wantedcookie = SHOWRANDOMCOOKIE THEN
        hndx := fileCreate(useLFN,indexfile);
        FIO.AssignBuffer(hndx,IObufferx);
        Str.Copy(indexheader.magic,        strmagic);
        indexheader.TAGLINEMODE         := taglinemode;
        indexheader.MOSTRECENTCOOKIE    := NOCOOKIEYET;
        indexheader.COUNTOFCOOKIES      := LONGCARD(lastCookie);
        FIO.WrBin(hndx,indexheader,SIZE(indexheader));
    END;

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        pos := FIO.GetPos(hnd);
        LOOP
            FIO.RdStr(hnd,S);
            IF verbose THEN Animation(cmdShow); END;
            IF taglinemode THEN
                LtrimBlanks(S);
                RtrimBlanks(S);
                IF Str.Length(S) > 0 THEN EXIT; END; (* skip empty taglines *)
            ELSE
                LtrimBlanks(S);
                RtrimBlanks(S);
                IF Str.Length(S) = 1 THEN (* stricter *)
                    IF S[0]=separator THEN EXIT;END;
                END;
            END;
            IF FIO.EOF THEN EXIT;END; (* avoid infinite loop *)
        END;
        IF FIO.EOF THEN EXIT; END; (* avoid adding unecessary last entry *)

        IF wantedcookie = SHOWRANDOMCOOKIE THEN
            FIO.WrBin(hndx,pos,SIZE(LONGCARD));
        END;
        INC(lastCookie);

        IF wantedcookie # SHOWRANDOMCOOKIE THEN
            IF wantedcookie = lastCookie THEN
                setEntry(wantedcookie, pos);
                EXIT;
            END;
        END;

        IF lastCookie >= maxCookie THEN EXIT; END;

    END;

    IF wantedcookie = SHOWRANDOMCOOKIE THEN
        FIO.Seek(hndx,0);
        indexheader.COUNTOFCOOKIES := LONGCARD(lastCookie);
        FIO.WrBin(hndx,indexheader,SIZE(indexheader));
        fileFlush(useLFN,hndx);
        fileClose(useLFN,hndx);
    END;

    fileClose(useLFN,hnd);

    IF verbose THEN
        Animation(cmdStop);
        WrStr( fmtbignum( LONGCARD(lastCookie),10,1," " ) );
        IF taglinemode THEN
            WrStr(" tagline");
        ELSE
            WrStr(" cookie");
        END;
        IF lastCookie > 1 THEN WrChar("s"); END;
        WrStr(" found !"); WrLn;
    END;
END buildIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkFortune ( datafile:pathtype;useLFN,terseTest:BOOLEAN  );
CONST
    msgWait     = "Checking, please wait...";
    msgTaglines = '::: Probably a tagline file : "~"';
    msgFortunes = '+++ Valid fortune file      : "~"';
    msgMissing  = '--- Missing final separator : "~"';
VAR
    S : str2048; (* oversized *)
    separator:CHAR;
    hnd:FIO.File;
    dmpme,wasSep : BOOLEAN;
BEGIN
    dmpme:=NOT(terseTest);
    video(msgWait,TRUE);

    hnd := fileOpenRead(useLFN,datafile);
    FIO.AssignBuffer(hnd,IObuffer);

    wasSep:= NOT ( isTaglineFile(hnd,separator) ); (* init it *)
    IF NOT(wasSep) THEN
        S:=msgTaglines;
    ELSE
        FIO.EOF:=FALSE;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hnd,S);
            LtrimBlanks(S);
            RtrimBlanks(S);
            CASE Str.Length(S) OF
            | 0 : ;
            | 1 : wasSep := ( S[0]=separator);
            ELSE
                  wasSep := FALSE;
            END;
            IF FIO.EOF THEN EXIT;END; (* avoid infinite loop *)
        END;

        IF wasSep THEN
            S:=msgFortunes;
        ELSE
            S:=msgMissing;
            dmpme:=TRUE;
        END;
    END;

    fileClose(useLFN,hnd);

    video(msgWait,FALSE);

    Str.Subst(S,"~",datafile);
    IF dmpme THEN WrStr(S);WrLn; END;
END chkFortune;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE getCookie (datafile,indexfile:pathtype;
                     doframe, tabwidth, LineWidth, wantedcookie:CARDINAL;
                     rotor,useLFN,DEBUG:BOOLEAN;
                     VAR lastcookie:CARDINAL):BOOLEAN;
CONST
    maxiter = LONGCARD(maxCookie) << 4;
VAR
    pos     : LONGCARD;
    cookid  : CARDINAL;
    separator:CHAR;
    freecookid:CARDINAL;
    iter:LONGCARD;
    S       : str2048; (* oversized *)
    R,R2    : str2048;

    splitagain : BOOLEAN;
    tmp        : str256;
    len        : CARDINAL;
    tmplen     : CARDINAL;
    stop       : BOOLEAN;
    taglinemode: BOOLEAN;
    hnd,hndx:FIO.File;
    indexheader: indexHeaderType;
    valid:BOOLEAN;
BEGIN
    CASE doframe OF
    | frameRaw : ;
    | frameNone:
        DEC(LineWidth,wiHORIZalt); (* sline string + 2 spaces *)
    ELSE
        DEC(LineWidth,wiHORIZ);    (* sline string + 2 spaces + 2 bars *)
    END;

    hnd := fileOpenRead(useLFN,datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    taglinemode := isTaglineFile(hnd,separator);

    IF wantedcookie # SHOWRANDOMCOOKIE THEN (* assume index already loaded *)
        pos:=getEntry(wantedcookie);
        cookid:=wantedcookie;
    END;

    hndx := fileOpen(useLFN,indexfile); (* RW because we'll update file *)
    FIO.AssignBuffer(hndx,IObufferx);
    retrieveEntries(indexheader,valid, hndx,DEBUG);
    IF NOT(valid) THEN
        fileClose(useLFN,hndx);
        fileClose(useLFN,hnd);
        RETURN FALSE;
    END;
    lastcookie := CARDINAL( getEntry(ndxCountCookie) );

    IF wantedcookie = SHOWRANDOMCOOKIE THEN

        (* check all Cookies have not been displayed *)

        cookid:=firstCookie; (* 1 *)
        LOOP
            pos:=getEntry(cookid);
            IF pos # ALREADYDUMPEDCOOKIE THEN freecookid:=cookid; EXIT; END;
            INC(cookid);
            IF cookid > lastcookie THEN
               fileClose(useLFN,hndx);
               fileClose(useLFN,hnd);
               RETURN FALSE;
            END;
        END;

        (* now find a not yet displayed Cookie, preventing impossible infinite loop *)

        iter:=0;
        LOOP
            cookid := GetRndCardRange(firstCookie,lastcookie);
            INC(iter);
            IF iter > maxiter THEN cookid:=freecookid; END; (* we're already waiting too long *)
            pos:=getEntry(cookid);
            IF pos # ALREADYDUMPEDCOOKIE THEN EXIT; END;
        END;

    END;

    (* get it *)

    FIO.EOF:=FALSE; (* force it *)
    FIO.Seek(hnd,pos);

    lastline  := 0;
    longest   := 0;
    LOOP
        FIO.RdStr(hnd,R);
        IF NOT(taglinemode) THEN
            Str.Copy(S,R);
            LtrimBlanks(S);
            RtrimBlanks(S);
            IF Str.Length(S) = 1 THEN (* stricter *)
                IF S[0]=separator THEN EXIT;END;
            END;
        END;

        stripANSI(R);
        stripchar(bs,R);
        IF rotor THEN unrot13me(R);END;

        detab (tabwidth,R,R2);
        Str.Copy(R,R2);
        len:=Str.Length(R);

        IF len > LineWidth THEN
            stop:=FALSE;
            splitagain:=dmpTTX(R,LineWidth,tmp,TRUE);
            WHILE splitagain DO
                Str.Copy( sline[firstline+lastline],tmp);
                tmplen:=Str.Length(tmp);
                slen[firstline+lastline]:=tmplen;
                IF tmplen > longest THEN longest := tmplen; END;
                INC(lastline);
                IF lastline >= maxline THEN stop:=TRUE; EXIT; END;
                splitagain:=dmpTTX(R,LineWidth,tmp,FALSE);
            END;
            IF stop THEN EXIT; END;
        ELSE
            Str.Copy( sline[firstline+lastline],R);
            slen[firstline+lastline]:=len;
            IF len > longest THEN longest := len; END;
            INC(lastline);
            IF lastline >= maxline THEN EXIT; END;
        END;

        IF taglinemode THEN EXIT; END;
        IF FIO.EOF THEN EXIT; END;
    END;

    (* mark it as used *)

    pos:=SIZE(indexHeaderType) + LONGCARD(cookid-1) * SIZE(LONGCARD); (* cookid is 1-based *)
    FIO.Seek(hndx,pos);

    pos:=ALREADYDUMPEDCOOKIE;
    FIO.WrBin(hndx,pos,SIZE(LONGCARD));

    (* save most recent *)

    indexheader.MOSTRECENTCOOKIE := cookid;
    FIO.Seek(hndx,0);
    FIO.WrBin(hndx,indexheader,SIZE(indexheader));

    fileFlush(useLFN,hndx);
    fileClose(useLFN,hndx);
    fileClose(useLFN,hnd);
    RETURN TRUE;
END getCookie;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE newExtension (VAR index:pathtype ;ext:pathtype);
VAR
    u,d,n,e : pathtype;
BEGIN
    qdSplitAllPath(index,u,d,n,e);
    Lib.MakeAllPath(index,u,d,n,ext);
END newExtension;

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE dmpCookie (screenwidth,linewidth,doFrame:CARDINAL;redirected,doBeautify:BOOLEAN);
VAR
    len,plus   : CARDINAL;
    frameChars : str128;
    i,j,k      : CARDINAL;
    S          : str128;
    neednl     : BOOLEAN;
BEGIN
    len := longest;
    (*
    IF doFrame # frameRaw THEN
        IF getWindowWidth() <= (len+wiHORIZ) THEN doFrame:=frameRaw; END; (* sline string + 2 spaces + 2 bars *) (* BUGFIX : was < *)
        IF getWindowWidth() <= (len+wiHORIZ+1) THEN doFrame:=frameRaw; END; (* sline string + 2 spaces + 2 bars + 1 for exactly 80 columns *) (* CAKE bugfix *)
    END;
    *)
    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    | frameAscii  : frameChars := sAscii;  plus:=2;
    END;

    CASE doFrame OF
    | frameRaw :
        WrLn;
        FOR j:=firstline TO lastline DO
            WrStr( sline[j]);
            neednl :=( slen[j] < linewidth );
            neednl :=(neednl OR redirected);
            neednl :=(neednl OR (linewidth # screenwidth) ); (* < *)
            IF neednl THEN WrLn; END;
        END;

    ELSE

        neednl := ((1+len+plus+1) < linewidth );
        neednl := (neednl OR redirected );
        neednl := (neednl OR (linewidth # screenwidth) ); (* < *)

        WrLn;
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        IF neednl THEN WrLn; END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        FOR j:=firstline TO lastline DO
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr( sline[j]);
            FOR k:=Str.Length( sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        IF neednl THEN WrLn; END;
    END;
    IF doBeautify THEN WrLn; END;
END dmpCookie;

PROCEDURE forcepause (stopmouse:BOOLEAN; alwayspause,pause,first,last:CARDINAL );
VAR
    i,j:CARDINAL;
BEGIN
    FOR i := 1 TO alwayspause*10 DO
        IF BiosIO.KeyPressed() THEN RETURN;END;
        IF stopmouse THEN
            IF mouseclick() THEN RETURN;  END;
        END;
        Lib.Delay(delai);
    END;
    FOR j:=first TO last DO
        FOR i := 1 TO pause*10 DO
            IF BiosIO.KeyPressed() THEN RETURN; END;
            IF stopmouse THEN
                IF mouseclick() THEN RETURN; END;
            END;
            Lib.Delay(delai);
        END;
    END;
END forcepause;

(*
    yes, yes, we know we should have rewritten dmpCookie in a more general way...
    useless here to check linelength against linewidth
*)

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE dmpCookieAt (doFrame:CARDINAL;
                       alwayspause,pause:CARDINAL;atrandompos,stopmouse:BOOLEAN );
VAR
    len,i,j,k,plus : CARDINAL;
    frameChars     : str16;
    S              : str128;
VAR
    mini,maxi,wi,ws,v,htab,vtab : CARDINAL;
BEGIN
    mini := getMinHtab(); (* 0.. *)
    maxi := getMaxHtab();
    wi := maxi-mini+1;
    ws := longest;
    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        INC(ws,wiHORIZalt);
    ELSE
        INC(ws,wiHORIZ);
    END;
    IF wi > ws THEN
        IF atrandompos THEN
            v:=GetRndCardRange(1,wi-ws) -1;
        ELSE
            v:=(wi-ws) DIV 2;
        END;
    ELSE
        v := 0;
    END;
    htab := mini+v;

    mini := getMinVtab(); (* 0.. *)
    maxi := getMaxVtab();
    wi := maxi-mini+1;
    ws := lastline-firstline+1;
    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        INC(ws,wiVERTIalt);
    ELSE
        INC(ws,wiVERTI);
    END;
    IF wi > ws THEN
        IF atrandompos THEN
            v:=GetRndCardRange(1,wi-ws) -1;
        ELSE
            v:=(wi-ws) DIV 2;
        END;
    ELSE
        v := 0;
    END;
    vtab := mini+v;

    len := longest;
    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    | frameAscii  : frameChars := sAscii;  plus:=2;
    END;

    CASE doFrame OF
    | frameRaw :
        FOR j:=firstline TO lastline DO
            gotoXY(htab,vtab);
            WrStr( sline[j]);
            INC(vtab);
        END;
    ELSE
        gotoXY(htab,vtab);
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        INC(vtab);

        IF doFrame # frameNone THEN
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        FOR j:=firstline TO lastline DO
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr( sline[j]);
            FOR k:=Str.Length( sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        IF doFrame # frameNone THEN
            gotoXY(htab,vtab);
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            INC(vtab);
        END;

        gotoXY(htab,vtab);
        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        INC(vtab);
    END;
    forcepause(stopmouse,alwayspause,pause,firstline,lastline);
END dmpCookieAt;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a last revised 29 Apr 00 *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TpcTOwin  = CharTable (
    chardef(000H, "=", 000H),
    chardef(001H, "=", 001H),
    chardef(002H, "=", 002H),
    chardef(003H, "=", 003H),
    chardef(004H, "=", 004H),
    chardef(005H, "=", 005H),
    chardef(006H, "=", 006H),
    chardef(007H, "=", 007H),
    chardef(008H, "=", 008H),
    chardef(009H, "!", 009H),
    chardef(00AH, "=", 00AH),
    chardef(00BH, "=", 00BH),
    chardef(00CH, "=", 00CH),
    chardef(00DH, "=", 00DH),
    chardef(00EH, "=", 00EH),
    chardef(00FH, "=", 00FH),
    chardef(010H, "=", 010H),
    chardef(011H, "=", 011H),
    chardef(012H, "=", 012H),
    chardef(013H, "=", 013H),
    chardef(014H, "!", 0B6H),
    chardef(015H, "!", 0A7H),
    chardef(016H, "=", 016H),
    chardef(017H, "=", 017H),
    chardef(018H, "=", 018H),
    chardef(019H, "=", 019H),
    chardef(01AH, "=", 01AH),
    chardef(01BH, "=", 01BH),
    chardef(01CH, "=", 01CH),
    chardef(01DH, "=", 01DH),
    chardef(01EH, "=", 01EH),
    chardef(01FH, "=", 01FH),
    chardef(020H, "=",  " "),
    chardef(021H, "=",  "!"),
    chardef(022H, "=",  '"'),
    chardef(023H, "=",  "#"),
    chardef(024H, "=",  "$"),
    chardef(025H, "=",  "%"),
    chardef(026H, "=",  "&"),
    chardef(027H, "=",  "'"),
    chardef(028H, "=",  "("),
    chardef(029H, "=",  ")"),
    chardef(02AH, "=",  "*"),
    chardef(02BH, "=",  "+"),
    chardef(02CH, "=",  ","),
    chardef(02DH, "=",  "-"),
    chardef(02EH, "=",  "."),
    chardef(02FH, "=",  "/"),
    chardef(030H, "=",  "0"),
    chardef(031H, "=",  "1"),
    chardef(032H, "=",  "2"),
    chardef(033H, "=",  "3"),
    chardef(034H, "=",  "4"),
    chardef(035H, "=",  "5"),
    chardef(036H, "=",  "6"),
    chardef(037H, "=",  "7"),
    chardef(038H, "=",  "8"),
    chardef(039H, "=",  "9"),
    chardef(03AH, "=",  ":"),
    chardef(03BH, "=",  ";"),
    chardef(03CH, "=",  "<"),
    chardef(03DH, "=",  "="),
    chardef(03EH, "=",  ">"),
    chardef(03FH, "=",  "?"),
    chardef(040H, "=",  "@"),
    chardef(041H, "=",  "A"),
    chardef(042H, "=",  "B"),
    chardef(043H, "=",  "C"),
    chardef(044H, "=",  "D"),
    chardef(045H, "=",  "E"),
    chardef(046H, "=",  "F"),
    chardef(047H, "=",  "G"),
    chardef(048H, "=",  "H"),
    chardef(049H, "=",  "I"),
    chardef(04AH, "=",  "J"),
    chardef(04BH, "=",  "K"),
    chardef(04CH, "=",  "L"),
    chardef(04DH, "=",  "M"),
    chardef(04EH, "=",  "N"),
    chardef(04FH, "=",  "O"),
    chardef(050H, "=",  "P"),
    chardef(051H, "=",  "Q"),
    chardef(052H, "=",  "R"),
    chardef(053H, "=",  "S"),
    chardef(054H, "=",  "T"),
    chardef(055H, "=",  "U"),
    chardef(056H, "=",  "V"),
    chardef(057H, "=",  "W"),
    chardef(058H, "=",  "X"),
    chardef(059H, "=",  "Y"),
    chardef(05AH, "=",  "Z"),
    chardef(05BH, "=",  "["),
    chardef(05CH, "=",  "\"),
    chardef(05DH, "=",  "]"),
    chardef(05EH, "=",  "^"),
    chardef(05FH, "=",  "_"),
    chardef(060H, "=",  "`"),
    chardef(061H, "=",  "a"),
    chardef(062H, "=",  "b"),
    chardef(063H, "=",  "c"),
    chardef(064H, "=",  "d"),
    chardef(065H, "=",  "e"),
    chardef(066H, "=",  "f"),
    chardef(067H, "=",  "g"),
    chardef(068H, "=",  "h"),
    chardef(069H, "=",  "i"),
    chardef(06AH, "=",  "j"),
    chardef(06BH, "=",  "k"),
    chardef(06CH, "=",  "l"),
    chardef(06DH, "=",  "m"),
    chardef(06EH, "=",  "n"),
    chardef(06FH, "=",  "o"),
    chardef(070H, "=",  "p"),
    chardef(071H, "=",  "q"),
    chardef(072H, "=",  "r"),
    chardef(073H, "=",  "s"),
    chardef(074H, "=",  "t"),
    chardef(075H, "=",  "u"),
    chardef(076H, "=",  "v"),
    chardef(077H, "=",  "w"),
    chardef(078H, "=",  "x"),
    chardef(079H, "=",  "y"),
    chardef(07AH, "=",  "z"),
    chardef(07BH, "=",  "{"),
    chardef(07CH, "=",  "|"),
    chardef(07DH, "=",  "}"),
    chardef(07EH, "=",  "~"),
    chardef(07FH, "?",  " "),
    chardef(080H, "=", 0C7H),
    chardef(081H, "=", 0FCH),
    chardef(082H, "=", 0E9H),
    chardef(083H, "=", 0E2H),
    chardef(084H, "=", 0E4H),
    chardef(085H, "=", 0E0H),
    chardef(086H, "=", 0E5H),
    chardef(087H, "=", 0E7H),
    chardef(088H, "=", 0EAH),
    chardef(089H, "=", 0EBH),
    chardef(08AH, "=", 0E8H),
    chardef(08BH, "=", 0EFH),
    chardef(08CH, "=", 0EEH),
    chardef(08DH, "=", 0ECH),
    chardef(08EH, "=", 0C4H),
    chardef(08FH, "=", 0C5H),
    chardef(090H, "=", 0C9H),
    chardef(091H, "=", 0E6H),
    chardef(092H, "=", 0C6H),
    chardef(093H, "=", 0F4H),
    chardef(094H, "=", 0F6H),
    chardef(095H, "=", 0F2H),
    chardef(096H, "=", 0FBH),
    chardef(097H, "=", 0F9H),
    chardef(098H, "=", 0FFH),
    chardef(099H, "=", 0D6H),
    chardef(09AH, "=", 0DCH),
    chardef(09BH, "=", 0A2H),
    chardef(09CH, "=", 0A3H),
    chardef(09DH, "=", 0A5H),
    chardef(09EH, "?",  " "),
    chardef(09FH, "?",  " "),
    chardef(0A0H, "=", 0E1H),
    chardef(0A1H, "=", 0EDH),
    chardef(0A2H, "=", 0F3H),
    chardef(0A3H, "=", 0FAH),
    chardef(0A4H, "=", 0F1H),
    chardef(0A5H, "=", 0D1H),
    chardef(0A6H, "=", 0AAH),
    chardef(0A7H, "=", 0BAH),
    chardef(0A8H, "=", 0BFH),
    chardef(0A9H, "?",  " "),
    chardef(0AAH, "=", 0ACH),
    chardef(0ABH, "=", 0BDH),
    chardef(0ACH, "=", 0BCH),
    chardef(0ADH, "=", 0A1H),
    chardef(0AEH, "=", 0ABH),
    chardef(0AFH, "=", 0BBH),
    chardef(0B0H, "@",  " "),
    chardef(0B1H, "@",  " "),
    chardef(0B2H, "@",  " "),
    chardef(0B3H, "@",  " "),
    chardef(0B4H, "@",  " "),
    chardef(0B5H, "@",  " "),
    chardef(0B6H, "@",  " "),
    chardef(0B7H, "@",  " "),
    chardef(0B8H, "@",  " "),
    chardef(0B9H, "@",  " "),
    chardef(0BAH, "@",  " "),
    chardef(0BBH, "@",  " "),
    chardef(0BCH, "@",  " "),
    chardef(0BDH, "@",  " "),
    chardef(0BEH, "@",  " "),
    chardef(0BFH, "@",  " "),
    chardef(0C0H, "@",  " "),
    chardef(0C1H, "@",  " "),
    chardef(0C2H, "@",  " "),
    chardef(0C3H, "@",  " "),
    chardef(0C4H, "@",  " "),
    chardef(0C5H, "@",  " "),
    chardef(0C6H, "@",  " "),
    chardef(0C7H, "@",  " "),
    chardef(0C8H, "@",  " "),
    chardef(0C9H, "@",  " "),
    chardef(0CAH, "@",  " "),
    chardef(0CBH, "@",  " "),
    chardef(0CCH, "@",  " "),
    chardef(0CDH, "@",  " "),
    chardef(0CEH, "@",  " "),
    chardef(0CFH, "@",  " "),
    chardef(0D0H, "@",  " "),
    chardef(0D1H, "@",  " "),
    chardef(0D2H, "@",  " "),
    chardef(0D3H, "@",  " "),
    chardef(0D4H, "@",  " "),
    chardef(0D5H, "@",  " "),
    chardef(0D6H, "@",  " "),
    chardef(0D7H, "@",  " "),
    chardef(0D8H, "@",  " "),
    chardef(0D9H, "@",  " "),
    chardef(0DAH, "@",  " "),
    chardef(0DBH, "@",  " "),
    chardef(0DCH, "@",  " "),
    chardef(0DDH, "@",  " "),
    chardef(0DEH, "@",  " "),
    chardef(0DFH, "@",  " "),
    chardef(0E0H, "?",  " "),
    chardef(0E1H, "=", 0DFH),
    chardef(0E2H, "?",  " "),
    chardef(0E3H, "?",  " "),
    chardef(0E4H, "?",  " "),
    chardef(0E5H, "?",  " "),
    chardef(0E6H, "=", 0B5H),
    chardef(0E7H, "?",  " "),
    chardef(0E8H, "?",  " "),
    chardef(0E9H, "?",  " "),
    chardef(0EAH, "?",  " "),
    chardef(0EBH, "?",  " "),
    chardef(0ECH, "?",  " "),
    chardef(0EDH, "=", 0D8H),
    chardef(0EEH, "?",  " "),
    chardef(0EFH, "?",  " "),
    chardef(0F0H, "?",  " "),
    chardef(0F1H, "=", 0B1H),
    chardef(0F2H, "?",  " "),
    chardef(0F3H, "?",  " "),
    chardef(0F4H, "?",  " "),
    chardef(0F5H, "?",  " "),
    chardef(0F6H, "=", 0F7H),
    chardef(0F7H, "?",  " "),
    chardef(0F8H, "=", 0B0H),
    chardef(0F9H, "?",  " "),
    chardef(0FAH, "?",  " "),
    chardef(0FBH, "?",  " "),
    chardef(0FCH, "?",  " "),
    chardef(0FDH, "=", 0B2H),
    chardef(0FEH, "?",  " "),
    chardef(0FFH, "=",  " "));

(* we don't care about flag here *)

PROCEDURE remap2oem (ch:CHAR):CHAR;
BEGIN
    RETURN TpcTOwin[ ORD(ch) ].MapChar;
END remap2oem;

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE dmpToClipboard (lastline:CARDINAL):BOOLEAN ;
CONST
    multiplex = 2FH;
VAR
    R : SYSTEM.Registers;
VAR
    Z : str4096;
    i,j:CARDINAL;
    ch,newch:CHAR;
BEGIN
    R.AX := 1700H; (* INT 2F - MS Windows "WINOLDAP" - IDENTIFY WinOldAp version *)
    Lib.Intr(R,multiplex);
    IF R.AX = 1700H THEN RETURN FALSE; END; (* clipboard not supported *)

    R.AX := 1701H; (* INT 2F - MS Windows "WINOLDAP" - OPEN CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* clipboard already open *)

    R.AX := 1702H; (* INT 2F - MS Windows "WINOLDAP" - EMPTY CLIPBOARD *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN RETURN FALSE; END; (* failure to empty clipboard *)

    Z := "";
    FOR i:=firstline TO lastline DO
        FOR j:= 1 TO slen[i] DO
            ch:=sline[i][j-1];
            newch:=remap2oem(ch); (* should do *)
            Str.Append(Z,newch);
        END;
        IF i < lastline THEN Str.Append(Z,nl); END; (* leave paste cursor at last typed char *)
    END;

    R.AX := 1703H; (* INT 2F - MS Windows "WINOLDAP" - SET CLIPBOARD DATA *)
    R.DX := 1; (* 1=text, 7=OEM text *)
    R.ES := Seg(Z);
    R.BX := Ofs(Z);
    R.SI := 0;                (* hugeStr is never more than 4096 *)
    R.CX := Str.Length(Z); (* idem *)
    Lib.Intr(R,multiplex);
    IF R.AX = 0 THEN (* failure to copy data to clipboard *)
        ; (* we should return FALSE here but we'll force closeclipboard for safety *)
    END;

    R.AX := 1708H; (* INT 2F - MS Windows "WINOLDAP" - CloseClipboard *)
    Lib.Intr(R,multiplex);
    RETURN (R.AX # 0);
END dmpToClipboard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showIndexStatistics (indexfile:pathtype; useLFN,flagWide,DEBUG:BOOLEAN);
VAR
    total,used,unused   : CARDINAL;
VAR
    i       : CARDINAL;
    pos     : LONGCARD;
    count   : CARDINAL;
    percent : LONGREAL;
    S       : str128;
    ok      : BOOLEAN;
    hndx:FIO.File;
    indexheader : indexHeaderType;
    valid:BOOLEAN;
BEGIN
    hndx := fileOpenRead(useLFN,indexfile); (* // was fileOpen() *)
    FIO.AssignBuffer(hndx,IObufferx);
    retrieveEntries(indexheader,valid, hndx,DEBUG);
    fileClose(useLFN,hndx);
    IF NOT(valid) THEN
        WrStr('--- Invalid "');WrStr(indexfile);WrStr('" index file !');WrLn;
        RETURN;
    END;

    total := CARDINAL( getEntry(ndxCountCookie) );

    used  := 0;
    unused:= 0;
    FOR i := firstCookie TO total DO
        pos:= getEntry(i);
        IF pos = ALREADYDUMPEDCOOKIE THEN
            INC(used);
        ELSE
            INC(unused);
        END;
    END;

    CASE flagWide OF
    | FALSE:
        WrLn;
        WrStr("Index file        : "); WrStr(indexfile); WrLn;
        WrStr("File type         : ");
        IF indexheader.TAGLINEMODE THEN
            S:="taglines";
        ELSE
            S:="fortunes";
        END;
        WrStr(S);WrLn;
        WrStr("Total entries     : "); WrStr(fmtbignum( LONGCARD(total ),10,5,space));WrLn;
        WrStr("Used entries      : "); WrStr(fmtbignum( LONGCARD(used  ),10,5,space));WrLn;
        WrStr("Unused entries    : "); WrStr(fmtbignum( LONGCARD(unused),10,5,space));WrLn;
        WrStr("Most recent entry : ");
        IF indexheader.MOSTRECENTCOOKIE = NOCOOKIEYET THEN
            S:="undefined";
        ELSE
            Str.Copy(S,fmtbignum( LONGCARD(indexheader.MOSTRECENTCOOKIE),10,5,space));
        END;
        WrStr(S);WrLn;
    | TRUE:
        IF total = 0 THEN
            percent := 0.0;
        ELSE
            (* warning ! here, we need to sync bios, dos and our crt ! *)
            percent := (LONGREAL(used) / LONGREAL(total) ) * 100.0;
        END;
        WrStr(fmtbignum( LONGCARD(used ),10,5,space));
        Str.FixRealToStr(percent,1,S,ok);
        FOR i := Str.Length(S)+1 TO 3+1+1 DO
            Str.Prepend(S," ");
        END;
        WrStr(" ("); WrStr(S); WrStr("%) used out of ");
        WrStr(fmtbignum( LONGCARD(total),10,5,space));
        WrStr(" in "); WrStr(indexfile); WrLn;
    END;
END showIndexStatistics;

(* ------------------------------------------------------------ *)

(* q&d check : any "\" or ":" means a path *)

PROCEDURE nopathhere (S:pathtype):BOOLEAN;
BEGIN
    IF Str.CharPos(S,backslash) # MAX(CARDINAL) THEN RETURN FALSE; END;
    RETURN ( Str.CharPos(S,colon)=MAX(CARDINAL) );
END nopathhere;

PROCEDURE prependexepath (exe:pathtype; VAR dat : pathtype);
VAR
    u,d,f8,e3:pathtype;
    uz,dz,f8z,e3z:pathtype;
BEGIN
    qdSplitAllPath(exe,u,d,f8,e3);
    qdSplitAllPath(dat,uz,dz,f8z,e3z);
    Lib.MakeAllPath(dat,u,d,f8z,e3z);
END prependexepath;

PROCEDURE initFileNames (VAR exe,dat:pathtype);
VAR
    tmpdat,u,d,f8,e3:pathtype;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(exe,0);
    qdSplitAllPath(exe,u,d,f8,e3);
    Lib.MakeAllPath(tmpdat,"","",f8,e3);
    p:=Str.RCharPos(tmpdat,dot);
    IF p # MAX(CARDINAL) THEN tmpdat[p]:=CHR(0);END;
    Str.Concat(dat,tmpdat,extTXT);
END initFileNames;

(* ------------------------------------------------------------ *)

CONST
    firstfile = 1;
    maxfile   = 200; (* should be enough *)
VAR
    fileArray : ARRAY [firstfile..maxfile] OF pathtype;

PROCEDURE legalextension (S:pathtype):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    LOOP
        isoleItemS(e3, extensions,delim,n);
        IF same(e3,"") THEN EXIT; END;
        IF Str.Pos(S,e3) # MAX(CARDINAL) THEN rc:=FALSE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
CONST
    defaultdrive = SHORTCARD(0);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        Str.Concat(basepath, CHAR( ORD("A")-1+ FIO.GetDrive()), ":");
        FIO.GetDir(defaultdrive,d);
        Str.Append(basepath,d);
        fixDirectory(basepath); (* in case *)
    END;
END makebase;

PROCEDURE isDirEntry (S : pathtype) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isDirEntry;

(* anyone storing more than 65536 files in a single directory is a madman ! *)

PROCEDURE readDirectory (useLFN,DEBUG:BOOLEAN;orgspec:pathtype;
                         VAR basepath:pathtype) : CARDINAL;
CONST
    dbgSpec = "::: Filespec         : ";
    dbgYep  = "+++ Included [~] : ";
    dbgNope = "--- Excluded         : ";
VAR
    fentry    : FIO.DirEntry;
    last      : CARDINAL;
    found     : BOOLEAN;
    spec      : pathtype;
    w9Xentry  : findDataRecordType;
    unicodeconversion:unicodeConversionFlagType;
    w9Xhandle,errcode:CARDINAL;
    fname:pathtype;
    rc,includeme:BOOLEAN;
    S:str128;
BEGIN
    Str.Copy(spec,orgspec);
    makebase (spec,basepath); (* yes, we'll mix f83 and LFN *)

    IF DEBUG THEN WrStr(dbgSpec);WrStr(spec);WrLn;WrLn;END;

    last:=firstfile-1; (* 0 *)

    IF useLFN THEN
        found := w9XfindFirst (spec,SHORTCARD(everything),SHORTCARD(w9XnothingRequired),
                              unicodeconversion,w9Xentry,w9Xhandle,errcode);
    ELSE
        found := FIO.ReadFirstEntry(spec,everything,fentry);
    END;
    LOOP
        IF NOT(found) THEN EXIT; END;
        IF useLFN THEN
            Str.Copy(fname,w9Xentry.fullfilename);
        ELSE
            Str.Copy(fname,fentry.Name);
        END;
        IF isDirEntry(fname)=FALSE THEN (* skip . AND .. *)
            includeme:=legalextension(fname);
            IF includeme THEN
                INC(last);
                IF last > maxfile THEN last:=MAX(CARDINAL);EXIT;END;
                Str.Copy(fileArray[last],fname);
            END;
            IF DEBUG THEN
                IF includeme THEN
                    S:=dbgYep;
                    Str.Subst(S,"~",fmtbignum(LONGCARD(last),10,5,space));
                ELSE
                    S:=dbgNope;
                END;
                WrStr(S);
                IF useLFN THEN WrStr(dquote);END;
                WrStr(fname);
                IF useLFN THEN WrStr(dquote);END;
                WrLn;
            END;
        END;
        IF useLFN THEN
            found :=w9XfindNext(w9Xhandle, unicodeconversion,w9Xentry,errcode);
        ELSE
            found :=FIO.ReadNextEntry(fentry);
        END;
    END;
    IF useLFN THEN rc:=w9XfindClose(w9Xhandle,errcode); END;

    RETURN last;
END readDirectory;

(* ripped from MPAUSE *)

PROCEDURE MouseDriverHere ( ) : BOOLEAN;
CONST
    MouseInt   = 033H;
CONST
    InstallChk = 00000H;
VAR
    R : SYSTEM.Registers;
BEGIN
    (*
    R.AX := InstallChk;
    Lib.Intr(R,MouseInt);
    RETURN (R.AX # 0);
    *)
    RETURN (MsMouse.Reset() # MAX(INTEGER) ); (* InstallChk is Reset ! *)
END MouseDriverHere;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    mincolumns  = 1+1+1+1+1;
    mintabwidth = 1;
    maxtabwidth = 64;
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype;
    spec,basepath,exefile,datafile,indexfile : pathtype;
    terseTest,cmdTest, cmdIndex,doWait, doBeautify, cmdStats, doStatsWide : BOOLEAN;
    doFrame, tabwidth,maxcolumns,LineWidth,screenwidth:CARDINAL;
    tagcount  : LONGCARD;
    state     : (waiting,gotDatafile);
    v         : LONGCARD;
    c1,c2     : CHAR;
    ink,paper,lastcookie,wantedcookie,rc,filecount : CARDINAL;
    savermode,stopmouse,atrandompos,docls,FRprompt,rotor:BOOLEAN;
    useLFN,usemouse,exedirfirst:BOOLEAN;
    pause,alwayspause:CARDINAL;
    redirected,ok,chk:BOOLEAN;
    keycode:CARDINAL;
    mousebuttons:mousebuttonstype;
    toclipboard,clipok:BOOLEAN;
    DEBUG:BOOLEAN;
    Z:str2;
BEGIN
    Lib.DisableBreakCheck();
    FIO.IOcheck:=FALSE;

    (* handleVesa; *) (* useless, because we won't change video mode *)
    setUseBiosMode ( IsRedirected() );
    findInkPaperAtStartup();
    colorhelp;

    redirected:=IsRedirected();

    screenwidth := getWindowWidth(); (* no longer -1, 80 no longer becomes 79 *)

    InitRnd();

    initFileNames(exefile,spec);

    cmdIndex   := FALSE;
    doFrame    := frameNone;
    doWait     := FALSE;
    doBeautify := FALSE;
    cmdStats   := FALSE;
    ink        := ORD(progink);
    paper      := ORD(progpaper);
    LineWidth  := screenwidth;
    maxcolumns := screenwidth;
    tabwidth   := 8;
    savermode  := FALSE;
    stopmouse  := FALSE;
    atrandompos:= FALSE;
    pause      := defaultpause;
    alwayspause:= defaultalwayspause;
    docls      := FALSE;
    wantedcookie:=SHOWRANDOMCOOKIE;
    FRprompt   := FALSE;
    usemouse   := TRUE;
    exedirfirst:= TRUE;
    rotor      := FALSE;
    useLFN     := TRUE;
    cmdTest    := FALSE;
    terseTest  := FALSE;
    toclipboard:= FALSE;
    DEBUG      := FALSE;

    state      := waiting;
    parmcount  := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "I"+delim+"INIT"+delim+
                                 "F:"+delim+"FRAME:"+delim+
                                 "W"+delim+"WAIT"+delim+
                                 "N"+delim+"NEWLINE"+delim+"CR"+delim+"CRLF"+delim+
                                 "I:"+delim+"INK:"+delim+
                                 "P:"+delim+"PAPER:"+delim+
                                 "B"+delim+"BIOS"+delim+
                                 "T:"+delim+"TAB:"+delim+
                                 "X"+delim+
                                 "XX"+delim+
                                 "W:"+delim+"WIDTH:"+delim+
                                 "S"+delim+"SAVER"+delim+"SHOW"+delim+
                                 "S:"+delim+"PAUSE:"+delim+
                                 "Z"+delim+"MOUSECLICK"+delim+
                                 "R"+delim+"RANDOMPOS"+delim+
                                 "C"+delim+
                                 "M:"+delim+"MINIMUM:"+delim+
                                 "SS"+delim+"SC"+delim+
                                 "N:"+delim+"NUMBER:"+delim+
                                 "M"+delim+"MOUSE"+delim+
                                 "WW"+delim+"WM"+delim+
                                 "P"+delim+
                                 "PP"+delim+
                                 "O"+delim+"ORDER"+delim+
                                 "L"+delim+"LFN"+delim+
                                 "13"+delim+"ROT13"+delim+
                                 "T"+delim+"TEST"+delim+
                                 "TT"+delim+"TESTQUIET"+delim+
                                 "Y"+delim+"CLIPBOARD"+delim+
                                 "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5 :
                cmdIndex := TRUE;
            | 6,7 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minframe) OR (v > maxframe) ) THEN abort(errBadNumber,S); END;
                doFrame:=CARDINAL(v);
            | 8,9 :
                doWait  := TRUE;
            | 10,11,12,13:
                doBeautify  := TRUE;
            | 14,15:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errInkRange,"");END;
                ink:=CARDINAL(v);
            | 16,17:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolor) OR (v > maxcolor) ) THEN abort(errPaperRange,"");END;
                paper:=CARDINAL(v);
            | 18,19:
                setUseBiosMode ( TRUE );
            | 20,21:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mintabwidth) OR (v > maxtabwidth) ) THEN abort(errTabRange,"");END;
                tabwidth :=CARDINAL(v);
            | 22:
                cmdStats:=TRUE; doStatsWide := TRUE;
            | 23:
                cmdStats:=TRUE; doStatsWide := FALSE;
            | 24,25 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 26,27,28:
                savermode:=TRUE;
            | 29,30:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minpause) OR (v > maxpause) ) THEN abort(errPauseRange,"");END;
                pause:=CARDINAL(v);
            | 31,32:
                stopmouse := TRUE;
            | 33,34:
                atrandompos:=TRUE;
            | 35:
                docls := TRUE;
            | 36,37:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minpause) OR (v > maxpause) ) THEN abort(errPauseRange,"");END;
                alwayspause:=CARDINAL(v);
            | 38,39:
                savermode :=TRUE;
                docls     :=TRUE;
            | 40,41:
                GetString(S,Z);
                IF same(Z,"*") THEN
                    wantedcookie:=SHOWMOSTRECENTCOOKIE;
                ELSE
                    IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                    IF ( (v < firstCookie) OR (v > maxCookie) ) THEN abort(errCookieVal,S);END;
                    wantedcookie:=CARDINAL(v);
                END;
            | 42,43:
                usemouse:=FALSE;
            | 44,45:
                doWait:=TRUE; usemouse:=FALSE;
            | 46:
                doWait:=TRUE;                  FRprompt:=TRUE;
            | 47:
                doWait:=TRUE; usemouse:=FALSE; FRprompt:=TRUE;
            | 48,49:
                exedirfirst:=FALSE;
            | 50,51:
                useLFN := FALSE;
            | 52,53:
                rotor := TRUE;
            | 54,55:
                cmdTest := TRUE;
            | 56,57:
                cmdTest := TRUE; terseTest := TRUE;
            | 58,59:
                toclipboard := TRUE;
            | 60:
                DEBUG:=TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                IF same(R,"?") THEN abort(errHelp,""); END;
                Str.Copy(spec,S); (* keep original case here *)
            | gotDatafile :
                abort(errParameter,S);
            END;
            INC(state);
        END;
    END;
    useLFN := (useLFN AND fileSupportLFN() );

    i:=0;
    IF cmdStats THEN INC(i);END;
    IF cmdIndex THEN INC(i);END;
    IF cmdTest  THEN INC(i);END;
    IF i > 1 THEN abort(errCmdConflict,"");END;

    IF fileIsDirectorySpec(useLFN,spec) THEN
        IF chkJoker(spec)=FALSE THEN
            fixDirectory(spec);
            Str.Append(spec,star+extTXT);
        END;
    END;

    IF same(spec,dot) THEN Str.Copy(spec,star+extTXT);END;
    IF same(spec,star) THEN Str.Append(spec,extTXT);END;

    IF NOT(useLFN) THEN UpperCaseAlt(spec);END; (* useless but... //V11L was UpperCase() *)

    IF Str.CharPos(spec,dot)=MAX(CARDINAL) THEN Str.Append(spec,extTXT); END;

    IF nopathhere(spec) THEN (* try exe path *)
        Str.Copy(R,spec); (* R=original spec *)
        IF exedirfirst THEN prependexepath(exefile,spec); END;
        filecount := readDirectory(useLFN,DEBUG,spec,basepath);
        CASE filecount OF
        | 0 :
            Str.Copy(spec,R);
            IF NOT(exedirfirst) THEN prependexepath(exefile,spec); END;
            filecount := readDirectory(useLFN,DEBUG,spec,basepath);
            CASE filecount OF
            | 0 :
                abort(errNotFoundReally,spec);
            | MAX(CARDINAL) :
                abort(errTooManyFiles,spec);
            END;
        | MAX(CARDINAL) :
            abort(errTooManyFiles,spec);
        END;
    ELSE
        filecount := readDirectory(useLFN,DEBUG,spec,basepath);
        CASE filecount OF
        | 0 :
            abort(errNotFound,spec); (* we had a full path *)
        | MAX(CARDINAL):
            abort(errTooManyFiles,spec);
        END;
    END;

    (* ------------------------------------------------------------ *)

    IF cmdStats THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            Str.Copy(indexfile,datafile);
            newExtension(indexfile,extNDX);
            IF fileExists(useLFN,indexfile)=FALSE THEN
                Str.Concat(S,"--- Index not found : ",indexfile);
                WrStr(S);WrLn;
            ELSE
                showIndexStatistics(indexfile,useLFN,doStatsWide,DEBUG);
            END;
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF cmdIndex THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            Str.Copy(indexfile,datafile);
            newExtension(indexfile,extNDX);
            IF fileIsRO(useLFN,indexfile) THEN (* of course, RW if file does not exist *)
                (*
                Str.Concat(S,"--- Index is read-only : ",indexfile);
                WrStr(S);WrLn;
                *)
                fileSetRW(useLFN,indexfile);
            END;
            buildIndex(datafile,indexfile,useLFN,TRUE,SHOWRANDOMCOOKIE,lastcookie);
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF cmdTest THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            chkFortune(datafile,useLFN,terseTest);
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    (* well, just serve us a cookie *)

    i:=GetRndCardRange(firstfile,firstfile+filecount-1);
    Str.Concat(datafile,basepath,fileArray[i]);
    Str.Copy(indexfile,datafile);
    newExtension(indexfile,extNDX);

    IF fileExists(useLFN,indexfile)=FALSE THEN
        buildIndex(datafile,indexfile,useLFN,FALSE,SHOWRANDOMCOOKIE,lastcookie);
    ELSE
        IF fileIsRO(useLFN,indexfile) THEN (* of course, RW if file does not exist *)
            (* abort(errReadOnlyIndex,indexfile); *)
            fileSetRW(useLFN,indexfile);
        END;
    END;

    CASE savermode OF
    | FALSE:
        IF atrandompos THEN
            abort(errNotInNormalMode,"-r option is a nonsense without -s option !");
        END;
        IF stopmouse THEN
            abort(errNotInNormalMode,"-z option is a nonsense without -s option !");
        END;

        IF wantedcookie # SHOWRANDOMCOOKIE THEN
            IF filecount # 1 THEN abort(errNotWithMultifile,"");END;
            IF wantedcookie = SHOWMOSTRECENTCOOKIE THEN
                wantedcookie := getmostrecent(useLFN,indexfile);
                IF wantedcookie = NOCOOKIEYET THEN
                    abort(errNoCookieYet,indexfile);
                END;
            END;
            buildIndex(datafile,indexfile,useLFN,FALSE,wantedcookie,lastcookie);
            IF ( (wantedcookie < firstCookie) OR (wantedcookie > lastcookie) ) THEN
                Str.Copy(S, fmtbignum( LONGCARD(lastcookie), 10,1," ") );
                Str.Prepend(S," valid range is [1..");
                Str.Append(S,"] !");
                Str.Prepend(S,datafile);
                abort(errCookieRange,S);
            END;
        END;
        IF getCookie(datafile,indexfile,doFrame,tabwidth,LineWidth,wantedcookie,rotor,useLFN,DEBUG,lastcookie) = FALSE THEN
            (* tags' well is dry, ressource it ! *)
            buildIndex(datafile,indexfile,useLFN,FALSE,SHOWRANDOMCOOKIE,lastcookie);
            ok:=getCookie(datafile,indexfile,doFrame,tabwidth,LineWidth,SHOWRANDOMCOOKIE,rotor,useLFN,DEBUG,lastcookie); (* should always be TRUE *)
        END;

        colortext( ink,paper );
        dmpCookie(screenwidth,LineWidth,doFrame,redirected,doBeautify);
        colorhelp;

        IF toclipboard THEN
            clipok:=dmpToClipboard(lastline); (* ignore error status *)
        END;

        IF doWait THEN
            IF usemouse THEN usemouse:=MouseDriverHere();END;
            IF usemouse THEN
                IF FRprompt THEN
                    S:=msgWaitMouseFR;
                ELSE
                    S:=msgWaitMouse;
                END;
            ELSE
                IF FRprompt THEN
                    S:=msgWaitFR;
                ELSE
                    S:=msgWait;
                END;
            END;
            video(S,TRUE);
            (* BiosWaitkey(c1,c2); *)
            LOOP
                IF usemouse THEN
                    IF mouseclick() THEN EXIT; END;
                END;
                IF getKeyboardCode(keycode) THEN EXIT; END;
            END;
            video(S,FALSE);
        END;
    | TRUE:
        IF wantedcookie # SHOWRANDOMCOOKIE THEN
            abort(errNotInSaverMode,"-n:# option is a nonsense in screensaver mode !");
        END;
        IF redirected THEN
             abort(errNotInSaverMode,"Redirection is a nonsense in screensaver mode !");
        END;
        flushKeyboard;
        setCursorShape(invisiblecursor);
        IF stopmouse THEN stopmouse:=MouseDriverHere();END;
        LOOP
            colorhelp;
            cls;
            colortext( ink,paper );
            IF getCookie (datafile,indexfile,doFrame,tabwidth,LineWidth,SHOWRANDOMCOOKIE,rotor,useLFN,DEBUG,lastcookie)=FALSE THEN
                (* tags' well is dry, ressource it ! *)
                 buildIndex(datafile,indexfile,useLFN,FALSE,SHOWRANDOMCOOKIE,lastcookie);
                 ok:=getCookie(datafile,indexfile,doFrame,tabwidth,LineWidth, SHOWRANDOMCOOKIE,rotor,useLFN,DEBUG,lastcookie); (* should always be TRUE *)
            END;
            colortext( ink,paper );
            dmpCookieAt(doFrame,alwayspause,pause,atrandompos,stopmouse);
            chk:=getKeyboardCode(keycode);
            IF chk THEN
                CASE keycode OF
                | keyEscape     : EXIT;
             (* | keyCR         : EXIT; *)
                END;
            END;
            IF stopmouse THEN
                (* IF mouseclick() THEN *)
                    mousebuttons:=getLastPressed();
                    IF (rightbutton IN mousebuttons) THEN EXIT; END;
                (* END; *)
            END;

            i:=GetRndCardRange(firstfile,firstfile+filecount-1);
            Str.Concat(datafile,basepath,fileArray[i]);
            Str.Copy(indexfile,datafile);
            newExtension(indexfile,extNDX);

            IF fileExists(useLFN,indexfile)=FALSE THEN
                buildIndex(datafile,indexfile,useLFN,FALSE,SHOWRANDOMCOOKIE,lastcookie);
            ELSE
                IF fileIsRO(useLFN,indexfile) THEN (* of course, RW if file does not exist *)
                   (* abort(errReadOnlyIndex,indexfile); *)
                   fileSetRW(useLFN,indexfile);
                END;
            END;

        END;
        colorhelp;
        IF docls THEN  cls; ELSE WrLn; END;
        setCursorShape(oldcursor);
    END;

    abort(errNone,"");
END Fortune.

(*

using Linux Red Hat 5.1 fortune cookie FORTUNES.ZIP (about 12000)

art
ascii-ar
computer
cookie
definiti
drugs
educatio
ethnic
food
fortunes
goedel
humorist
kids
law
linuxcoo
literatu
love
magic
medicine
men-wome
miscella
news
people
pets
platitud
politics
riddles
science
songs-po
sports
startrek
translat
wisdom
work

*)
