Option Explicit
DefInt A-Z

Sub doGetPasswordCancel ()
' prevent mousemove keyboard artifact again when cancelling
justRunCount% = MINJUSTRUNCOUNT
quitGetPassword
End Sub

Sub doGetPasswordCountdown ()
Dim s$
' called after second
countdown% = countdown% - 1
If countdown% = 0 Then
    doGetPasswordCancel
Else
    s$ = Str$(countdown%)
    s$ = Trim$(s$)
    ff!lblCountdown.Caption = s$
End If
End Sub

Sub doGetPasswordMain ()
Set ff = frmGetPassword
cursorON ' before getpassword form is shown
ff.Hide
ff.Visible = False
ff.AutoRedraw = True
' ff.ControlBox = False
' ff.MaxButton = False
' ff.MinButton = False
' ff.BorderStyle = DOUBLEFIXED
ff.Caption = title$ + " : Get password"
ff.WindowState = NORMAL
centerform ff

ff!txtGetPassword.PasswordChar = "*"
ff!txtGetPassword.Text = ""

ff!lblCountdown.Alignment = CENTER
ff!lblCountdown.Caption = savMaxPasswordWait$ ' in seconds
countdown% = Val(savMaxPasswordWait$) ' in seconds

ff!TimerGetPassword.Enabled = False
ff!TimerGetPassword.Interval = ONESECOND ' Val(savMaxPasswordWait$)
ff!TimerGetPassword.Enabled = True
's$ = readini$(ini$, sSectionWinPassword$, eWinPassword$)
'savPassword$ = s$
If FROZEN Then
    ff.Show MODAL
    'now in form_load event
    'stayOnTop ff.hWnd, True
    'SystemModal ff.hWnd
Else
    ff.Show MODAL
End If
End Sub

Sub doGetPasswordOK ()
Dim s$, encrypted$

s$ = ff!txtGetPassword.Text
' remember txtGetPassword.text is set to uppercase by lostfocus event
' see setpassword form too...
encrypted$ = passwordEncrypt$(s$)

If encrypted$ = savPassword$ Then ' removed universal password (s$ = universal$) Or)
    turnItOff% = True
    quitGetPassword
Else
    ff!TimerGetPassword.Enabled = False
    s$ = "Wrong password !"
    'MsgBox s$, MB_ICONEXCLAMATION, title$
    errMsgDenied s$, title$
    ff!txtGetPassword.Text = ""
    ff!txtGetPassword.SetFocus

    ff!lblCountdown.Caption = savMaxPasswordWait$ ' in seconds
    countdown% = Val(savMaxPasswordWait$) ' in seconds
    ff!TimerGetPassword.Enabled = True
End If
End Sub

Function FilterKeyModal% (ByVal keycode%)
' directly replacing with TAB forces a sound alarm !
' assume tab order is correct
' for these damn modal forms (getPassword)
If keycode% = KEY_RETURN Then ' avoid invisible editbox
    If FROZEN = False Then SendKeys "{TAB}"
    keycode% = 0 ' disable silly default beep
End If
FilterKeyModal% = keycode%
End Function

Sub quitGetPassword ()
ff!TimerGetPassword.Enabled = False
ff.Hide
Unload ff
cursorOFF ' after getpassword form is hidden
f.Refresh ' yes, f for background Screen
' just in case, reset caller status (f=frmScreen)
stayOnTop f.hWnd, True
SystemModal f.hWnd
End Sub

