Option Explicit
DefInt A-Z

' vindoze 3.1 related constants

Global Const ControlIni$ = "control.ini"

Global Const sSectionWinPassword$ = "Screensaver"
Global Const eWinPassword$ = "Password"

' app ini settings

Global Const ePasswordProtected$ = "PasswordProtected"
Global Const eMaxPasswordWait$ = "MaxPasswordWait"

Global Const eShowNow$ = "ShowNow"
Global Const eNowLanguage$ = "NowLanguage"
Global Const eNowFont$ = "NowFont"
Global Const eNowSize$ = "NowSize"
Global Const eNowBold$ = "NowBold"
Global Const eNowInk$ = "NowInk"
Global Const eNowMoveInterval$ = "NowMoveInterval"
Global Const eNowMove$ = "NowMove"
Global Const eNowMaxMove$ = "NowMaxMove"

Global Const ePaper$ = "Paper"
Global Const eInk$ = "Ink"
Global Const eInkFadeTo$ = "InkFadeTo"
Global Const eControlPoints$ = "ControlPoints"
Global Const eSegments$ = "Segments"
Global Const eMinSpeed$ = "MinSpeed"
Global Const eMaxSpeed$ = "MaxSpeed"
Global Const eTrails$ = "Trails"
Global Const eMode$ = "Mode"' fixed color, random colors, fading colors
Global Const eBoldLines$ = "BoldLines"

Global Const eRefreshNow$ = "RefreshNow"

' list and indexes

Global Const lY$ = "Y"
Global Const lN$ = "N"

Global Const lFR$ = "FR"
Global Const lUS$ = "US"

Global Const lFIXED$ = "FIXED"
Global Const lRANDOM$ = "RANDOM"
Global Const lFADE$ = "FADE"

Global Const kFR = 0
Global Const kUS = 1

Global Const kFIXED = 0
Global Const kRANDOM = 1
Global Const kFADE = 2

Global Const kFONT8 = 0
Global Const kFONT10 = 1
Global Const kFONT12 = 2
Global Const kFONT14 = 3
Global Const kFONT18 = 4

' defaults (strings)

Global Const dPassword$ = ""

Global Const dPasswordProtected% = False
Global Const dMaxPasswordWait% = 15

Global Const dShowNow% = False
Global Const dNowLanguage% = kFR
Global Const dNowFont$ = "Arial"
Global Const dNowSize$ = "13.5"
Global Const dNowSizeNDX% = kFONT14 ' hack berk
Global Const dNowBold% = False
Global Const dNowInk& = &HFF00&
Global Const dNowMoveInterval% = 30
Global Const dNowMove% = 2
Global Const dNowMaxMove% = 16

Global Const dPaper& = &H0&
Global Const dInk& = &HFF&
Global Const dInkFadeTo& = &HFFFF&
Global Const dControlPoints% = 5
Global Const dSegments% = 10
Global Const dMinSpeed% = 5
Global Const dMaxSpeed% = 20
Global Const dTrails% = 10
Global Const dMode% = kFIXED' fixed color, random colors, fading colors
Global Const dBoldLines% = False

Global Const dRefreshNow = 500

' global settings

Global gPassword$

Global gPasswordProtected%
Global gMaxPasswordWait%

Global gShowNow%
Global gNowLanguage%
Global gNowFont$
Global gNowSize%
Global gNowBold%
Global gNowInk&
Global gNowMoveInterval%
Global gNowMove%
Global gNowMaxMove%

Global gPaper&
Global gInk&
Global gInkFadeTo&
Global gControlPoints%
Global gSegments%
Global gMinSpeed%
Global gMaxSpeed%
Global gTrails%
Global gMode% ' fixed color, random colors, fading colors
Global gBoldLines%

Global gRefreshNow%

' app constants

Global Const Title$ = "Curves v1.0b"
Global Const culprit$ = "by PhG"
Global Const sSection$ = "Screen Saver.Curves"

' global vars (easier with vb piece of crap, and saves typing too !)

Global f As form
Global ff As form
Global fff As form

Global windir$
Global sysdir$

Global exedir$ ' avoid repeated getexepath$()
Global ini$

' for mouse artifact

Global Const MINJUSTRUNCOUNT% = 0
Global Const MAXJUSTRUNCOUNT% = 4
Global justRunCount%

' for date and time motion

Global newpos%
Global currMove%

' after checking password

Global turnItOff%

' misc

Global Const ONESECOND = 1000 ' in milliseconds

' for waits

Global countdown%

' result of frmPickInk

Global newcolor$

' for debug

Global Const LOGGING% = False ' for logging of some events while creating code
Global hndLog% ' yes, virginia, could be in vb_log... but it's vb after all ! :-)

Global Const frozen% = True ' true=final production ! for experimental code

