Option Explicit
DefInt A-Z

' vindoze related constants
' control.ini
Global Const ControlIni$ = "control.ini"

Global Const sSectionWinPassword$ = "Screensaver"
Global Const eWinPassword$ = "Password"

' app ini settings

Global Const ePasswordProtected$ = "PasswordProtected"

Global Const eChimeOnStart$ = "ChimeOnStart"
Global Const eChimeAtHour$ = "ChimeAtHour"
Global Const eChimeAtHalfHour$ = "ChimeAtHalfHour"
Global Const eChimeOnExit$ = "ChimeOnExit"

Global Const eHourSound$ = "HourSound"
Global Const eHalfHourSound$ = "HalfHourSound"

Global Const eDeadlineDate$ = "DeadlineDateDMY"
Global Const eDeadlineTime$ = "DeadlineTime"

Global Const eDeltaUT$ = "DeltaUT"

Global Const eIncludeTodayInDaysRemaining$ = "IncludeTodayInDaysRemaining"

Global Const eShowLanguage$ = "ShowLanguage"' FR or US
Global Const eShowDateAndTime$ = "ShowDateAndTime"
Global Const eShowUT$ = "ShowUT"
Global Const eDateFormat$ = "DateFormat"' DMY or MDY
Global Const eRemainingFormat$ = "RemainingFormat"' d, h, m, dh or dhm

' paper useless now for we force transparency...

Global Const ePaperRGB$ = "PaperRGB"
Global Const eFontDateAndTime$ = "FontDateAndTime"
Global Const eBoldDateAndTime$ = "BoldDateAndTime"
Global Const eSizeDateAndTime$ = "SizeDateAndTime"
Global Const eInkRGBDateAndTime$ = "InkRGBDateAndTime"
Global Const eFontCountdown$ = "FontCountdown"
Global Const eBoldCountdown$ = "BoldCountdown"
Global Const eSizeCountdown$ = "SizeCountdown"
Global Const eInkRGBCountdown$ = "InkRGBCountdown"

Global Const eRefreshInterval$ = "RefreshInterval"
Global Const eMoveInterval$ = "MoveInterval"
Global Const eMotion$ = "Motion"
Global Const eMaxMotion$ = "MaxMotion"
Global Const eMaxPasswordWait$ = "MaxPasswordWait"

Global Const ePictureFile$ = "PictureFile"

Global Const eBeforeFR1$ = "BeforeFR1"
Global Const eBeforeFR3$ = "BeforeFR3"
Global Const eAfterFR1$ = "AfterFR1"
Global Const eAfterFR3$ = "AfterFR3"
Global Const eVerityFR$ = "VerityFR"

Global Const eBeforeUS1$ = "BeforeUS1"
Global Const eBeforeUS3$ = "BeforeUS3"
Global Const eAfterUS1$ = "AfterUS1"
Global Const eAfterUS3$ = "AfterUS3"
Global Const eVerityUS$ = "VerityUS"

Global Const ePreset$ = "Preset"

' ini settings (global vars)

Global savPasswordProtected%
Global savPassword$

Global savChimeOnStart%
Global savChimeAtHour%
Global savChimeAtHalfHour%
Global savChimeOnExit%

Global savHourSound$
Global savHalfHourSound$

Global savDay%, savMonth%, savYear%
Global savHH%, savMM%, savSS%
Global savHHUT%, savMMUT%, savSSUT%

Global savIncludeTodayInDaysRemaining%
Global savShowLanguage$
Global savShowUT%
Global savShowDateAndTime%
Global savDateFormat$
Global savRemainingFormat$

Global savPaperRGB$
Global savFontDateAndTime$
Global savBoldDateAndTime%
Global savSizeDateAndTime%
Global savInkRGBDateAndTime$
Global savFontCountdown$
Global savBoldCountdown%
Global savSizeCountdown%
Global savInkRGBCountdown$

Global savRefreshInterval$
Global savMoveInterval$
Global savMotion$
Global savMaxMotion$

Global savMaxPasswordWait$

Global savPictureFile$

Global BeforeFR1$
Global BeforeFR3$
Global AfterFR1$
Global AfterFR3$
Global VerityFR$

Global BeforeUS1$
Global BeforeUS3$
Global AfterUS1$
Global AfterUS3$
Global VerityUS$

' preset events

Type presetDataType
    presettitle As String
    theDay As Integer
    theMonth As Integer
    theYear As Integer
    theHH As Integer
    theMM As Integer
    theSS As Integer
End Type

Global Const MINPRESET = 1
Global Const MAXPRESET = 16
Global presetndx%
Global presetData(MINPRESET To MAXPRESET) As presetDataType
Global Const defaultPresetError$ = "Invalid event"

Global Const defaultPreset1$ = "Year 2000,01-Jan-2000,00:00:00"
Global Const defaultPreset2$ = "Year 2001,01-Jan-2001,00:00:00"
Global Const defaultPreset3$ = "Year 2100,01-Jan-2100,00:00:00"

' main defaults

Global Const defaultPasswordProtected% = False
Global Const defaultPassword$ = ""

Global Const defaultChimeOnStart% = False
Global Const defaultChimeAtHour% = False
Global Const defaultChimeAtHalfHour% = False
Global Const defaultChimeOnExit% = False
Global Const defaultHourSound$ = "bambam.wav"
Global Const defaultHalfHourSound$ = "bam.wav"

Global Const defaultDeadlineDate$ = "01 Jan 2001"
Global Const defaultDeadlineTime$ = "00:00:00"
Global Const defaultDeltaUT$ = "-2h"

Global Const defaultIncludeTodayInDaysRemaining% = False
Global Const defaultShowLanguage$ = "FR"
Global Const defaultShowDateAndTime% = True
Global Const defaultShowUT% = False
Global Const defaultDateFormat$ = "DMY"
Global Const defaultRemainingFormat$ = "DHM"

Global Const defaultPaperRGB$ = "&h00000000&" ' black

Global Const defaultFont$ = "Arial"
Global Const defaultBold% = False
Global Const defaultSize% = 12
Global Const defaultInkRGB$ = "&h00ffff00&"

Global Const defaultFontAlt$ = "Arial"
Global Const defaultBoldAlt% = False
Global Const defaultSizeAlt% = 12
Global Const defaultInkRGBalt$ = "&h000000ff&"

Global Const defaultRefreshInterval$ = "250"' 0.25 seconds is small resolution enough for time update on screen
Global Const defaultMoveInterval$ = "30"' 30 seconds
Global Const defaultMotion$ = "2"' pixels
Global Const defaultMaxMotion$ = "16"

Global Const defaultMaxPasswordWait$ = "15" ' seconds

Global Const defaultPictureFile$ = "eternity.bmp"

Global Const defaultBeforeFR1$ = "Encore"
Global Const defaultBeforeFR3$ = "avant le moment fatidique..."
Global Const defaultAfterFR1$ = "Dj"
Global Const defaultAfterFR3$ = "depuis le moment fatidique..."
Global Const defaultVerityFR$ = "Les temps sont venus."

Global Const defaultBeforeUS1$ = "Still"
Global Const defaultBeforeUS3$ = "remaining..."
Global Const defaultAfterUS1$ = "Already"
Global Const defaultAfterUS3$ = "past deadline..."
Global Const defaultVerityUS$ = "The time has come."

' list constants

Global Const kMINUS = 0
Global Const kPLUS = 1

Global Const kFRENCH = 0
Global Const kENGLISH = 1

Global Const kDMY = 0
Global Const kMDY = 1

Global Const kD = 0
Global Const kH = 1
Global Const kM = 2
Global Const kDH = 3
Global Const kDHM = 4

Global Const kFONT8 = 0
Global Const kFONT10 = 1
Global Const kFONT12 = 2
Global Const kFONT14 = 3
Global Const kFONT18 = 4

' app constants

Global Const title$ = "Counter v1.0e" ' 
Global Const Culprit$ = "by PhG"

Global Const sSection$ = "Screen Saver.Counter"

Global Const OngletTitle0$ = "Date"
Global Const OngletTitle1$ = "Display"
Global Const OngletTitle2$ = "Sound"
Global Const OngletTitle3$ = "Font"
Global Const OngletTitle4$ = "French"
Global Const OngletTitle5$ = "English"

Global Const ONGLETNOMBRE = 6 ' 1..n, which will be translated as 0..n-1

' global vars : just say NO! to elegant code ;-)
' (really : easier with this VB piece of crap !)

Global f As form ' frmScreen or frmSetup
Global ff As form ' frmSetPassword or frmGetPassword
Global fff As form ' frmPickInk, frmPickBMP or frmPickWAV
Global windir$
Global sysdir$
Global ini$

Global gIgnorePassword%

Global newcolor$ ' frmPickInk
Global newfile$ ' frmPickBMP or frmPickWAV

' for julian dates

Global JDTarget#
Global JDNow#
Global JDDeltaUT#

' for comparisons with single float values

Global Const NEARLYZERO = .00001
Global Const LESSTHANTWO = 1.1

' for motion of screen (preventing possible burning)

Global motion%
Global maxmotion%
Global newpos%

Global turnItOff%

' for get password

Global Const ONESECOND = 1000 ' in milliseconds

Global countdown%

' for mouse artifact

Global Const MINJUSTRUNCOUNT% = 0
Global Const MAXJUSTRUNCOUNT% = 4
Global justRunCount%

' enable/disable sound

Global hourbell%
Global halfhourbell%

Global exedir$ ' avoid repeated getexepath$()

' for debug

Global Const LOGGING% = False ' for logging of some events while creating code
Global hndLog%

' fed up with numerous attempts to have stayontop and modal work
' code frozen and constant will NEVER be true here ! :-(

Global Const frozen% = True ' true=final production ! for experimental code

