Option Explicit
DefInt A-Z

' app

Global Const Title$ = "End v1.0a"
Global Const culprit$ = "by PhG"
Global Const sSection$ = "End"

' globerk

Global gPicture$
Global gRows%
Global gColumns%
Global gSpeed%
Global gBefore%
Global gAfter%
Global gFullScreen%
Global gAlwaysOnTop%
Global gBang%
Global gBangFile$
Global gGameOver%
Global gGameOverFile$
Global gPaper&

Global gXpos%
Global gYpos%

' ini entries

Global Const ePicture$ = "Picture"
Global Const eRows$ = "Rows"
Global Const eColumns$ = "Columns"
Global Const eSpeed$ = "Speed"
Global Const eBefore$ = "Before"
Global Const eAfter$ = "After"
Global Const eFullScreen$ = "FullScreen"
Global Const eAlwaysOnTop$ = "AlwaysOnTop"
Global Const eBang$ = "Bang"
Global Const eBangFile$ = "BangFile"
Global Const eGameOver$ = "GameOver"
Global Const eGameOverFile$ = "GameOverFile"
Global Const ePaper$ = "Paper"

Global Const eXpos$ = "Xpos"
Global Const eYpos$ = "Ypos"

' defaults

Global Const dPicture$ = "end.bmp" ' smileys
Global Const dRows% = 6 ' for end.bmp
Global Const dColumns% = 5 ' for end.bmp
Global Const dSpeed% = 100
Global Const dBefore% = 2
Global Const dAfter% = 2
Global Const dFullScreen% = True
Global Const dAlwaysOnTop% = True
Global Const dBang% = True
Global Const dBangFile$ = "end1.wav" ' rifle.wav
Global Const dGameOver% = True
Global Const dGameOverFile$ = "end2.wav" ' t2excel.wav
Global Const dPaper& = &H30303   ' black background

Global Const dXpos% = -1
Global Const dYpos% = -1

' for setup options

Global Const MINROW = 1
Global Const MAXROW = 32
Global Const SMALLCHANGEROW = 1
Global Const LARGECHANGEROW = 8

Global Const MINCOLUMN = 1
Global Const MAXCOLUMN = 32
Global Const SMALLCHANGECOLUMN = 1
Global Const LARGECHANGECOLUMN = 8

Global Const MINSPEED = 1
Global Const MAXSPEED = 2000 ' 2 seconds is more than enough !
Global Const SMALLCHANGESPEED = 1
Global Const LARGECHANGESPEED = 100

Global Const MINBEFORE = 0 ' no delay
Global Const MAXBEFORE = 15 ' 15 seconds is enough
Global Const SMALLCHANGEBEFORE = 1
Global Const LARGECHANGEBEFORE = 5

Global Const MINAFTER = 0 ' let the user close program
Global Const MAXAFTER = 15 ' 15 seconds is enough
Global Const SMALLCHANGEAFTER = 1
Global Const LARGECHANGEAFTER = 5

' common globerks
' global vars (easier with vb piece of crap, and saves typing too !)

Global f As form
Global ff As form
Global fff As form

Global windir$
Global sysdir$

Global exedir$ ' avoid repeated getexepath$()
Global ini$

' common globerk constants

Global Const INIext$ = ".INI"
Global Const lY$ = "Y"
Global Const lN$ = "N"

' screen dimensions

Global XscreenInPixels%
Global YscreenInPixels%

' for frmPickBMP and frmPickWAV

Global newFile$

' for frmPickInk

Global newInk&

' for animation

Global Const ONESECOND = 1000 ' in milliseconds
Global Const FIRSTFRAME = 0

Global lastFrame%
Global currentStep%

Sub retrieveParameters ()
Dim s$
Dim flag%
Dim i%

s$ = readIni$(ini$, sSection$, ePicture$)
If s$ = "" Then s$ = dPicture$
gPicture$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, eRows$)
gRows% = getInt%(s$, dRows%)
s$ = readIni$(ini$, sSection$, eColumns$)
gColumns% = getInt%(s$, dColumns%)

s$ = readIni$(ini$, sSection$, eSpeed$)
gSpeed% = getInt%(s$, dSpeed%)

s$ = readIni$(ini$, sSection$, eBefore$)
gBefore% = getInt%(s$, dBefore%)

s$ = readIni$(ini$, sSection$, eAfter$)
gAfter% = getInt%(s$, dAfter%)

s$ = readIni$(ini$, sSection$, eFullScreen$)
gFullScreen% = getBool%(s$, dFullScreen%)

s$ = readIni$(ini$, sSection$, eAlwaysOnTop$)
gAlwaysOnTop% = getBool%(s$, dAlwaysOnTop%)

s$ = readIni$(ini$, sSection$, eBang$)
gBang% = getBool%(s$, dBang%)
s$ = readIni$(ini$, sSection$, eBangFile$)
If s$ = "" Then s$ = dBangFile$
gBangFile$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, eGameOver$)
gGameOver% = getBool%(s$, dGameOver%)
s$ = readIni$(ini$, sSection$, eGameOverFile$)
If s$ = "" Then s$ = dGameOverFile$
gGameOverFile$ = fixname(exedir$, s$)

s$ = readIni$(ini$, sSection$, ePaper$)
If s$ = "" Then
    gPaper& = dPaper&
Else
    gPaper& = Val(rgbToHex$(s$))
End If

s$ = readIni$(ini$, sSection$, eXpos$)
gXpos% = getInt%(s$, dXpos%)
s$ = readIni$(ini$, sSection$, eYpos$)
gYpos% = getInt%(s$, dYpos%)

End Sub

