
' program should be revised for Win98SE FAT32 huge disks...
' but I only use it with FAT16 Win31, eh eh...
'
' HDFREE DOS console tool does not require a GUI nor ugly VB 3.0 !
' (as for XP, that's yet another story...)
'
' part of Q&D Tools QDTOOLS.ZIP archive (c) by PhG
'

' see VBASM.TXT for VBASM.DLL freeware license (nice work, by the way !)

Option Explicit
DefInt A-Z


Sub doQuit ()
quit True
End Sub

Sub doUpdate (ByVal assumeFAT32%, ByVal firsttime%)
Dim ypos!
Dim i%, ndx%

' refill drivedata
If firsttime% = False Then getDriveData assumeFAT32%, drivelist$

showhint

sigmaused = 0
sigmafree = 0
sigmatotal = 0

ypos! = ybar!
i% = minLabel + 1
For ndx% = minDrive To maxDrive
    If drivedata(ndx%).included Then
	If firsttime% Then syncTop ypos!, i%

	showdata ndx%, i%, xbar!, ypos!

	ypos! = ypos! + f!lblUnit(0).Height
	If firsttime% Then syncVisible True, i%
	i% = i% + 1
    End If
Next

    If drivecount% > 1 Then
	ypos! = ypos! + gap!
	If firsttime% Then syncTop ypos!, i%

	showdata -1, i%, xbar!, ypos!

	If firsttime% Then syncVisible True, i%
    End If

f.Refresh
End Sub

Function GetDiskSpace (ByVal assumeFAT32%, ByVal driveNum As Integer, totalspace As Long, freeSpace As Long) As Integer
Dim r As VBREGS
Dim bytesPerCluster As Long
Dim rdx&, rbx&
'Returns the total and available disk space for the specified drive
'driveNum specifies which drive (0 = default, 1 = A, 2 = B, etc.)

'Request drive allocation information from DOS services
r.AX = &H3600
r.DX = driveNum%
Call vbInterrupt(&H21, r, r)
'If vbRealModeIntX(&H21, r, r) = False Then r.AX = -1

'Test for error condition
If r.AX <> -1 Then
'Calculate free and total space
    bytesPerCluster& = CLng(r.AX) * CLng(r.CX) ' sectorsPerCluster * bytesPerSector

    totalspace = (r.DX And &HFFFF&) * bytesPerCluster
    freeSpace = (r.BX And &HFFFF&) * bytesPerCluster

    'rdx& = CLng(r.DX)
    'rbx& = CLng(r.BX)
    'If rdx& < 0 Then rdx& = rdx& + 65536
    'If rbx& < 0 Then rbx& = rbx& + 65536
    'totalSpace = rdx& * bytesPerCluster&
    'freeSpace = rbx& * bytesPerCluster&

    GetDiskSpace = True
Else
    GetDiskSpace = False
End If
End Function

Sub getDriveData (ByVal assumeFAT32%, ByVal s$)
Dim i%, ndx%, u%, drivetype%
Dim total&, free&' eh eh, if used on a huge (> 2Gb) drive... argh !
Dim c$

waiting True
For i% = minDrive To maxDrive
    drivedata(i%).included% = False
Next
s$ = LTrim$(RTrim$(s$))
If s$ = "" Then s$ = "cdefghijklmnopqrstuvwxyz" ' default is all but floppies

s$ = UCase$(s$)
For i% = 1 To Len(s$)
    c$ = Mid$(s$, i%, 1)
    Select Case c$
    Case "A" To "Z"
	drivetype% = vbGetDriveType(c$)
	If drivetype% <> VBDRIVE_INVALID Then
	    If drivetype% = VBDRIVE_FIXED Then
		ndx% = Asc(c$) - Asc("A") + minDrive
		u% = Asc(c$) - Asc("A") + 1
		If GetDiskSpace(assumeFAT32%, u%, total&, free&) Then
		    drivedata(ndx%).freeSpace = free&
		    drivedata(ndx%).usedspace = total& - free&
		    drivedata(ndx%).totalspace = total&
		    drivedata(ndx%).included% = True
		End If
	    End If
	End If
    End Select
Next
waiting False
End Sub

Sub main ()
Dim xpos!, ypos!
Dim xx1!, yy1!, xx2!, yy2!
Dim i%, ndx%, flag%
Dim s$
Dim ref As Control

Set f = frmMain
Set ref = f!lblUnit(0)

If isRunning%() Then quit False ' just in case

f.Hide
f.AutoRedraw = True
'f.ScaleMode = PIXELS
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = FIXED_SINGLE
f.Caption = progTitle$
f.WindowState = NORMAL

f.DrawMode = 13 ' default using forecolor
f.DrawStyle = 0 ' default draw solid
f.DrawWidth = 1

exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$
If fileExists%(ini$) Then
    'flag% = SW_SHOW
    'restoreWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$, flag%
    resetPosition f, ini$, sSection$, eYtsr$, eXtsr$

    f.Hide ' try and prevent ugly repaint
    If f.Top = 0 And f.Left = 0 Then centerform f
    drivelist$ = readini$(ini$, sSection$, eUnits$)
    If drivelist$ = "" Then drivelist$ = dUnits$

    s$ = readini$(ini$, sSection$, eQBcolorUsed$)
    colorUsed% = getInt%(s$, dQBcolorUsed%)
    s$ = readini$(ini$, sSection$, eQBcolorFree$)
    colorFree% = getInt%(s$, dQBcolorFree%)

    s$ = readini$(ini$, sSection$, eQBcolorUsedAlt$)
    colorUsedAlt% = getInt%(s$, dQBcolorUsedAlt%)
    s$ = readini$(ini$, sSection$, eQBcolorFreeAlt$)
    colorFreeAlt% = getInt%(s$, dQBcolorFreeAlt%)

    s$ = readini$(ini$, sSection$, eQBcolorBorder$)
    colorBorder% = getInt%(s$, dQBcolorBorder%)

    s$ = readini$(ini$, sSection$, eAutoUpdate$)
    globAutoUpdate% = getBool%(s$, dglobAutoUpdate%)
    s$ = readini$(ini$, sSection$, eAutoUpdateInterval$)
    autoUpdateInterval% = getInt%(s$, dAutoUpdateInterval%)
    s$ = readini$(ini$, sSection$, eIgnoreWin9X$)
    ignoreWin9X% = getBool%(s$, dIgnoreWin9X%)
Else
    centerform f
    drivelist$ = ""
    colorUsed% = dQBcolorUsed%
    colorFree% = dQBcolorFree%
    colorUsedAlt% = dQBcolorUsedAlt%
    colorFreeAlt% = dQBcolorFreeAlt%
    colorBorder% = dQBcolorBorder%

    globAutoUpdate% = dglobAutoUpdate%
    autoUpdateInterval% = dAutoUpdateInterval%
    ignoreWin9X% = dIgnoreWin9X%
End If
If ((colorUsed% = colorFree%) Or (colorUsedAlt% = colorFreeAlt%)) Then
    colorUsed% = dQBcolorUsed%
    colorFree% = dQBcolorFree%
    colorUsedAlt% = dQBcolorUsedAlt%
    colorFreeAlt% = dQBcolorFreeAlt%
    colorBorder% = dQBcolorBorder%
End If

assumeFAT32% = (w9XsupportLFN() And (ignoreWin9X% = False))

' sync dimensions against reference controls
gap! = ref.Left
syncTop gap!, minLabel

f!lblUsed(0).Height = ref.Height
f!lblFree(0).Height = ref.Height
f!lblTotal(0).Height = ref.Height
f!lblPercentUsed(0).Height = ref.Height
f!lblUsedFree(0).Height = ref.Height
f!lblPercentFree(0).Height = ref.Height

f!cmdQuit.Height = f!cmdUpdate.Height
f!chkAutoUpdate.Height = f!cmdUpdate.Height

f!lblFree(0).Width = f!lblUsed(0).Width
f!lblTotal(0).Width = f!lblUsed(0).Width
f!lblFree(0).Width = f!lblUsed(0).Width

f!cmdQuit.Width = f!cmdUpdate.Width
f!chkAutoUpdate.Width = f!cmdUpdate.Width

xpos! = ref.Left
newXpos gap!, xpos!, ref, f!lblUsed(0)
newXpos gap!, xpos!, f!lblUsed(0), f!lblFree(0)
newXpos gap! * 2, xpos!, f!lblFree(0), f!lblTotal(0)
newXpos gap! * 2, xpos!, f!lblTotal(0), f!lblPercentUsed(0)
newXpos gap!, xpos!, f!lblPercentUsed(0), f!lblUsedFree(0)
xbar! = xpos!
newXpos gap!, xpos!, f!lblUsedFree(0), f!lblPercentFree(0)

f.Width = xpos! + f!lblPercentFree(0).Width + gap!

f!lblUnit(0).BackColor = f.BackColor
f!lblUsed(0).BackColor = f.BackColor
f!lblFree(0).BackColor = f.BackColor
f!lblTotal(0).BackColor = f.BackColor
f!lblPercentUsed(0).BackColor = f.BackColor
'f!lblUsedFree(0).BackColor = f.BackColor
f!lblPercentFree(0).BackColor = f.BackColor

f!lblUsedFree(0).Visible = False

' build possibly needed controls

For i% = minLabel + 1 To maxLabel
    Load f!lblUnit(i%)
    Load f!lblUsed(i%)
    Load f!lblFree(i%)
    Load f!lblTotal(i%)
    Load f!lblPercentUsed(i%)
    'Load f!lblUsedFree(i%)
    Load f!lblPercentFree(i%)
Next

For i% = minLabel + 1 To maxLabel
    f!lblUnit(i%).Top = ypos!
    f!lblUsed(i%).Top = ypos!
    f!lblFree(i%).Top = ypos!
    f!lblTotal(i%).Top = ypos!
    f!lblPercentUsed(i%).Top = ypos!
    'f!lblUsedFree(i%).Top = ypos!
    f!lblPercentFree(i%).Top = ypos!
Next

' now, fill drivedata then labels and resize form accordingly
getDriveData assumeFAT32%, drivelist$

' we must resize form BEFORE we draw ! or create it with a huge size
' we create ybar!, ysigmabar! and drivecount% while we're at it
drivecount% = 0
ybar! = ref.Top + ref.Height + gap!
ypos! = ybar!
i% = minLabel + 1
For ndx% = minDrive To maxDrive
    If drivedata(ndx%).included Then
	ypos! = ypos! + ref.Height
	drivecount% = drivecount% + 1
    End If
Next
If drivecount% > 1 Then
    ypos! = ypos! + gap!
    ysigmabar! = ypos!
    ypos! = ypos! + ref.Height
End If
ypos! = ypos! + gap!

f!cmdQuit.Top = ypos!
f!cmdUpdate.Top = ypos!

f!theTimer.Interval = autoUpdateInterval% * ONESECOND&
f!theTimer.Enabled = False ' safety first

f!chkAutoUpdate.Top = ypos!
f!chkAutoUpdate.Left = ref.Left
If globAutoUpdate% = True Then
    flag% = CHECKED
Else
    flag% = UNCHECKED
End If
f!chkAutoUpdate.Value = flag%

f.Height = ypos! + f!cmdQuit.Height + gap!
' include title bar !
f.Height = f.Height + screen.TwipsPerPixelY * (GetSystemMetrics(SM_CYCAPTION))

updateVisibleButtons False, f!chkAutoUpdate
' now we can draw everything for the first time (hence TRUE parameter)
doUpdate assumeFAT32%, True
updateVisibleButtons True, f!chkAutoUpdate

f.Show
End Sub

Sub newXpos (ByVal gap!, pos!, prev As Control, curr As Control)
pos! = prev.Left + prev.Width + gap!
curr.Left = pos!
End Sub

Sub quit (ByVal savepos%)
Dim rc%
If savepos% Then
    'saveWindowPosition f, ini$, sSection$, eXtsrIcon$, eYtsrIcon$, eXtsr$, eYtsr$
    savePosition f, ini$, sSection$, eYtsr$, eXtsr$
End If
' write drivelist$ and QBcolors
rc% = writeIni(ini$, sSection$, eQBcolorUsed$, intToStr$(colorUsed%))
rc% = writeIni(ini$, sSection$, eQBcolorFree$, intToStr$(colorFree%))
rc% = writeIni(ini$, sSection$, eQBcolorUsedAlt$, intToStr$(colorUsedAlt%))
rc% = writeIni(ini$, sSection$, eQBcolorFreeAlt$, intToStr$(colorFreeAlt%))
rc% = writeIni(ini$, sSection$, eQBcolorBorder$, intToStr$(colorBorder%))
rc% = writeIni(ini$, sSection$, eUnits$, drivelist$)

rc% = writeIni(ini$, sSection$, eAutoUpdate$, boolToStr$(globAutoUpdate%))
rc% = writeIni(ini$, sSection$, eAutoUpdateInterval$, intToStr$(autoUpdateInterval%))
rc% = writeIni(ini$, sSection$, eIgnoreWin9X$, boolToStr$(ignoreWin9X))
While forms.Count > 0
    forms(0).Hide
    Unload forms(0)
Wend
End
End Sub

Sub showdata (ByVal ndx%, ByVal i%, ByVal xbar!, ByVal ypos!)
Dim xx1!, yy1!, xx2!, yy2!
Dim s$
If ndx% = -1 Then
    used = sigmaused
    free = sigmafree
    total = sigmatotal
    s$ = "All"
Else
    used = drivedata(ndx%).usedspace
    free = drivedata(ndx%).freeSpace
    total = drivedata(ndx%).totalspace
    sigmaused = sigmaused + used
    sigmafree = sigmafree + free
    sigmatotal = sigmatotal + total
    s$ = Chr$(Asc("A") + ndx% - 1) + ":"
End If
pused = used / total * 100
pfree = free / total * 100
f!lblUnit(i%).Caption = s$
f!lblUsed(i%).Caption = Format$(used, FMTVALUE$)
f!lblFree(i%).Caption = Format$(free, FMTVALUE$)
f!lblTotal(i%).Caption = Format$(total, FMTVALUE$)
f!lblPercentUsed(i%).Caption = Format$(pused, FMTPERCENT$)
f!lblPercentFree(i%).Caption = Format$(pfree, FMTPERCENT$)

xx1! = xbar!
yy1! = ypos!
xx2! = xx1! + f!lblUsedFree(0).Width
yy2! = yy1! + f!lblUsedFree(0).Height

f.Line (xx1!, yy1!)-(xx2!, yy2!), QBColor(colorFree%), BF
f.Line (xx1!, yy1!)-(xx2!, yy2!), QBColor(colorBorder%), B

xx2! = xx1! + (used / total) * f!lblUsedFree(0).Width
f.Line (xx1!, yy1!)-(xx2!, yy2!), QBColor(colorUsed%), BF
f.Line (xx1!, yy1!)-(xx2!, yy2!), QBColor(colorBorder%), B
End Sub

Sub showhint ()
If globAutoUpdate% = True Then
    swap colorFree%, colorFreeAlt%
    swap colorUsed%, colorUsedAlt%
End If
End Sub

Sub swap (a%, b%)
Dim old%
old% = a%
a% = b%
b% = old%
End Sub

Sub syncTop (y!, ByVal i%)
f!lblUnit(i%).Top = y!
f!lblUsed(i%).Top = y!
f!lblFree(i%).Top = y!
f!lblTotal(i%).Top = y!
f!lblPercentUsed(i%).Top = y!
' f!lblUsedFree(i%).Top = y!
f!lblPercentFree(i%).Top = y!
End Sub

Sub syncVisible (ByVal flag%, ByVal i%)
f!lblUnit(i%).Visible = flag%
f!lblUsed(i%).Visible = flag%
f!lblFree(i%).Visible = flag%
f!lblTotal(i%).Visible = flag%
f!lblPercentUsed(i%).Visible = flag%
'f!lblUsedFree(i%).Visible = flag%
f!lblPercentFree(i%).Visible = flag%
End Sub

Sub updateVisibleButtons (ByVal oktimer%, c As Control)
Dim ref As Control
Dim xpos!, gap!

Set f = frmMain ' global

Set ref = f!lblUnit(0) ' same as main()
gap! = ref.Left ' same as main()

If oktimer% = True Then f!theTimer.Enabled = False ' better safe than sorry

Select Case c.Value
Case CHECKED
    globAutoUpdate% = True
Case UNCHECKED
    globAutoUpdate% = False
Case Else
    globAutoUpdate% = False' cannot happen
End Select

If globAutoUpdate% = True Then
    xpos! = (f.Width - f!cmdQuit.Width) / 2
    f!cmdUpdate.Left = xpos!
    f!cmdQuit.Left = xpos!
    f!cmdUpdate.Visible = False
Else
    xpos! = (f.Width - f!cmdUpdate.Width - gap! - f!cmdQuit.Width) / 2
    f!cmdUpdate.Left = xpos!
    f!cmdQuit.Left = xpos! + f!cmdUpdate.Width + gap!
    f!cmdUpdate.Visible = True
End If
If oktimer% = True Then f!theTimer.Enabled = globAutoUpdate%
End Sub
