Option Explicit
DefInt A-Z

Sub doPickBMPcancel (fo As Form)
fo.Hide
Unload fo
End Sub

Sub doPickBMPmain (ByVal udf$)
Dim unit$, subdir$, fileName$
Dim n%

Set fff = frmPickBMP

fff.Hide
fff.Visible = False
fff.AutoRedraw = True
' fff.ControlBox = False
' fff.MaxButton = False
' fff.MinButton = False
' fff.BorderStyle = DOUBLEFIXED
fff.Caption = Title$ + " : Picture selection"
fff.WindowState = Normal

centerform fff

' keep default

newfile$ = udf$

' init a few things

fff!imgPreview.Stretch = True

fff!fileList.Pattern = "*.BMP;*.RLE;*.DIB"
fff!fileList.Normal = True
fff!fileList.Archive = True
fff!fileList.Hidden = True
fff!fileList.System = True

initPreviousDrive ' just in case...

If udf$ = "" Then ' should never happen !
    udf$ = exedir$
Else
    If fileexists(udf$) = False Then udf$ = exedir$ ' unlikely but who knows ?
End If
parseCanonical udf$, unit$, subdir$, fileName$

fff!unitList.Drive = Left$(unit$, 1) ' u from u:
If subdir$ <> "\" Then
    subdir$ = Left$(subdir$, Len(subdir$) - 1)
End If
fff!dirList.Path = subdir$
fff!fileList.Path = subdir$

fileName$ = UCase$(fileName$)
If fileName$ <> "" Then
    For n% = 0 To (fff!fileList.ListCount - 1)
	If UCase$(fff!fileList.List(n%)) = fileName$ Then
	    fff!fileList.ListIndex = n%
	    doPickBMPpreview fff!fileList, fff!imgPreview
	    Exit For
	End If
    Next
End If

fff.Show MODAL

End Sub

Sub doPickBMPok (fo As Form, c As Control)
Dim s$
s$ = getFileFullPath$(c)
If s$ <> "" Then newfile$ = s$

fo.Hide
Unload fo
End Sub

Sub doPickBMPpreview (fl As Control, img As Control)
Dim s$
s$ = getFileFullPath$(fl)
If s$ <> "" Then img.Picture = LoadPicture(s$)
End Sub

