Option Explicit
DefInt A-Z

' awful mix of globerk and parameters passing

Const MINRGB = 0
Const MAXRGB = 255

Const RGBSMALLCHANGE = 1
Const RGBLARGECHANGE = 16

Sub doPickInkCancel (fo As Form)
fo.Hide
Unload fo
End Sub

Sub doPickInkOK (fo As Form)
Dim r%, g%, b%
Dim v&
Dim s$

r% = fo!hbarRed.Value
g% = fo!hbarGreen.Value
b% = fo!hbarBlue.Value
newInk&= RGB(r%, g%, b%)

fo.Hide
Unload fo
End Sub

Sub unpackRGBstring (ByVal s$, r%, g%, b%)
Dim v&
' eh eh, remember that rgb, when in a long, is in fact bgr !
v& = Val(s$)
b% = v& \ 65536          ' &h00##xxxx&
g% = (v& \ 256) Mod 256  ' &h00xx##xx&
r% = v& Mod 256          ' &h00xxxx##&
End Sub

Sub updateRGBsample (c As Control)
Dim r%, g%, b%
r% = fff!hbarRed.Value
g% = fff!hbarGreen.Value
b% = fff!hbarBlue.Value

c.BackColor = RGB(r%, g%, b%)
End Sub

Sub updateRGBvalue (bar As Control, txt As Control, ByVal v%)
Dim s$
If v% < MINRGB Then v% = MINRGB
If v% > MAXRGB Then v% = MAXRGB
bar.Value = v%
s$ = Str$(v%)
s$ = Trim$(s$)
txt.Text = s$
updateRGBsample fff!lblRGBsample
End Sub

Sub doPickInkMain (ByVal savInkRGB&)
Dim c As Control
Dim r%, g%, b%
dim s$

Set fff = frmPickInk

fff.Hide
fff.Visible = False
fff.AutoRedraw = True
' fff.ControlBox = False
' fff.MaxButton = False
' fff.MinButton = False
' fff.BorderStyle = DOUBLEFIXED
fff.Caption = Title$ + " : Color selection"
fff.WindowState = NORMAL

centerform fff

' init values
newInk& = savInkRGB& ' assume unchanged result

s$=str$(newInk&)
s$=trim$(s$)

unpackRGBstring s$, r%, g%, b%

Set c = fff!hbarRed
c.Min = MINRGB
c.Max = MAXRGB
c.SmallChange = RGBSMALLCHANGE
c.LargeChange = RGBLARGECHANGE
c.Value = r%
updateRGBvalue c, fff!txtRed, r%

Set c = fff!hbarGreen
c.Min = MINRGB
c.Max = MAXRGB
c.SmallChange = RGBSMALLCHANGE
c.LargeChange = RGBLARGECHANGE
c.Value = g%
updateRGBvalue c, fff!txtGreen, g%

Set c = fff!hbarBlue
c.Min = MINRGB
c.Max = MAXRGB
c.SmallChange = RGBSMALLCHANGE
c.LargeChange = RGBLARGECHANGE
c.Value = b%
updateRGBvalue c, fff!txtBlue, b%

updateRGBsample fff!lblRGBsample

fff!lblRGBsample.Caption = ""

fff.Show MODAL
End Sub

