'
' part of Q&D Tools QDTOOLS.ZIP archive (c) by PhG
'

Option Explicit
DefInt A-Z

Sub doCompute ()
Dim datetime As Variant
Dim dmy$, hms$
Dim vbjour%
Dim jjindex%, joursemaine$
Dim jj%, mm%, aa%
Dim h%, m%, s%
Dim r$
Dim JDnow#, JDtarget#
Dim v#
Dim zJour#, zMois#, zAnnee#

'Dim inDays#, inHours#, inMinutes#
'Dim i1$, i2$, i3$
'Dim jour$, mois$, annee$
'Dim heures$, minutes$, secondes$
Dim ad%, ah%, am%

ad% = Val(f!txtDay.Text)
ah% = Val(f!txtHour.Text)
am% = Val(f!txtMinute.Text)
If valid(ad%, ah%, am%) Then
    initResults ' should already be done but just in case...

    ' get current date and time
    datetime = Now
    dmy$ = Format$(datetime, "d m yyyy")
    hms$ = Format$(datetime, "h n s")
    vbjour% = Val(Format$(datetime, "w"))' 1=sunday 7=saturday
    jjindex% = vbjour% - 1 ' in vb, sunday = 1, in meeus, sunday = 0

    ' get j/m/a and h:m:s

    jj% = Val(argv$(dmy$, 1))
    mm% = Val(argv$(dmy$, 2))
    aa% = Val(argv$(dmy$, 3))

    h% = Val(argv$(hms$, 1))
    m% = Val(argv$(hms$, 2))

    s% = Val(argv$(hms$, 3)) ' yes, we should round for >30 seconds
    s% = 0

    r$ = fmtNow$(jj%, mm%, aa%, h%, m%, s%, jjindex%)
    f!lblNow.Caption = r$

    filldata ad%, ah%, am%

    ' don't forget to recalc jdnow !
    v# = (m%) / 60#  ' minutes to hours
    v# = (h% + v#) / 24#  ' hours to days
    v# = jj% + v#
    JDnow# = DateToJD#(v#, mm%, aa%)

    ' compute jdnow + delta
    v# = 59 / 60#' seconds to minutes
    v# = (am% + v#) / 60#  ' minutes to hours
    v# = (ah% + v#) / 24#  ' hours to days
    v# = ad% + v#

    JDtarget# = JDnow# + v#

    JDtoDate JDtarget#, zJour#, zMois#, zAnnee#
    jjindex% = JDtoWeekday%(JDtarget#)

    jj% = vint#(zJour#)
    mm% = vint#(zMois#)
    aa% = vint#(zAnnee#)

    zJour# = frac#(zJour#)
    h% = vint#(zJour# * 24#)
    m% = vint#(zJour# * 24# * 60#) Mod 60#
    s% = vint#(zJour# * 24# * 60# * 60#) Mod 60#
    s% = 0

    r$ = fmtNow$(jj%, mm%, aa%, h%, m%, s%, jjindex%)

    f!lblNowPlus.Caption = r$
Else
    f!lblNow.Caption = ""
    f!lblNowPlus.Caption = "Erreur de formulation !"
End If
End Sub

Sub doQuit ()
savePosition f, ini$, sSection$, eXtsr$, eYtsr$
f.Hide
Unload f
End
End Sub

Sub filldata (ByVal d%, ByVal h%, ByVal m%)
f!txtDay.Text = Mid$(Str$(d%), 2)
f!txtHour.Text = Mid$(Str$(h%), 2)
f!txtMinute.Text = Mid$(Str$(m%), 2)
End Sub

Sub initDHM ()
initResults

f!txtDay.Text = ""
f!txtHour.Text = ""
f!txtMinute.Text = ""

f!txtDay.MaxLength = 3 ' 0..999
f!txtHour.MaxLength = 2' 0..23
f!txtMinute.MaxLength = 2' 0..59
End Sub

Sub initResults ()
f!lblNow.Caption = "Bidding, bidding, bidding..."
f!lblNowPlus.Caption = "... Will it ever end ?"
End Sub

Sub main ()
Dim cli$, s$, d%, h%, m%

Set f = frmMain

' If isRunning%() = True Then quit False ' just in case

getDirectories windir$, sysdir$
exedir$ = getEXEpath$()
ini$ = exedir$ + getEXEname$() + INIext$

f.AutoRedraw = True
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = FIXED_SINGLE
f.Caption = caption$
f.WindowState = NORMAL

resetPosition f, ini$, sSection$, eXtsr$, eYtsr$
initDHM

cli$ = Command$
cli$ = UCase$(cli$)

If argc%(cli$) = 3 Then
    s$ = argv$(cli$, 1)
    d% = Val(s$)
    s$ = argv$(cli$, 2)
    h% = Val(s$)
    s$ = argv$(cli$, 3)
    m% = Val(s$)
    filldata d%, h%, m%
    doCompute
End If

f.Show
End Sub

Function valid% (ByVal d%, ByVal h%, ByVal m%)
Dim ok%
ok% = 0
Select Case d%
Case 0 To 999  ' should be enought
    ok% = ok% + 1
End Select
Select Case h%
Case 0 To 23
    ok% = ok% + 1
End Select
Select Case m%
Case 0 To 59
    ok% = ok% + 1
End Select
If ok% = 3 Then
    valid% = True
Else
    valid% = False
End If
End Function
