Option Explicit
DefInt A-Z

Sub doScreenMain ()
Dim i%
Dim xbackground!

Set f = frmScreen

retrieveParameters

If fileExists%(gBackground$) = False Then End
If fileExists%(gPicture$) = False Then End

If gBang% Then gBang% = fileExists%(gBangFile$)
If gGameOver% Then gGameOver% = fileExists%(gGameOverFile$)

lastFrame% = gRows * gColumns% - 1

f.Visible = False
f.AutoRedraw = True
' f.ControlBox = true
' f.MaxButton = False
' f.MinButton = true
' f.BorderStyle = SINGLEFIXED
f.Caption = Title$  ' + " " + culprit$
f.BackColor = gPaper&
f.ScaleMode = PIXELS

f!tmrTimer.Enabled = False

f!picBackground.ScaleMode = PIXELS
f!picBackground.BorderStyle = NONE
f!picBackground.AutoSize = True ' default is false !
f!picBackground.AutoRedraw = True
f!picBackground.Picture = LoadPicture(gBackground$)

Select Case gFullScreen%
Case True ' center animation window
    ' eh eh, values were not updated because form is not shown yet !
    ' let's do it anyway
    xbackground! = (XscreenInPixels% - f!picBackground.Width) / 2
    f!picBackground.Left = XscreenInPixels%
    f!picBackground.Top = (YscreenInPixels% - GetSystemMetrics(SM_CYCAPTION) - f!picBackground.Height) / 2
    f.WindowState = MAXIMIZED
    'f.Height = YscreenInPixels%
    'f.Width = XscreenInPixels%
Case False ' resize form window to animation window
    xbackground! = 0' upper left of form
    f!picBackground.Top = 0
    f!picBackground.Left = f!picBackground.Width
    f.WindowState = NORMAL
    f.Left = gXpos%
    f.Top = gYpos%
    ' resize form to fit picture (warning : should include title bar height !)
    f.Height = screen.TwipsPerPixelY * (f!picBackground.Height + GetSystemMetrics(SM_CYCAPTION))
    f.Width = screen.TwipsPerPixelX * f!picBackground.Width
    If ((gXpos% = dXpos%) And (gYpos% = dYpos%)) Then centerform f
End Select
'f!picSteps.ScaleMode = PIXELS
f!picSteps.Picture = LoadPicture("") ' clear just in case
f!picSteps.Picture = LoadPicture(gPicture$)
f!picSteps.Rows = gRows%
f!picSteps.Cols = gColumns%

For i% = FIRSTSMILEY To LASTSMILEY
    f!picAnimation(i%).ScaleMode = PIXELS
    f!picAnimation(i%).BorderStyle = NONE
    'f!picAnimation(i%).AutoSize = false ' default is false !
    f!picAnimation(i%).AutoRedraw = True
    ' resize animation window to fit BMP
    f!picAnimation(i%).Height = (f!picSteps.Height) / gRows% ' do NOT use \ integer division here !
    f!picAnimation(i%).Width = (f!picSteps.Width) / gColumns% ' ditto
    Select Case gFullScreen%
    Case True
        f!picAnimation(i%).Left = XscreenInPixels%
    Case False
        f!picAnimation(i%).Left = f.Width / screen.TwipsPerPixelX
    End Select
    f!picAnimation(i%).Top = f!picBackground.Top
    ' show animation first step
    f!picAnimation(i%).Picture = f!picSteps.GraphicCell(FIRSTFRAME)
Next

f.Show
': : : MsgBox Str$(f.Left) + "," + Str$(f.Top) + " -- " + Str$(f.Width) + "," + Str$(f.Height)

initStayOnTop f, gAlwaysOnTop%

cursorOFF

' let's bring the XXth century...

gXtarget! = xbackground!
gXposanim! = f!picBackground.Left
gXposanimdelta! = gParadeDeltaX%
If gFaster% = False Then
    ' --- SLOWER BUT PRETTIER CODE
    f!tmrTimer.Enabled = False
    f!tmrTimer.Interval = gParadeSpeed%
    gOVER% = False
    gTIMEREVENT% = BUILDBACKGROUND%
    f!tmrTimer.Enabled = True
    Do While gOVER% = False
        DoEvents
    Loop
Else
    ' --- FASTER BUT UGLIER CODE
    Do While gXposanim! > gXtarget!
        gXposanim! = gXposanim! - gXposanimdelta!
        f!picBackground.Left = gXposanim!
    Loop
    f!picBackground.Left = gXtarget!
End If

' let's bring'em on screen and build 2000 !

For i% = FIRSTSMILEY To LASTSMILEY
    gXtarget! = f!picBackground.Left + f!picBackground.Width * (i% + 1) / 4
    gXposanim! = f!picAnimation(i%).Left
    gXposanimdelta! = gParadeDeltaX%
    gSmiley% = i%
    If gFaster% = False Then
        ' --- SLOWER BUT PRETTIER CODE
        f!tmrTimer.Enabled = False
        f!tmrTimer.Interval = gParadeSpeed%
        gOVER% = False
        gTIMEREVENT% = BUILD2000%
        f!tmrTimer.Enabled = True
        Do While gOVER% = False
            DoEvents
        Loop
    Else
        ' --- FASTER BUT UGLIER CODE
        Do While gXposanim! > gXtarget!
            gXposanim! = gXposanim! - gXposanimdelta!
            f!picAnimation(gSmiley%).Left = gXposanim!
        Loop
        f!picAnimation(gSmiley%).Left = gXtarget!
    End If
Next

' let's pause if required !

If gPauseBefore% > 0 Then
    f!tmrTimer.Enabled = False
    f!tmrTimer.Interval = ONESECOND
    gCountdown% = gPauseBefore%
    gOVER% = False
    gTIMEREVENT% = PAUSEBEFORE%
    f!tmrTimer.Enabled = True
    Do While gOVER% = False
        DoEvents
    Loop
End If

' let's animate'em !

For i% = FIRSTSMILEY To LASTSMILEY
    If gBang% Then playsound gBangFile$
    gSmiley% = i%
    f!tmrTimer.Enabled = False
    f!tmrTimer.Interval = gSpeed%
    gCurrentFrame% = FIRSTFRAME
    gOVER% = False
    gTIMEREVENT% = ANIMATE%
    f!tmrTimer.Enabled = True
    Do While gOVER% = False
        DoEvents
    Loop
Next

' let's hear Game Over if required !

If gGameOver% Then playsound gGameOverFile$

' let's pause if required !

If gPauseAfter% > 0 Then
    f!tmrTimer.Enabled = False
    f!tmrTimer.Interval = ONESECOND
    gCountdown% = gPauseAfter%
    gOVER% = False
    gTIMEREVENT% = PAUSEAFTER%
    f!tmrTimer.Enabled = True
    Do While gOVER% = False
        DoEvents
    Loop
    Unload f
    End
Else
    cursorON
End If
End Sub

Sub doScreenQuit (fo As Form)
cursorON
fo!tmrTimer.Enabled = False
If gBang% Or gGameOver% Then stopSound
If fo.WindowState = NORMAL Then
    savePosition fo, ini$, sSection$, eYpos$, eXpos$
End If

End

End Sub

Sub initStayOnTop (f As Form, ByVal flag%)
Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Dim rc%
Select Case flag%
Case True
    rc% = SetWindowPos%(f.hWnd, HWND_TOPMOST, 0, 0, 0, 0, FLAGS)
Case False
    rc% = SetWindowPos%(f.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, FLAGS)
End Select
End Sub

