Option Explicit
DefInt A-Z

' --- from APIDECS.TXT

' for topmost option : SUB according to VB and Appleman, but FUNCTION according to SDK and Knowledge base !

Declare Function SetWindowPos% Lib "User" (ByVal hWnd%, ByVal hWndInsertAfter%, ByVal X%, ByVal Y%, ByVal cx%, ByVal cy%, ByVal wFlags%)

'--------------------------------------------------------------------
' paramcount = argC% (cli$)

'--------------------------------------------------------------------
' param$ = ArgV$ (cli$, parmnumber) you must take care yourself of case

Function argc% (ByVal cli$)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank ' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
argc% = argCount
End Function

Function argv$ (ByVal cli$, ByVal n)
Const empty = 0
Const intoken = 1
Const instring = 2

Dim quote
Dim blank

Dim cliLen
Dim cliPos
Dim argCount
Dim state
Dim char$
Dim code
Dim arg$

quote = 34
blank = &H20

If n < 1 Or n > argc%(cli$) Then
    argv$ = ""
    Exit Function
End If
cli$ = Trim$(cli$)
cliLen = Len(cli$)
cliPos = 1
argCount = 0
state = empty
Do Until cliPos > cliLen
    char$ = Mid$(cli$, cliPos, 1)
    code = Asc(char$)
    Select Case state
    Case empty
	If n = argCount Then ' argV$ test
	    Exit Do
	End If
	Select Case code
	Case quote
	    state = instring' begin new string
	    arg$ = char$
	    argCount = argCount + 1
	Case Is > blank' quote already trapped
	    state = intoken' begin new token
	    arg$ = char$
	    argCount = argCount + 1
	End Select
    Case intoken
	Select Case code
	Case quote ' quote in token
	    state = instring' if string in parameter
	    arg$ = arg$ + char$
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    state = empty' end of token
	End Select
    Case instring
	Select Case code
	Case quote
	    arg$ = arg$ + char$
	    state = empty' end of string
	Case Is > blank
	    arg$ = arg$ + char$
	Case Else
	    arg$ = arg$ + Chr$(blank)' remove TAB if any
	End Select
    End Select
    cliPos = cliPos + 1
Loop
argv$ = arg$
End Function

Function FilterKey% (ByVal keycode%)
' directly replacing with TAB forces a sound alarm !
' assume tab order is correct
If keycode% = KEY_RETURN Then ' avoid invisible editbox
    SendKeys "{TAB}"
    keycode% = 0 ' disable silly default beep
End If
FilterKey% = keycode%
End Function

Function fixname$ (ByVal org$, ByVal fi$)
If InStr(fi$, ":\") = 0 Then fi$ = org$ + fi$
fixname$ = fi$
End Function

Function fmtInt$ (ByVal v%)
Dim s$
s$ = Str$(v%)
fmtInt$ = Trim$(s$)
End Function

Function fmtSingleReal$ (ByVal v!)
Dim s$
s$ = Str$(v!)
fmtSingleReal$ = Trim$(s$)
End Function

Sub fullselect (c As Control)
Const MAXPATHLENGTH% = 128
c.SelStart = 0
c.SelLength = MAXPATHLENGTH%
End Sub

Function isRunning% ()
Dim rc%
If app.PrevInstance = True Then
    rc% = True
Else
    rc% = False
End If
isRunning% = rc%
End Function

Sub stayOnTop (ByVal hWnd%, ByVal boolean%)
Const Flags = SWP_NOMOVE Or SWP_NOSIZE
Dim rc%
If boolean% Then
    rc% = SetWindowPos%(hWnd%, HWND_TOPMOST, 0, 0, 0, 0, Flags)
Else
    rc% = SetWindowPos%(hWnd%, HWND_NOTOPMOST, 0, 0, 0, 0, Flags)
End If
End Sub

