Option Explicit
DefInt A-Z

Const MAGIC = 42

Function passwordDecrypt$ (ByVal crypted$)
Dim length%
Dim tmp$
Dim i%
Dim p%
Dim c$
Dim v%
Dim plain$

length% = Len(crypted$)

tmp$ = ""
For i% = length% To 1 Step -1
    p% = i% - 1
    c$ = Mid$(crypted$, i%, 1)
    If i% = length% Then
	v% = MAGIC
	c$ = winXOR$(c$, v%)
	v% = 0
    Else
	v% = Asc(Mid$(crypted$, i% + 1, 1))
	c$ = winXOR$(c$, v%)
	v% = p%
    End If
    c$ = winXOR$(c$, v%)
    c$ = winXOR$(c$, length%)
    tmp$ = c$ + tmp$
Next

If length% = 1 Then
    passwordDecrypt$ = tmp$
    Exit Function
End If

plain$ = ""
For i% = 1 To length%
    p% = i% - 1
    c$ = Mid$(tmp$, i%, 1)
    If i% = 1 Then
	v% = MAGIC
	c$ = winXOR$(c$, v%)
	v% = 0
    Else
	v% = Asc(Mid$(tmp$, i% - 1, 1))
	c$ = winXOR$(c$, v%)
	v% = p%
    End If
    c$ = winXOR$(c$, v%)
    c$ = winXOR$(c$, length%)
    plain$ = plain$ + c$
Next
passwordDecrypt$ = plain$
End Function

Function passwordEncrypt$ (ByVal plain$)
Dim length%
Dim tmp$
Dim prev%
Dim i%
Dim p%
Dim c$
Dim v%
Dim crypted$

length% = Len(plain$)

tmp$ = ""
prev% = MAGIC
For i% = 1 To length%
    p% = i% - 1
    c$ = Mid$(plain$, i%, 1)
    c$ = winXOR$(c$, length%)
    If i% = 1 Then
	v% = 0
    Else
	v% = p%
    End If
    c$ = winXOR$(c$, v%)
    c$ = winXOR$(c$, prev%)
    tmp$ = tmp$ + c$
    prev% = Asc(c$)
Next

If length% = 1 Then
    passwordEncrypt$ = tmp$
    Exit Function
End If

crypted$ = ""

prev% = MAGIC
For i% = length% To 1 Step -1
    p% = i% - 1
    c$ = Mid$(tmp$, i%, 1)
    c$ = winXOR$(c$, length%)
    If i% = length% Then
	v% = 0
    Else
	v% = p%
    End If
    c$ = winXOR$(c$, v%)
    c$ = winXOR$(c$, prev%)
    crypted$ = c$ + crypted$
    prev% = Asc(c$)
Next

passwordEncrypt$ = crypted$
End Function

Function winXOR$ (ByVal c$, ByVal v%)
Dim x%
Dim avoid%
Dim r$

x% = Asc(c$) Xor v%

avoid% = True
Select Case x%
Case Is < 33
Case Is > 126
Case 91 ' "["
Case 93 ' "]"
Case 61 ' "="
Case Else
    avoid% = False
End Select

Select Case avoid%
Case False
    r$ = Chr$(x%)
Case True
    r$ = c$
End Select
winXOR$ = r$
End Function

