MODULE chkVGA;

IMPORT Graph,Lib,IO,Str;

FROM IO IMPORT WrStr,WrLn;

PROCEDURE abort (rc:CARDINAL);
BEGIN
    Lib.SetReturnCode(SHORTCARD (rc) );
    HALT;
END abort;

VAR
    vi: Graph.VideoConfig;
    paper:CARDINAL;
    wi,he,hi,lo,x,y:CARDINAL;
    ch:CHAR;
    parmcount : CARDINAL;
    ok:BOOLEAN;
    v:LONGCARD;
    vmode:CARDINAL;
BEGIN
    WrLn;
    parmcount:=Lib.ParamCount();
    IF parmcount # 0 THEN
        WrStr("Check VGA 16 colors");WrLn;
        WrLn;
        WrStr("Syntax : CHKVGA");WrLn;
        WrLn;
        WrStr("In order to exit program, hit the <ESCape> key.");WrLn;
        abort(1);
    END;

    vmode:=Graph._VRES16COLOR;

    Graph.GetVideoConfig(vi);
    IF vi.adapter # Graph._VGA THEN abort(255);END;
    ok:=Graph.SetVideoMode(vmode);
    Graph.GetVideoConfig(vi);

        v:=Graph.SetBkColor(Graph._BLACK);
        Graph.ClearScreen(Graph._GCLEARSCREEN);
        wi:=vi.numxpixels DIV 16;
        he:=vi.numypixels DIV 16;
        paper:=0;
        FOR hi:=0 TO 15 DO
            FOR lo:=0 TO 15 DO
                x:=lo*wi;
                y:=hi*he;
                Graph.Rectangle(x,y,x+wi-1,y+he-1,paper,TRUE );
                INC(paper);
            END;
        END;
        WHILE IO.KeyPressed()=FALSE DO
        END;
        ch:=IO.RdKey();IF ch=CHR(0) THEN ch:=IO.RdKey();END;

        v:=Graph.SetBkColor(Graph._BLACK);
        Graph.ClearScreen(Graph._GCLEARSCREEN);
        wi:=vi.numxpixels DIV 16;
        he:=vi.numypixels DIV 16;
        paper:=0;
            FOR lo:=0 TO 15 DO
                x:=lo*wi;
                y:=vi.numypixels DIV 2;
                Graph.Disc(x,y,wi DIV 3,paper);
                INC(paper);
            END;
        WHILE IO.KeyPressed()=FALSE DO
        END;
        ch:=IO.RdKey();IF ch=CHR(0) THEN ch:=IO.RdKey();END;




    ok:=Graph.SetVideoMode(Graph._DEFAULTMODE);

    abort(0);
END chkVGA.
