(* show XDS lack of "programming decency" *)

MODULE jpiParse;

IMPORT Lib;

FROM IO IMPORT WrStr,WrLn,WrCard;

TYPE
    strtype = ARRAY [0..255] OF CHAR;

CONST
    cr = CHR(13);
    lf = CHR(10);
    nl = cr+lf;
    exe     = "JPIPARSE";
    msgHelp = nl+
              "Note this is "+exe+" executable."+nl+
              nl+
              "Command line parsing is both an essential and an easy task."+nl+
              "Yet, you are for a surprise comparing JPI and XDS results."+nl+
              nl+
              "Among other exemples, try typing "+exe+" with these parameters :"+nl+
              nl+
              '    /p /f /n /x test.exe "g:\z\"'+nl+
              nl+
              "Last parameter, if quoted, seems always corrupt by XDS Lib.ParamStr() function."+nl+
              nl+
              "Never trust anyone for anything ! :-("+nl;
VAR
    i,j:CARDINAL;
    S:strtype;
BEGIN

    IF Lib.ParamCount() = 0 THEN WrStr(msgHelp);HALT;END;

    FOR j:= 1 TO 2 DO
        WrLn;
        FOR i:= 1 TO Lib.ParamCount() DO
            Lib.ParamStr(S,i);
            WrCard(i,4);
            CASE j OF
            | 1 : WrStr(" (raw)    : ");WrStr(S);
            | 2 : WrStr(' (quoted) : "');WrStr(S);WrStr('"');
            END;
            WrLn;
        END;
    END;

    HALT;
END jpiParse.

